{-# LANGUAGE MultiParamTypeClasses #-}
-- {-# LANGUAGE UndecidableInstances #-}
{-# LANGUAGE FlexibleInstances #-}

module Data.Convertible
	( Convertible(..)
	, convert
	) where

-- import Control.Monad

class Convertible b a where
	safeConvert :: a -> Either () b

convert :: Convertible b a => a -> b
convert a = case safeConvert a of
	Right b -> b
	_ -> error "conversion failed"

{-
{- this instance is a problem b/c we could have multiple instances providing different paths:
	instance Convertible Foo Bar where
	instance Convertible Foo Baz where
	instance Convertible Baz Quux where
	instance Convertible Bar Quux where
and then there's no way to decide whether to make the
	instance Convertible Foo Quux instance using the Bar or the Baz instances. or i might have these instances backwards, w/e. also, since we _do_ want 1. one type to be converted to many other types and 2. many types being converted to one other type, we can't put any fundeps on here to make it work
-}
instance (Convertible b a, Convertible c b) => Convertible c a where
	safeConvert = (safeConvert :: b -> Either () c) <=< (safeConvert :: a -> Either () b)
-}
instance Convertible b a => Convertible [b] a where
	safeConvert = fmap pure . safeConvert
