module Description.Body.Types.Material
	( Covering(..)
	, FullMat(..)
	, MatAttr(..)
	, mat
	, attr
	, matword
	, mattrword
	, mattrString
	, matcolor
	, Material(..)

	, BlocStore(..)
	, BodyLocation(..)
	, BodyTransLocation(..)
	, Hind(..)

	, BodyLocatable(..)
	, BodyCovering(..)
	) where

import Prelude hiding (head, tail)

import Control.Lens (Lens')

data Covering a = Covering
	{ head :: Maybe a
	, chest :: a
	, arms :: Maybe a
	, legs :: Maybe a
	, tail :: Maybe a
	, wings :: Maybe a
	, genitalia :: Maybe a
	}
	deriving (Eq, Ord, Show, Read)

instance Functor Covering where
	fmap f (Covering head chest arms legs tail wings genitalia) =
		Covering (f <$> head) (f chest) (f <$> arms) (f <$> legs) (f <$> tail) (f <$> wings) (f <$> genitalia)

instance Applicative Covering where
	pure a = Covering (Just a) a (Just a) (Just a) (Just a) (Just a) (Just a)
	(Covering fmh fb fma fml fmt fmw fmg) <*> (Covering vmh vb vma vml vmt vmw vmg) =
		Covering (fmh <*> vmh) (fb vb) (fma <*> vma) (fml <*> vml) (fmt <*> vmt) (fmw <*> vmw) (fmg <*> vmg)


data FullMat = FMat MatAttr Material
	deriving (Eq, Ord, Show, Read)

mat :: Lens' FullMat Material
mat f (FMat a m) = (\m' -> FMat a m') <$> f m

attr :: Lens' FullMat MatAttr
attr f (FMat a m) = (\a' -> FMat a' m) <$> f a

data MatAttr
	-- attrs that are just colors
	= RuddyRedBrown -- Skin, Human
	| Brown -- default horn color
	| Golden -- Fur, Lion
	| White -- Feathers, Bird
	| Black -- Feathers, Raven
	| PalePink -- goat dick
	| Ebony -- unicorn dick
	| RichPurple -- bull dick
	| Pink -- lion, tiger, bird, bat, boar dick
	| PurpleBlack -- scorpion & spider dick
	| GreyBlack -- ichorous dick
	| PallidGrey -- ichor skin
	| DullGrey -- ichor scales & feathers
	| BrilliantRed -- fire on flame/protoplasm
	| StarryNebula -- stellar on skin, faceless void (technically)
	| BlackWithGlowingTips -- stellar on fur/coat/scales/feathers

	-- attrs that include tactile info
	| CoarseGrey -- Fur, Wolf
	| CoarseBrown -- Fur, Goat
	| StiffGrey -- Coat, Bull
	| FuzzyBlack -- Chitin, Spider
	| BristlyBrown -- Coat, Boar
	| OilyBlack -- ichor fur
	| RoughBlackGlyphEnscribed -- various metal/armor parts
	| IcyPaleBlue -- frost on fur/scales/etc
	| SnowyPureWhite -- frost on skin
	| GlowingWhite -- stellar horns
	| GlowingRedHot -- fire dicks
	-- attrs that include a pattern as well as colors
	| DappledBrownAndTan -- Coat, Deer
	| StripedOrangeBlack -- Fur, Tiger
	| PatternedGreenYellow -- Scales, Snake
	| MottledPinkAndBrown -- horse dick
	| MottledPurple -- dragon dick
	| BlotchyPurple -- fish & snake dick
	-- attrs that include other glosses
	| ShiningBrown -- Coat, Horse
	| GemlikeRed -- Scales, Dragon
	| ShiningSilver -- Coat, Unicorn
	| ShiningBlack -- Chitin, Scorpion
	| ShortGrey -- Fur, Bat
	| ShiningBlue -- Scales, Fish
	| Fiery -- fire on fur, coat, skin
	| ScintilatingOrangeRed -- fire on scales
	| LavaPatterned -- fire horns
	| RoughCrystalGrowth -- [gem] on skin/fur/etc
	| TranslucentPurple
	| TranslucentGlowing
--	| MottledColorChanging -- octopus skin/dick

	| BloodyRed -- wolf dick
	| RawRed -- deer dick

	| Nil -- Protoplasm, N/A

	deriving (Eq, Ord, Enum, Bounded, Show, Read)

data Material
	= Protoplasm
	| Skin | Fur | Scales | Coat | Chitin | Feathers
	| Flesh -- for sheathed/internal cocks
	| Hide | Hair | Horn
	| Hoof
	| Flame | Bone | Crystal | Metal | Armor | Space
	| BurntWood | WroughtIron | Rock
	deriving (Eq, Ord, Enum, Bounded, Show, Read)

data BodyLocation
	= Head | Chest | Arms | Legs | Tail | Wings | Genitals
	deriving (Eq, Ord, Enum, Bounded, Show, Read)

data BodyTransLocation
	= Neck | Waist Hind | Shoulders | Crotch | Back | LowerBack
	-- | Wrist | Ankle (uh but we don't have hand/foot locations, so...)
	deriving (Eq, Ord, Show, Read)

data Hind = Fore | Hind
	deriving (Eq, Ord, Enum, Bounded, Show, Read)

data BlocStore = Bas BodyLocation | Tra BodyTransLocation
	deriving (Eq, Ord, Show, Read)

class BodyLocatable b where
	loc :: b -> BlocStore

instance BodyLocatable BodyLocation where
	loc = Bas

instance BodyLocatable BodyTransLocation where
	loc = Tra

data BodyCovering
	= Solid FullMat
	| Trans FullMat FullMat
	deriving (Eq, Ord, Show, Read)

matword :: Material -> String
matword m = case m of
	Skin -> "skin"
	Feathers -> "feathers"
	Scales -> "scales"
	Fur -> "fur"
	Protoplasm -> "protoplasm"
	Coat -> "coat"
	Chitin -> "chitin"
	Hide -> "hide"
	Flesh -> "flesh"
	Horn -> "horn"

	-- exotic materials that don't necessary have good one-word summaries
	Metal -> "metal" -- armor?? helmet?
	Armor -> "armor"
	Flame -> "flame"
	Rock -> "rock"
	Bone -> "bones"
	Crystal -> "crystal"
	Space -> "space"
	BurntWood -> "burnt wood" -- if this ever gets output there is a problem V:
	WroughtIron -> "wrought iron" -- ditto

	-- these are less reasonable materials imo
	Hair -> "hair"
	Hoof -> "hoof"

matcolor :: BodyCovering -> String
matcolor (Solid (FMat c _)) = mattrword c
matcolor (Trans (FMat c _) (FMat c' _)) = mattrword c ++ " shading into " ++ mattrword c'

mattrString :: MatAttr -> String -> String
mattrString x = case x of
	BlackWithGlowingTips -> \s -> unwords
		["black", s, "with glowing tips"]
	LavaPatterned -> \s -> unwords
		["black", s, "threaded through with glowing veins of lava"]
	StarryNebula -> \s -> unwords
		[s, "patterned as a starry nebula"]
	RoughCrystalGrowth -> \s -> unwords
		[s, "covered in rough crystal spikes"]
	mattr -> \s -> (mattrword mattr) ++ ' ' : s

mattrword :: MatAttr -> String
mattrword x = case x of
	RuddyRedBrown -> "ruddy red-brown"
	Brown -> "brown"
	CoarseGrey -> "coarse grey"
	DappledBrownAndTan -> "dappled brown and tan"
	CoarseBrown -> "coarse brown"
	StiffGrey -> "stiff grey"
	ShiningBrown -> "shining brown"
	Golden -> "golden"
	StripedOrangeBlack -> "orange and black striped"
	GemlikeRed -> "burnished red"
	ShiningSilver -> "shining silver"
	ShiningBlack -> "shining black"
	FuzzyBlack -> "fuzzy black"
	White -> "white"
	Black -> "black"
	ShortGrey -> "short grey"
	BristlyBrown -> "bristly brown"
	ShiningBlue -> "shining blue"
	PatternedGreenYellow -> "patterned green and yellow"
	Nil -> "colorless"
	IcyPaleBlue -> "icy blue"
	SnowyPureWhite -> "pure white"

	PalePink -> "pale pink"
	Ebony -> "pure ebony"
	BloodyRed -> "bloody red"
	RawRed -> "raw red"
	RichPurple -> "rich purple"
	MottledPinkAndBrown -> "mottled pink and brown"-- horse dick
	Pink -> "pink"
	MottledPurple -> "mottled purple"
	PurpleBlack -> "purple-black"
	BlotchyPurple -> "blotchy purple"
	TranslucentPurple -> "translucent purple"
	GreyBlack -> "bruised-looking grey-black"

	PallidGrey -> "pallid grey"
	DullGrey -> "dull grey"
	OilyBlack -> "oily black"

	Fiery -> "fiery"
	ScintilatingOrangeRed -> "scintillating orange-red"
	BrilliantRed -> "brilliant red"
	GlowingRedHot -> "glowing red-hot"
	LavaPatterned -> "black and threaded through with glowing veins of lava"

	RoughCrystalGrowth -> "covered in spiky crystal growth"
	RoughBlackGlyphEnscribed -> "rough black"
	BlackWithGlowingTips -> "black with glowing tips"
	StarryNebula -> "patterned as a starry nebula"

	GlowingWhite -> "glowing white"
	TranslucentGlowing -> "translucent, glowing"
