module Description.Pronoun
  ( Pronoun (..)
  , Gender (..)
  , pronoun
  , plural
  , pluralize
  ) where

--             he   his   he's   his    him   himself
--            she   her  she's   hers   her   herself
--            you  your   you   yours   you   yourself
--           they their   they theirs  them   themself
--             it   its   it's   its    it    itself
data Pronoun = E | Eir | E' | Eirs | Em | Emself | PlurFrag String String
	deriving (Eq, Ord, Show, Read)
data Gender
	= I | You | He | She | They | It
	| GenderCustom String String String String String Bool
	deriving (Eq, Ord, Show, Read)

pronoun :: Gender -> Pronoun -> String
pronoun g E = case g of
	I -> "i"
	He -> "he"
	She -> "she"
	They -> "they"
	It -> "it"
	You -> "you"
	GenderCustom x _ _ _ _ _ -> x
pronoun g Eir = case g of
	I -> "my"
	He -> "his"
	She -> "her"
	They -> "their"
	It -> "its"
	You -> "your"
	GenderCustom _ x _ _ _ _ -> x
pronoun g E' = case g of
	I -> "i"
	He -> "he's"
	She -> "she's"
	They -> "they"
	It -> "it's"
	You -> "you"
	GenderCustom x _ _ _ _ p -> if p then x else x ++ "'s"
pronoun g Eirs = case g of
	I -> "my"
	He -> "his"
	She -> "hers"
	They -> "theirs"
	It -> "its"
	You -> "yours"
	GenderCustom _ _ x _ _ _ -> x
pronoun g Em = case g of
	I -> "me"
	He -> "him"
	She -> "her"
	They -> "them"
	It -> "it"
	You -> "you"
	GenderCustom _ _ _ x _ _ -> x
pronoun g Emself = case g of
	I -> "myself"
	He -> "himself"
	She -> "herself"
	They -> "themselves"
	It -> "itself"
	You -> "yourself"
	GenderCustom _ _ _ _ x _ -> x
pronoun g (PlurFrag sing plur) = if plural g then plur else sing

plural :: Gender -> Bool
plural g = case g of
	I -> False
	You -> True
	He -> False
	She -> False
	They -> True
	It -> False
	(GenderCustom _ _ _ _ _ p) -> p

pluralize :: a -> a -> Gender -> a
pluralize sing plur p = if plural p then plur else sing
