{-# LANGUAGE MultiParamTypeClasses #-}
module Sites.Hell.Events.Hubur.Asakku
	( Asakku(..)

	, Index
	
	, deck
	, scene

	, name
	, bits
	, variants
	) where

import Prelude hiding ((/), (^))

import Sites.Hell.Events.SceneUtils hiding ((/))
import Sites.Hell.Events.Construction ((/))

import Sites.Hell.Events.Hubur

name :: String
name = "asakku"

data Asakku = Asakku
	deriving (Eq, Ord, Show, Read)

instance Random Asakku where
	randomR _ = random
	random = getRand $ pure Asakku

instance ToJSON Asakku where
	toJSON Asakku = object
		[ pack "name" .= name
		, pack "data" .= ([] :: [Int])
		]

bits :: Value -> Value
bits _ = object
	[ pack "name" .= name
	, pack "data" .= ([] :: [Int])
	]

variants :: [(MapZone, ())]
variants =
	[ (Glade, ())
	, (Field, ())
	]

instance FromJSON Asakku where
	parseJSON (Object vs) = case (parse (.: pack "name") vs, parse (.: pack "data") vs :: Result [Int]) of
			(Success pName, Success [])
				| pName == name -> return Asakku
			_ -> mzero
	parseJSON _ = mzero

deck :: RandomGen g => Rand g (Enumerable Asakku)
deck = return . pure $ Asakku

data Index = Dummy
	deriving (Eq, Ord, Show, Read)

instance Scene Index () Asakku where
	link f = case f of
		_ -> error "bad link"

	display = fmap toLower . show
	vardisplay = fmap toLower . show

scene :: Encounter Index () Asakku
scene b z = describe b z -- <> error "bad scene"

--- actual event start

describe :: Encounter Index () Asakku
describe _ z =
	[ Narration2 $ "You come across an Asakku."
		/ Paragraph / "He's a giant of a man, who would tower head-and-shoulders over the average human. He's muscular, with a bloated belly. His skin is leathery and callused all over, almost rhino-like in its heavy, stiff layers. His hide peaks up into blunt horns across his shoulders, down his back, and across his forearms. His skin thickens even further at his hands and feet, grey-brown hide turning mottled black, and his nails are dusty black talons."
		/ Paragraph / "His face is a mess, with sharp horns bursting out from his brows, eye sockets, cheeks; it's impossible to tell if he ever had eyes or nose, or if they're simply lost in the gnarled growth. His mouth is a mess of jagged, snarled tusks. His head and hands are wreathed in a pale, rippling fire that billows up like candle flames."
	]
