{-# LANGUAGE MultiParamTypeClasses #-}

module Sites.Hell.Events.Hubur.Bubbles
	( Bubbles(..)
	, deck
	, scene

	, name
	, bits
	, variants
	) where

import Sites.Hell.Events.SceneUtils hiding (Material(..))

import Sites.Hell.Events.Hubur

name :: String
name = "bubbles"

data Bubbles = Bubbles
	deriving (Eq, Ord, Enum, Bounded, Show, Read)

instance Random Bubbles where
	randomR _ = random
	random = (`runRand` genRandom)

instance ToJSON Bubbles where
	toJSON d = object
		[ pack "name" .= name
		, pack "data" .= ([] :: [Int])
		]

bits :: Value -> Value
bits _ = object
	[ pack "name" .= name
	, pack "data" .= ([] :: [Int])
	]

variants :: [(MapZone, ())]
variants =
	[ (Shallows, ())
	]

instance FromJSON Bubbles where
	parseJSON (Object vs) = case (parse (.: pack "name") vs, parse (.: pack "data") vs :: Result [Int]) of
			(Success pName, Success [])
				| pName == name -> return Bubbles
			_ -> mzero
	parseJSON _ = mzero

deck :: RandomGen g => Rand g (Enumerable Bubbles)
deck = return $ pure $ Bubbles

instance Scene () () Bubbles where
	link _ = error "link"
	display = fmap toLower . show
	vardisplay = fmap toLower . show

scene :: Encounter () () Bubbles
scene _ d = case d of
	Bubbles ->
		[ Narration2 $ c "Froth churns at the surface of the river, bubbling up from beneath."
		]
