{-# LANGUAGE ViewPatterns #-}
{-# LANGUAGE FlexibleContexts #-}
{-# LANGUAGE MultiParamTypeClasses #-}

module Sites.Hell.Events.Hubur.ClayMan
	( ClayMan
	, deck
	, description
	, scene

	, name
	, bits
	, variants
	) where

import Prelude hiding ((/), (^))

import Data.Maybe (catMaybes)

-- import Utility.Tuple
import Server.JSON
import Utility.Rand
import Sites.Hell.Events.GameEvent (materialWord, animalAss)
import Sites.Hell.Events.SceneUtils hiding ((/))
import Sites.Hell.Events.Construction ((/), (^))

import Sites.Hell.Events.Hubur

import Description.TfNode (Animal(..))
import Description.Build hiding (Dick)
import Description.Body.Sample hiding ((?), animalAss, feet, hands, Dick)

{- todo:

* code check

* closing scene / dialog
-}

-- no variants :V
-- ha ha clay man that's got grass/crops growing on him like hair
-- driftwood lodged in him?
-- tarpit version? for the tarpit/quarry.

name :: String
name = "clayman"

data ClayMan = ClayMan
	deriving (Eq, Show)

instance Random ClayMan where
	randomR _ = random
	random = getRand $ return ClayMan

instance ToJSON ClayMan where
	toJSON ClayMan = object
		[ pack "name" .= name
		, pack "data" .= ([] :: [Int])
		]

bits :: Value -> Value
bits _ = object
	[ pack "name" .= name
	, pack "data" .= ([] :: [Int])
	]

variants :: [(MapZone, ())]
variants =
	[ (Mudfield, ())
	]

instance FromJSON ClayMan where
	parseJSON (Object vs) = case (parse (.: pack "name") vs, parse (.: pack "data") vs :: Result [Int]) of
			(Success pName, Success [])
				| pName == name ->
				case pure ClayMan of
						Nothing -> mzero
						Just h -> return h
			_ -> mzero
	parseJSON _ = mzero

deck :: RandomGen g => Rand g (Enumerable ClayMan)
deck = return $ pure $ ClayMan

data Index
	= Opening | OpeningChoices
	| Talk | Leave
	| FuckOpening | FuckAggressive | FuckPassive
	| FuckDeepthroat
	| InflationFuck | InflationSpitroast | InflationMouth
	deriving (Eq, Ord, Enum, Bounded, Show)

instance Scene Index () ClayMan where
	link x = case x of
		Opening -> scene
		OpeningChoices -> openingChoices
		Talk -> talk
		Leave -> leave
		FuckOpening -> fuckOpening
		FuckAggressive -> fuckAggroBranch
		FuckPassive -> fuckPassiveOpening
		FuckDeepthroat -> fuckDeepthroat
		InflationSpitroast -> inflationSpitroast
		InflationMouth -> inflationMouth
		InflationFuck -> inflationFuck
	display = fmap toLower . show
	vardisplay = fmap toLower . show

description :: ClayMan -> Event ClayMan Index ()
description _ = Narration2 $
	"The clay shifts and stirs, and for a moment it seems as if some slumbering creature is about to break through the surface. The clay itself is moving: pulling itself upright, thick slabs cracking until they become saturated with river water, slick and ready to be worked. River water pours into the seams between slabs, raw red clay becoming covered in slip as the clay builds itself a body. It takes the form of a man, body thick, fat gut a smooth swell of dripping clay, muscles smeared, no sharp detail possible in the constantly-shifting mess of clay slip. He surges up from the bank, waist flaring out to a massive upwell of fresh clay, blending into the rest of the shore in dripping waves."
	/ Paragraph / "His face is vague: heavy brows, eyepits, a nose, thick wedges of ears, twin curves of teeth in a mouth that seals over when not in use. Clay drips down his head like hair soaked to the skin, thick tufts and clumps slowly breaking apart and sluicing down his sides. The clay is a brilliant purplish umber, silty ochre on the surface, and bands of color continually marble and mix through him."

dialog :: Convertible a EventReel => ClayMan -> a -> Event ClayMan Index ()
dialog _ = Dialog2 "/static/img/icon.png" "Clay Man" . convert

scene :: MarkedScene Index () ClayMan
scene b c =
	[ SetFlag (Global MetClayMan) 1
	, description c
	] <> opening b c

opening :: MarkedScene Index () ClayMan
opening b c =
	[ Narration
		[ "The clay man raises a hand in greeting, slip dripping down from his hand to his elbow continually."
		]
	, Dialog "/static/img/icon.png" "Clay Man"
		[ "Hey there, mortal."
		, "Not so often we see your kind out and about in hell."
		, "What's up?"
		]
	] <> openingChoices b c

openingChoices :: MarkedScene Index () ClayMan
openingChoices b c =
	[ Choices
		[ ("{talk}", Talk)
		, ("hey you wanna fuck", FuckOpening)
		, ("just passing through bye", Leave)
		]
	]

leave :: MarkedScene Index () ClayMan
leave b c =
	[ Dialog "/static/img/icon.png" "Clay Man"
		[ "Well alright then."
		, "We might see you again if you pass through this way, I guess."
		]
	, Narration
		[ "You keep going."
		]
	]

talk :: MarkedScene Index () ClayMan
talk b c =
	[ Narration
		[ "{talk options here}"
		]
	, Choices
		[ ("<==", OpeningChoices)
		]
	]

fuckOpening :: MarkedScene Index () ClayMan
fuckOpening b c = case locoplan b of
	x
		| x `elem` [Spec Orb, Spec FloatingHead, Spec FloatingDick, Basic Formless, Basic Complex] -> fuckRejection b c
	_ ->
		[ Narration
			[ "He approaches, vaguely-defined blobs of thighs surfacing as he undulates closer. He shapes his body more clearly, wide hips, fat belly, vague musculature across his shoulders and arms, all formed by invisible hands. A cock peels away from his heavy gut: a heavy mass of clay, fat and long. Veins crawl up its length, pumping as they feed more and more clay, and the growing cock sloughs down, forming a bend in the shaft, weighed down nearly to crumbling by its own fat weight. The tip opens, slit gaping, and the clay-man groans, head thrown back as it pumps, gushing a flood of watery slip out onto the clay bank between you."
			, "The clay itself churns, vague tremors shuddering beneath you, a sluggish current of clay spilling towards him in a vast circle, adding more bulk to his form."
			]
		-- TODO: limit by having dick? is this definitely what we want? fisting a mess of clay would be kinda weird
		, Choices $ catMaybes
			[ guardC (hasDick b) $ ("get over there and fuck him", FuckAggressive)
			, pure ("\"hey get over here and fuck me\"", FuckPassive)
			]
		]


fuckRejection :: MarkedScene Index () ClayMan
fuckRejection b c =
	[ Dialog "/static/img/icon.png" "Clay Man"
		[ "Y'know I'd love to but c'mon, there's only so much we can do with a floating " <> bodynoun <> "."
		, "Sorry!"
		]
	, FauxChoice "wow fine bye"
	, Dialog "/static/img/icon.png" "Clay Man"
		[ "Come back when you got an actual body and we can fuck, though!"
		]
	]
	where
		bodynoun = case locoplan b of
			Spec Orb -> "orb"
			Spec FloatingDick -> "cock"
			Spec FloatingHead -> "head"
			_ -> "lump"

fuckAggroBranch :: MarkedScene Index () ClayMan
fuckAggroBranch b c = case locoplan b of
	Basic Biped -> fuckAggroBiped b c
	Basic Centaur -> fuckAggroQuadTaur b c
	Basic Quadruped -> fuckAggroQuadTaur b c
	Basic Slithering -> fuckAggroBiped b c
	Basic Naga -> fuckAggroBiped b c
	-- Basic Wyvern -> bodyFail FuckAggressive $ Basic Wyvern
	f -> bodyFail FuckAggressive f

-- TODO: this seems to imply a slithering branch where you just tunnel back and forth through his body to fuck him. this would be the dickless variant / optional choice if you have a dick
fuckAggroBiped :: MarkedScene Index () ClayMan
fuckAggroBiped b cl =
	[ Narration2 $
		"You" / case locoplan b of
			Basic Naga -> "slither"
			Basic Slithering -> "slither"
			Basic Biped -> "step "
			f -> bodyFail FuckAggressive f
		/ "forward, " / case locoplan b of
			Basic Naga -> c "underbelly cutting a deep trench through the soft clay as you approach"
			Basic Slithering -> c "body cutting a deep trench through the soft clay as you approach"
			Basic Biped -> feet / "sinking inches into the thick mire before they hit anything solid enough to walk on"
			f -> bodyFail FuckAggressive f
		/ ". The clay man leers, hands rising from the churning mess, "
		/ case locoplan b of
			Basic Naga -> "cold clay stroking"
				/ case bodyMat_ (Waist Fore) b of
					Solid (FMat _ Scales) -> "over your scales"
					Solid (FMat _ Protoplasm) -> "over your waist, your rubbery protoplasm hardly more solid than the clay"
					_ -> "over your waist"
				/ ", smearing across your lower body, "
			Basic Slithering -> c "and stroking all down your sides, dozens upon dozens of hands reaching out from the muck"
			Basic Biped -> "cold clay stroking along your legs, reaching up your" / partAdjective Thighs / "thighs"
			f -> bodyFail FuckAggressive f
		-- cocks
		/ case dickLocation b of
			Just DickExternal -> c ", stroking the length of your cock"
			Just DickSheathed -> ", curling around your" / partAdjective Sheath / "sheath"
			Just _ -> c ", fingers sliding over your flushed vent"
			Nothing -> mempty
		/ "."
		/ Paragraph / "He's kneeling, hand stroking and squeezing along his cock, more a suggestion of movement than anything clear through the sloppy mess of clay drooling down his fat gut. His balls rest in the clay below, half-surfaced, gigantic orbs squelching across his thighs."
		/ Paragraph / case locoplan b of
			Basic Slithering ->
				"You slither up in front of him and then around, looping your coils around his body, your" / materialWord Chest / "digging into the wet, soft flesh of his body, making it bulge out around your coils. You pin his cock to his stomach, half-smearing the two together, and he groans and shifts forward, gut digging into your underbelly"
				/ hasDick ? (
					", bearing down against your"
					/ case dickLocation b of
						Just DickExternal -> "hanging" / Cock^s
						Just DickSheathed -> c "swollen sheath"
						Just _ -> c "flushed vent"
						f -> bodyFail FuckAggressive f)
				/ "."
			_ ->
				case locoplan b of
					Basic Biped -> "You kneel before him, matching his pose, "
					Basic Naga -> "You slither up in front of him, "
					f -> bodyFail FuckAggressive f
				/ "reaching out to feel across the fat ball of his gut. His clay is soft and slippery, squelching under your" / fingertips / "; you leave furrows in his flesh as you trail down his belly, ones that seal themselves over in seconds from the flow of fresh slip continually cascading down his body. You roll your knuckles over his cock, and he groans and shifts forward, gut pressing against your stomach, "
				/ hasDick ? "his cock and yours" ?: "his cock"
				/ "sandwiched between your bodies."
		/ Paragraph / case locoplan b of
			Basic Slithering -> "You tip him onto his back, trapping some of your coils in tunnels through the clay as his back merges with the clay field."
			_ -> "You push him back and he goes, rolling onto his back, cock warping and nearly bending in half before he tugs it up with him, smearing it against his gut."
		/ "He lies back, legs surfacing as thick lumps, a vee leading towards his ass. His huge balls just jostle, half-formed shapes tugging and stirring as he settles back into the clay mire. "
		/ case locoplan b of
			Basic Slithering -> "He tugs his balls out of the way -- an illusory motion, scooping up mounds of clay that reform into his balls, draping them over his thigh."
			_ -> "You tug his balls out of the way -- an illusory motion, scooping up mounds of clay that reform into his balls, draping them over his thigh."
		/ Paragraph / "His cock skews towards his thigh, hitting it with a wet slap and sticking, dribbling slip down into the mess of his ass. You"
		/ case locoplan b of
			Basic Biped -> "press"
			Basic Naga -> "slide"
			Basic Slithering -> "slide"
			f -> bodyFail FuckAggressive f
		/ "forward, cockhead tapping against the curve of his cheeks before you push between them, cool slick clay wrapping around your" / partAdjective Cockhead / "cockhead and clenching, sucking, on the tip. He groans, cock shuddering across his belly, spurting out spumes of thin slip, black water cascading over his chest as you thrust in, his body molding itself around your cock. He clenches around you, pre building up inside him, thinning his clay, and flooding the sloppy tunnel of his ass, squirting out around your shaft when you hilt inside."
	-- this is mostly shared w/ the quad/centaur bit
		/ Paragraph / "You're a mess, nearly every inch painted in umber and sienna, "
		/ case bodyMat_ Chest b of
			Solid (FMat _ Fur) -> "turning your fur into a mess of tangled, clay-streaked clumps"
			Solid (FMat _ Coat) -> "soaking your coat to your skin"
			_ -> "dripping down in half-motile streams"
		/ ", conjoining together to half-form hands and mouths, pressed all across your sides. Each thrust sprays hot clay across "
		/ case locoplan b of
			Basic Biped -> "your" / partAdjective Thighs / "thighs, and the clay man reaches up through them, "
			Basic Naga -> c "your underbelly, and the clay man reaches up along it, "
			Basic Slithering -> c "your underbelly, and the clay man reaches up along it, "
			f -> bodyFail FuckAggressive f
		/ "tongues and fingers teasing your cock. You thrust hard, cock slamming deep, "
		/ case dickLocation b of
			Just DickSheathed -> "sheath pressed against and then into the wet, sloppy furl of his ass, "
			Just DickExternal -> "the base of your cock grinding against the wet, sloppy furl of his ass, "
			Just _ -> "vent slapping against his clay flesh, "
			f -> bodyFail FuckAggressive f
		/ "and the clay man groans. His body's half-dissolved, all runny and smeared out, and he grunts and groans from the impact of each of your thrusts. Your pre floods through him, smearing him out until you're mostly fucking a shifting lump, "
		/ case locoplan b of
			Basic Slithering -> "your coils sawing through his soft flesh as you squeeze tighter, "
			_ -> mempty
		/ "arms and legs and cocks bubbling to the surface only to smear apart again as you pulverize him, thrusts coming hard and fast. "
		/ hasExternalBalls ? ("Your balls crash into the soft clay surface, leaving craters that flood with slimy slip, splattering up across your"
			/ case locoplan b of
				Basic Naga -> "underbelly"
				Basic Slithering -> "underbelly"
				_ -> "ass"
			/ "when you thrust again.")
		/ Paragraph / "Heat travels up your spine, the slick softness of his clay guts stroking you off. You groan, thrusting faster, cock plowing furrows through his distended body, until you come with a roar. "
		/ hasExternalBalls
			? "Your balls twitch, dragging themself tight against your shaft, squelching with each motion against the clay-man's body, "
			?: "Your internal balls clench, becoming a throbbing pressure inside you as you thrust, each motion squelching against the clay-man's body, "
		/ case locoplan b of
			Basic Biped -> "your legs "
			Basic Naga -> "the whole length of your tail "
			Basic Slithering -> "your entire body "
			f -> bodyFail FuckAggressive f
		/ "splattered with clay."
		, analComeshot b cl
	] <> fuckAggroAnalCloser b cl

fuckAggroQuadTaur :: MarkedScene Index () ClayMan
fuckAggroQuadTaur b cl =
	[ Narration
		[ "You reach him and keep going, grinding his face against your underbelly, pushing him backwards until he topples onto his back, sprawled in the mud. You grind your cock against his gut, soft clay distending in a sloppy trench. You gush pre, fluid being sucked up into his body, slickening your thrusts."
		]
	, dialog cl $ "Here,"
	, Narration2 $
		"The clay man shifts, raising a leg -- a lump of clay feigning being a leg -- and twisting, his oversized cock slapping across your underbelly as he shows his ass, hands dug into his fat cheeks, spreading them to reveal the spasming hole between them, a mess of clay twisting around itself in sluggish lurches, like he's got a whirlpool for an asshole."
		/ Paragraph / "You take a half-step back -- " / feet / "stuck in the mud, pulling away with half-formed hands groping up your" / ankles / " -- and slide back until your cockhead slaps between his cheeks, a spume of black water splattering your underbelly. His asshole pulses, twisting and opening, all but reaching out and pulling your cock inside it itself. You" / groan / ", cock shuddering, splattering another gush of pre all up across his belly, his clay skin sucking and slurping as it drinks up the fluid. You thrust forward, cock sinking nearly effortlessly into him, clay dense and oddly cool against your heated flesh, but it traps the heat, warming rapidly."
		/ Paragraph / "He groans, clay flattening as he strains up, cock bloating wider as it smears against your underbelly. You" / groan / "again and shove forward, "
		/ case firstOf [Barbs, Medial, Knotted] dickAttrs b of
			Just Medial -> "medial ring plunging into him, "
			Just Knotted -> "half-swollen knot jabbing against his hole and then simply hollowing his ass wider, "
			Just Barbs -> "barbs sawing through his clay flesh and instantly gumming up with the thick clumps of clay they smear off of him, your cock"
			_ -> mempty
		/ "carving through him and into the clay bed beneath. Or -- carving through the part of him he's shaped to look like a person, and into the rest. He clenches around you, pre building up in bubbling pockets, each thrust sending a gush of pre-thinned slip gushing up across your underbelly"
		/ case dickLocation b of
			Just DickSheathed -> ", coating your sheath"/ hasExternalBalls ? "and balls"/ "in rich sienna slop"
			Just DickExternal -> mempty
			Just _ -> c ", slopping into your gaping cloaca and gurgling out as you keep thrusting"
			f -> bodyFail FuckAggressive f
		/ "."
		/ Paragraph / "You're a mess, nearly every inch painted in umber and sienna, dripping down in half-motile streams, conjoining together to half-form hands and mouths, pressed all across your sides. Each thrust sprays hot clay across your flanks, and the clay man reaches up through them, tongues and fingers"
		/ case dickLocation b of
			Just DickSheathed -> c "teasing your sheath"
			Just DickExternal -> c $ hasExternalBalls
				? "tugging on your heavy, immense balls"
				?: "lapping at the base of your shaft"
			Just _ -> c "slipping into your flushed, gaping vent"
			f -> bodyFail FuckAggressive f
		/ ". You buck, " / forelegs / "rearing for a moment, cock slamming deep, and the clay man groans; his body half-dissolved, all runny and smeared out, and he's grunting and groaning from the impact of each of your thrusts. Your pre floods through him, smearing him out until you're mostly fucking a shifting lump, arms and legs and cocks bubbling to the surface only to smear apart again as you pulverize him, thrust coming hard and fast."
		/ hasExternalBalls ? "Your balls crash into the soft clay surface, leaving craters that flood with slimy slip, splattering up across your ass when you thrust again."
		/ Paragraph / "Heat travels up your spine, the slick softness of his clay guts stroking you off. You groan, thrusting faster, cock plowing furrows through his distended body, until you come with a roar. Your balls twitch, dragging themself tight against your shaft, squelching with each motion against the clay-man's body, your underside splattered with clay."
	, analComeshot b cl
	] <> fuckAggroAnalCloser b cl

fuckAggroAnalCloser :: MarkedScene Index () ClayMan
fuckAggroAnalCloser b cl =
	-- this is around when the orgasm scene would merge back in:
	[ dialog cl $ "Fuck, that was good."
	, Narration ["He grins down at you, reformed body coated, intermingled with your load, the messy slurry pouring down his body. He strokes you again, hands wrapping all along your shaft, and chuckles."]
	, dialog cl $ "Let me help you up. Definitely come back and do that again."
	, Narration2 $
		"The clay surges again, slowly disgorging you -- "
		/ case locoplan b of
			Basic Centaur -> "your lower body "
			_ -> "your entire body "
		/ "completely plastered in bright purple-red clay, painted in thick ridges and clusters over your"
		/ case bodyMat_ Legs b of
			Solid (FMat _ Scales) -> "scales"
			Solid (FMat _ Skin) -> "skin"
			Solid (FMat _ Fur) -> "skin, turning your shaggy fur into a collection of lumpy tendrils"
			Solid (FMat _ Coat) -> "skin, leaving your coat utterly soaked"
			Solid (FMat _ Protoplasm) -> "ameoboid membrane"
			_ -> "skin"
		/ ". Your cock is hardly discernable from a particularly huge arch of clay, swirled and detailed in alien shapes, and still leaking the last spurts of come from the tip, gushing a fresh squirt as the clay-man lazily reaches up from the morass and strokes it again."
	]
-- TODO: this needs closer dialog

analComeshot :: BodyGlob -> ClayMan -> Event ClayMan Index ()
analComeshot b cl = Narration2 $
	"Your first shot explodes inside him, forming a pocket, a messy reservoir of come that slowly expands as you keep thrusting."
	/ case ballProduction b of
		Just (Quant x) | x >= 2 -> -- cumflation popping
			"Each thrust takes your cock through the mass of clay sucking against your shaft, opening up into the sloppy mess of your load. "
			/ hasKnot ? "Your fat knot simply breaks his ass open wider and wider with no hope of knotting the soft clay."
			/ "Each thrust slams into his depths, "
			/ hasFlare ? "your broad flare tearing thick clots of clay back and forth each time, "
			/ "erupting again and again as you fill him with your load. He expands, bloating like no one with bones could ever do, barrel chest and fat gut smoothly swelling larger, clay folding over itself and smoothing the creases. His insides are flooded, a slurry of come and clay slip slurping down your shaft, gushing out of his cratered asshole, only to have each pump force more back inside."
			/ Paragraph / "The clay of his body swells and stretches further as you fill him up, until the thinning of the clay reaches a breaking point. He splits apart, a plume of come erupting from his broken body and flooding out in all directions, the reek of your come drowning out the earthy clay. He drags his arms over the tear, forming a paper-thin layer that bursts again almost instantly, your load bubbling out in burst after burst, smearing together with his body until he's saturated, insides hollowing out with a wet sucking sound, the slip coating him becoming thick and tacky as your load gets churned into it. The whole way through he doesn't stop milking your cock, body clenching and squeezing the" / partAdjective Shaft / "shaft to milk out spurt after spurt. His guts collapse around your shaft, the final gushes bubbling up inside lopsided folds of clay."
			/ Paragraph / "The swampy mess of your flooded load starts to churn, the clay beneath sucking it up, and he starts to reform, rich ochre and sienna faded, washed out to a grimy white-pale by your masses of come, body sticky and slimy. He shifts the clay, your load forming glassy pools in the swampy mess, and gulps it all down, swallowing it into the earth. Once he's reassembled, he sags forward, huffing against your chest:"
-- this would be the non-popping cumshot version
		_ ->
			hasKnot ? "Your fat knot simply breaks his ass open wider and wider with no hope of knotting the soft clay."
			/ "Each thrust ends with come squirting back down along your shaft, erupting out across"
			/ case locoplan b of
				Basic Slithering -> "your underbelly, "
				Basic Naga -> "your stomach and underbelly, "
				_ -> "your thighs and stomach, "
			/ case bodyMat_ Chest b of
				Solid (FMat _ Fur) -> "tangling your fur further until it's all stuck to your skin in a thick, heavy layer"
				_ -> "thinning the sloppy clay painted all over your body"
			/ ". You fuck him hard, each spurt of come churning and mingling with his clay, forming a frothing, bubbling slurry of pale orange, thick slimy dribbles flooding out along his gaping, ravaged asshole."
			/ Paragraph / "You eventually pull out, cock slathered with clay, and his ass burbles, drooling your load out in streams before it slowly collapses in on itself and seals over, trapping the rest of your load inside him -- though the clay flesh all across his thighs and ass is paler, white-orange threads marbling across his flesh as your load mingles with his body."


fuckPassiveOpening :: MarkedScene Index () ClayMan
fuckPassiveOpening b cl =
	[ Narration
		[ "The clay man laughs, the sound mostly a wet gurgle."
		]
	, dialog cl $ "Gonna make me do the work, huh? Well, that's okay."
	, Narration2 $ 
		"He walks over, loosely tugging his cock. The tip bulges, squelching under his hand, and it pumps again, gushing another flood of watery slip, this time close enough to splatter you up and down with droplets of clay."
		/ Paragraph / "The clay-man takes hold of his cock, pumping it -- hands smearing away detail only for it to slowly work back, squeezing his shaft out into a bloated oval -- and painting you with another gush of thin slip, his watery pre cascading down and pooling around your knees, turning the clay wet and sucking."
		/ Paragraph / "He presses against you, leaving messy smears of red clay everywhere he touches, cock a pumping pillar between your bodies. "
		/ case locoplan b of
			Basic Centaur ->
				case specNoun b of
					Just (SplitTaur t b) ->
						"He pats the junction of your body, "
						/ (if t == Human
							then "hands smearing clay across the shoulders of your" / animalName b / "half, fingers tugging at your bare crotch"
							else "hands smearing clay across the junction of your two halves, smearing clay in clumpy cords where" / animalName t / "meets" / animalName b / ", fingers tugging at the bare crotch of your" / animalName t / "half")
						/ "."
					_ -> c "He drags his hands down your stomach, smearing clay all over, his fingers curling over the junction where your hips meet your forelegs."
			Basic Quadruped ->
				"He pats your shoulders,"
				-- FIXME: is shoulders null if yr headless? or am i thinking of 'neck'. or is shoulders null if yr ARMLESS
				-- for a quadruped, which this is, shoulders is set to chest/legs
				/ case bodyMat_ Shoulders b of
					Solid (FMat _ Fur) -> "hands smearing clay into your fur, soaking it down into sodden, matted hanks"
					Solid (FMat _ Coat) -> "hands smearing globs of clay into your coat, sticking it down to your skin"
					Solid (FMat _ Skin) -> "streaking your bare skin with thick smears of rich clay"
					_ -> "smearing clay all over"
				/ "."
			Basic Slithering ->
				"He wraps his hands around your sides, "
				/ case bodyMat_ Chest b of
					Solid (FMat _ Scales) -> "sliding down your scales, "
					_ -> mempty
				/ "coating the whole length of your body in sloppy clay."
			Basic x | x `elem` [Biped, Naga] ->
				case dickLocation b of
					Just DickExternal -> "He reaches down and strokes your" / Cock^s / ", the sound sloppy as he paints it with wet clay, slurping when he pumps it through his loose grip."
					Just DickSheathed -> "He reaches down and wraps a hand around your sheath, stroking it to work your soft skin back and forth over your unsheathing" / Cock^s / "."
					Just _ -> "He reaches down to play with your vent, clay fingers shallowly pushing inside and just-barely catching across the tip of your unsheathing" / Dick^s / ", smearing wet slip and pre together in a mess that burbles out between your flushed lips."
					Nothing -> c "His cock throbs, gushing cool pre up across your chest in watery spurts."
			f -> bodyFail FuckPassive f
		/ Paragraph / "He leans in, dragging his face against"
		/ case mouthType b of
			Mouth -> c "yours"
			_ -> "your" / muzzle
		/ ", and presses his lips against you in a kiss, your mouth flooded with the taste: heavy clay, mud, oily water. Strange and unpleasant, but you kiss back, his tongue smearing across yours blotting out anything but the thick tang of clay. He moans into your mouth, body piling up as he ruts against you, painting your entire front in ridges and spirals of wet clay, his cock a spurting mass"
		/ hasDick ? "rolling against yours"
		/ ". When you break the kiss you spit afterward, clay stuck to your teeth and tongue. The clay man laughs again, breath cold and humid."
	, dialog cl $ "Yeah, most people don't go for the kissing."
	, Narration
		[ "He says it with a lopsided smile, pressing wet, cool kisses across your jaw and down your throat."
		]
	, Choices
		[ ("well cmon how abt you kiss me a lil deeper this time", FuckDeepthroat)
		, ("cmon dude just fuck me", InflationFuck)
		]
	]

fuckDeepthroat :: MarkedScene Index () ClayMan
fuckDeepthroat b cl =
	[ dialog cl $ "Is that so?"
	, Narration
		[ "He opens wide, sticking his tongue out just past his lower lip, and then he yawns wider, tongue stretching, squirming, swiping back and forth, just slow enough that it doesn't crumble under its own weight: the clay man feeds it more and more clay, base thickening and thickening until it doesn't resemble a tongue at all, just a huge writhing tentacle of sloppy clay, bulging out from a hollow in a lump that feigns being a head. Then he snaps in, drawing back, tongue if not pulling back into his mouth at least smearing most of its mass into his lips and jaw, casting off the excess to sluggishly drip down his neck."
		]
	, dialog cl $ "Let's see what you can fit, then."
	, Narration2 $
		"He licks"
		/ case mouthType b of
			Mouth -> c "your face"
			_ -> "across your" / muzzle
		/ ", coating it in runny slip, black water bubbling up in the back of his throat and spilling down his tongue, dissolving the sloppy clay flesh. Thicker lumps of clay bulge up at the base, slowly diffusing down the length of his tongue, staining it red-purple. He curls his tongue across your"
		/ case mouthType b of
			Mouth -> c "cheek"
			_ -> c muzzle
		/ ", lashing river water across your face, before he shoves his tongue back into your mouth -- you suckle on the heavy flesh, clay surging and smearing across your tongue and" / teeth / ", the thick wet taste flooding your mouth, a sharp, iron aftertaste lingering. He probes deeper, your throat convulsing when he taps the back of your mouth, the clench deforming his tongue, squeezing the tip off into free clots of clay that smear back across the now-stubbier length of his tongue, more and more clay piling up in the back of your throat until the sheer mass breaches downward, clenching and squirming as it forces its way down your throat."
		/ Paragraph / "The clay man groans, the flesh of his body vibrating, tongue less a tongue and more a huge cord of clay, sluggishly flowing up from the ground and earthing itself in your mouth, cold wet weight spilling down your throat, each gag and choke leaving imprints, moulding the clay against the confines of your throat."
		/ Paragraph / "The clay man moves forward, "
		/ case locoplan b of
			Basic Quadruped -> "gripping your shoulders, gut bulging out between your forelegs, "
			Basic Naga -> "chest pressed against yours, his gut bearing down against your underbelly, his soft flesh smearing and flattening in sloppy, chunky cords, "
			Basic Slithering -> "arms wrapping around you and pressing you against his chest, his body smearing against your thick coils, "
			Basic x | x `elem` [Biped, Centaur] -> "chest pressed against yours, soft flesh smearing up and down your chest, his gut flattening and smearing across your sides, "
			f -> bodyFail FuckDeepthroat f
		/ "his cock an abandoned lump compared to the writhing tentacle his head's become, water streaming up his body to work into the drooling mass of his tongue. You gag again, weight settling into your stomach, straining your flesh, head smeared in red-purple slip, jaw wide open, throat convulsing against the implacable flow of clay. Tongues bud from the main body, licking across your lips, twisting around your tongue, lips fluttering against the inner flesh of your throat for a second before the shaped clay is pressed flat by another gag, a mess of slip and black water streaming from your nose."
		/ Paragraph / "Hands sprout from the clay man's sides, "
		/ case locoplan b of
			Basic Biped -> c "curling over your shoulders, chest, hips"
			Basic Quadruped -> "curling over your shoulders, forelegs, " / feet
			Basic Centaur -> c "curling over your shoulders, chest, waist"
			Basic Naga -> c "curling over your shoulders, chest, hips, underbelly"
			Basic Slithering -> c "wrapping around your body from head to tip"
			f -> bodyFail FuckDeepthroat f
		/ ". A hand crawls "
		/ case locoplan b of
			Basic Biped -> "down your thigh, "
			Basic Quadruped -> "along your sides, "
			Basic Centaur -> "along your lower body, "
			Basic Naga -> "down your lower body, "
			Basic Slithering -> "along your underbelly, "
			f -> bodyFail FuckDeepthroat f
		/ case locoplan b of
			-- naga-or-snake-with-non-cloacal-dick
			Basic x | x `elem` [Naga, Slithering] ->
				c $ hasAsshole
					? ("sliding"
						/ case dickLocation b of
							Just DickExternal -> "past your hard" / Cock^s
							Just DickSheathed -> c "past your fat sheath"
							Just _ -> c "past your cloaca"
							Nothing -> c "down"
						/ "to dig into your asshole, clay piling up against it without ever quite pushing inside.")
					?: "down to your cloaca, clay piling up against it without ever quite pushing inside."
			Basic x | x `elem` [Biped, Centaur, Quadruped] ->
				"stretching and then splitting from the rest of his body entirely to become a lone arm reaching up from the ground behind you, "
				/ case locoplan b of
					Basic Biped -> "fingers "
					Basic x | x `elem` [Quadruped, Centaur] -> "fingers smearing across your flanks and then "
					f -> bodyFail FuckDeepthroat f
				/ "probing "
				/ hasExternalBalls ? "behind your balls" ?: "your asshole"
				/ ", clay piling up against "
				/ hasExternalBalls ? "against your asshole" ?: "it"
				/ " without ever quite pushing inside."
			f -> bodyFail FuckDeepthroat f
		/ Paragraph / "The clay man pulls back from the kiss, his immense tentacle lashing back and forth in your throat, snapping your head to the side. You cough up huge lumps of unformed clay in convulsive gags, thick clods sloughing off the retracting tentacle and settling in the pit of your gut, huge dense chunks of clay leaving you still bloated. The clay man finally pulls himself loose with a disgusting gurgling squelch, leaving your mouth hanging open, clay slip spilling out in a waterfall."
	, dialog cl $ "You want me to use both ends, or just go in from here?"
	, Choices
		[ ("yeah c'mon spitroast me!", InflationSpitroast)
		, ("listen i want u to crawl inside my body thru the mouth", InflationMouth)
		]
	]

-- this might just be the same (w/ a slightly different intro) as 'fuckinflation'. or maybe a variant.
-- currently redacted; to be fleshed out later
inflationSpitroast :: MarkedScene Index () ClayMan
inflationSpitroast b cl =
	[ Narration2 $ c "The clay man grins down at you."
	, dialog cl "Is that so."
	, Narration2 $ "The clay shifts around you, and a second shape builds behind you, like a swimmer breaking the surface of the water."
		/ case locoplan b of
			Basic x | x `elem` [Biped, Quadruped, Centaur] ->
				hasLocotype Quadruped
					? "The first clay man tugs at your head, pulling you forward to mash your face against his dripping gut"
					?: "The first clay-man tips you forward, face pressed against his dripping gut"
				/ ", while the shape forming behind you coheres enough for hands to wrap around your" / hind / "legs. The second clay-man slides upward,"
				/ case bodyMat_ Legs b of
					Solid (FMat _ x) | x `elem` [Skin, Scales]-> "leaving a smeary mess of clay across the backs of your thighs,"
					Solid (FMat _ Fur) -> "spiking your sodden fur up in backwards-facing peaks,"
					Solid (FMat _ Coat) -> "matting your coat to your skin in smeared mats of clay,"
					_ -> mempty
				/ "fingers digging into your cheeks and spreading them, the fat column of his cock prodding between your cheeks."
			Basic x | x `elem` [Naga, Slithering] ->
				"They pull you out, hands on your"
				/ hasLocotype Naga ? "shoulders" ?: "neck"
				/ "and"
				/ hasLocotype Naga ? "hips" ?: "tail"
				/ ", lying you down on your back on the churning mire. The clay man in front of you slurps forward, fat cock pinned under his dripping gut, smearing watery clay slip across your face, while the second one pulls at your tail, thick soft fingers"
				/ case bodyMat_ Tail b of
					Solid (FMat _ x) | x `elem` [Skin, Scales] -> "sliding over your" / matword x
					Solid (FMat _ x) | x `elem` [Fur, Coat] -> "carding through your" / matword x
					_ -> c "smearing across"
				/ "to prod into your"
				/ hasNagaCloaca ? "slit" ?: "asshole"
				/ ", spreading "
				/ hasNagaCloaca ? "your lips" ?: "it"
				/ "in preparation for his cock."
			f -> bodyFail "inflationSpitroast" f
		/ Paragraph / "They bear down, cocks grinding against you. The one pulls at his gut, tugging up to let his fat cock spit a mess of filmy slip across your face; the other grinds down, cock slurping"
		/ primaryFuckableCloaca
			? "over your slit, pressing between your lips"
			?: "between your cheeks, pressing against your asshole"
		/ ". You're pinned between them, their guts weighing you down, not an inch of your"
		/ case bodyMat_ Chest b of
			Solid (FMat _ m) -> matword m
			_ -> "body"
		/ "visible under the painting of clay."
		/ Paragraph
		/ "More hands wrap across your body -- "
		/ hasArms ? "shoulders,"
		/ case locoplan b of
			Basic Slithering -> "head, coils,"
			Basic x | x `elem` [Quadruped, Centaur] -> "flanks,"
				| x `elem` [Naga, Biped] -> "hips,"
			_ -> mempty
		/ case locoplan b of
			Basic x
				| x `elem` [Naga, Slithering] -> "tail"
			_ -> "sides"
		/ " -- and thickly coat you in a daubing of clay."
		/ hasDick
			? (case locoplan b of
					Basic x | x `elem` [Biped, Quadruped, Centaur] ->
						"They spread your" / hind / "legs, knees shifting through the clay mire, and fingers"
					_ -> c "Fingers"
				/ "slide up your"
				/ case locoplan b of
					Basic x | x `elem` [Biped, Quadruped, Centaur] -> "inner thighs"
						| x `elem` [Naga, Slithering] -> "tail and underbelly"
					f -> bodyFail "inflationSpitroast" f
				/ hasExternalBalls ? ", stroking your hanging balls" / ", playing with your" / unsheathed / "cock.")
		/ "The clay man in front wraps thick clay fingers around his cock, stroking and milking it; smearing the mass of his fingers together with his shaft, fattening it up into a thicker mass. He ruts forward, cock smearing across your"
		/ case mouthType b of
			Mouth -> c "face"
			_ -> c muzzle
		/ ", digging into your"
		/ primaryFuckableCloaca ? "slit" ?: "hole" / "."
		/ Paragraph / "The clay-man behind you plays his fingers over"
		/ primaryFuckableCloaca ? "your slit" ?: "your hole"
		/ " before he slides them inside -- fingers or cock it's the same mass of clay, thick and heavy, slick and drizzling watery slip across your inner walls. He thrusts inside, clay mass thinning against the"
		/ primaryFuckableCloaca ? "the fluttering clench of your lips" ?: "pressure of your clenching asshole"
		/ " -- and then more, wrist shoving inside, slurping as he sinks his arm in, his cock transformed into a brutal cudgel as he thrusts inside."
		/ primaryFuckableCloaca ? "Your slit clenches" ?: "Your asshole clenches"
		/ ", temporarily denying him entry, and clay builds up around your"
		/ primaryFuckableCloaca ? "lips" ?: "asshole"
		/ "in a heavy ball, bearing down with an immense weight before you shudder and spread yourself wide, letting him smear it all inside in pulses, filling you up with each gush."
		/ Paragraph / "The clay man's cock mashes against your"
		/ case mouthType b of
			Mouth -> c "face"
			_ -> c muzzle
		/ ", the dense clay denting from the force of his thrusts. His cock twists and shoves itself into your open mouth, thick earthy taste blossoming all across your tongue as he shoves deeper. His cock hits the spasming muscle of your throat and simply squashes through: the clay-tentacle erupts with a gush of slip that thins its substance into slick, soft clay, mixing together into a thick malleable goop as he crams more into your mouth and down your throat."
		/ hasDick
			? (Paragraph / "Hands work your cock, slipping up and down its length. You're spurting pre"
				/ case locoplan b of
					Basic x | x `elem` [Naga, Slithering] -> "all across your belly and down your sides,"
					_ -> mempty
				/ "into the churning sea beneath you, cock slathered and dripping with gritty clay, pre mixing with river water and thinning it further. The grip of clay around your shaft could be a hand, or a mouth, an ass -- rippling bands of pressure, sucking and squeezing, milking out watery spurts of pre. All the while they're plunging deeper, clay roiling over your"
				/ case bodyMat_ Chest b of
					Solid (FMat _ x) -> matword x
					_ -> "body"
				/ "and pushing into your mouth and"
				/ primaryFuckableCloaca ? "slit" ?: "ass"
				/ ".")
		/ Paragraph / "The clay-men press close, trapping you mostly-inside their bodies. They reach across to touch each other, bodies half-dissolving into lumpy boulders of clay, thrusts synchronizing as they rut into you. Their hips are pressed tight"
		/ case locoplan b of
			Basic x | x `elem` [Naga, Slithering] -> "to your body, straddling your tail to fuck your"
				/ primaryFuckableCloaca ? "cloaca" ?: "asshole"
			_ -> c "to your face and ass"
		/ ", and only rutting shallowly, but more cock keeps pushing into you: slurping obscenely into your gaping ass, stretching your mouth so wide your jaw aches. Shudders from within the clay pull smooth, unending arcs to the surface and plunge them into your bloated body. You gurgle, slip constantly spilling from your mouth, nose, while the clay man fucks your face; each thrust mashes your head half-inside his slick, soft gut, letting him pour the undifferentiated mess of clay that once was a cock deeper down your throat. The soft clay warps each time you swallow or gag, leaving behind imprints of your throat muscles that smear away under the next push of clay."
		/ Paragraph / "They feed you more and more clay, a thick heavy weight piling up inside you, churning and squirming in slow, sickening roils. Your stomach aches, bloating, sagging down into the clay mire, your guts cramping and spasming as clay forces its way deeper inside. There's no possible end to it; you're half-sunk into the watery mire"
		/ hasArms ? ", fingers dug into the bank"
		/", and for each glob of clay they sink inside you they recoup twice as much from the bank itself. Smeared waves of clay climb up their bodies -- and all over yours -- replenishing them as they pump immense, heavy clots of clay into your guts."
		/ Paragraph / case locoplan b of
			Basic Slithering -> "Clay presses against your bloated form, gut swollen like you've just swallowed a week's worth of prey,"
				/ case bodyMat_ Chest b of
					Solid (FMat _ Scales) -> "scales seamed wide"
					Solid (FMat _ x) | x `elem` [Skin, Fur, Coat] -> "skin stretched ragged"
					_ -> "flesh warped"
				/ "over the dense, heavy mass roiling inside you. Water burbles up around your coils, and your shuddering squirms plow furrows in the soft mud, making trenches that fill with black water."
			Basic Naga -> c "Clay presses against your bloated form, stomach churning as clay sinks down into your guts. Water burbles up around you, sloppy waves slapping across your sides, your gut an immense mounded hill bearing down on the rest of you."
			Basic Biped -> c "Clay presses against the curve of your gut, water burbling up around you, and maybe it's that you've bloated so much that you're resting on your gut, or maybe it's just that the ever-shifting clay mire beneath you, just as much a part of the clay men as their actual bodies, has risen up to support you."
			Basic x | x `elem` [Centaur, Quadruped] -> c "Clay presses against your bloated form. You're half-immersed in the clay sea, legs caught in the mire, and each push of clay into your mouth or ass makes your gut shudder, its aching bloat bearing down against the clay around it: inside and out, you're completely painted in clay. You shudder, motions just making water suck at your sides, burbling around you in sloppy waves."
			f -> bodyFail "inflationSpitroast" f

		/ "Your body aches, gut bloated enormously. The clay inside you squirms and churns, rolling itself up into a dense ball. Slip sloshes inside, gurgling through your guts, gritty and heavy."
		/ Paragraph / "You probably came at some point; it's hard to tell. Any evidence of your load would be washed away, mingled with the clay so that the only evidence would be a slimier texture, a shade lighter clay."
	] <> inflationEnd FromSpitroast b cl








{-
-- clay men

The clay churns under your hooves and you sink downward, forelegs first. The clay-man oozes closer, grinning wide. Half-formed structures touch your underbelly: slick hands surfacing through the formless clay, wet lips pressing against your flanks. Hands cup your fat balls, another wrapping around your sheath, and a tongue laps inside, clay cool and slippery as it drags across the flesh of your cock.

The clay holds you aloft in the churning mess, limbs all spread, and the first clay-man sinks lower, kneeling to press his dripping length across your front, soft clay deforming and pulling itself back into shape as he thrusts up your chest, leaving behind a brilliantly-colored trough of clay slip. You press your hands against his sides, and under the pressure his sides peel and split, carving into neat sections as he arches up and the line of his motion cuts through your palms. Your fingers sink into his feigned flesh as he stitches himself together, leaving your hand sunk inside his stomach, his cock thumping against your forearm, constantly pouring watery slip. This calls for a delicate touch.

The clay churns around you, coaxing your cock from its sheath -- hand after hand wrapping around the unsheathing length, like there are a dozen people waiting under the clay -- and you buck reflexively, the motion only serving to send water squirting up from the separated clay, lapping in waves across your half-submerged back. The clay-man groans, shuddering from the motion of your cock, and leans in, plastering his body against your front, cock throbbing between you, flattened and lopsided from the pressure. He's gushing pre, more and more wet slip, gritty now with old clay. He presses a wet kiss to your neck, mouth slurping and drooling as he rolls his hips, bucking his body against you, groaning louder when your grip spasms and you plunge your arms inside his body again, his clay body sucking eagerly on your flesh.

Wet hands trail between your flanks, stroking the flesh behind your balls, and you jerk again, cock twitching, jerking through the mess of clay, and the next burble of displaced water from your motions comes up reeking of your pre. You arch, pushing against the clay-man who by now has mostly decohered, a statue thinned and split apart, limbs and head and cock writhing through a mess of clay, his body plastered to yours in thick clumps. Water spouts from your motions, waves of gritty slip as the mud churns, and he keeps moaning, grunting, even with his head smeared and lopsided, plastered to your chest.

The clay beneath you churns, a sucking mouth wrapping around your cock. You moan, each fresh gush of pre smearing into the clay around you until the reek of sex overwhelms even the rich scent of raw clay. The clay milks your cock, lips or hands or asshole slurping up and down your shaft, pumping you faster and faster as you buck with it, rutting your cock through the morass.

Your balls pull up tight, cockhead flaring out, and you come with a bellow, gush after gush of come feeding the hungry clay. The ground bulges, a wet reservoir of come surging below, and finally cracks apart, your load gushing up to the surface in waves of gloppy white, churning into the clay and staining it paler.

The clay surges and stills, and then slowly starts building up an avatar again, the smeared-out remains of the clay-man crawling across your front as they reassemble into something more humanoid, not the crawling mass of clay it had been.

Once he's reassembled, huffing against your chest:

> Fuck, that was good.

He grins down at you, reformed body coated, intermingled with your load, the messy slurry pouring down his body. He strokes you again, hands wrapping all along your shaft, and chuckles.

> Let me help you up. Definitely come back and do that again.

The clay surges again, slowly disgorging you -- your lower body completely plastered in bright purple-red clay, painted in thick ridges and clusters over your skin, turning your shaggy fur into a collection of lumpy tendrils. Your cock is hardly discernable from a particularly huge arch of clay, swirled and detailed in alien shapes, and still leaking the last spurts of come from the tip, gushing a fresh squirt as the clay-man lazily reaches up from the morass and strokes it again.

-}


inflationMouth :: MarkedScene Index () ClayMan
inflationMouth b cl =
	[ Narration
		[ "He laughs again, a lopsided grin on his face, and he reaches out and runs a hand across your teeth, fingers smearing together."
		]
	, dialog cl $
		"Well I can't say you're not asking for it."
		/ Paragraph / "Sure, let's do this."
	, Narration2 $
		"He presses his lips to yours again, your" / muzzle / "already coated, teeth and inner flesh slimy with clay. The heavy mass in your stomach churns, still animated, and the clay man groans, "
		/ case locoplan b of
			Basic x | x `elem` [Biped, Naga, Centaur] -> "hands spreading across your" / partAdjective Belly / "belly,"
			Basic Quadruped -> "reaching up from the ground beneath to spread budding hands across your" / partAdjective Belly / "belly, "
			Basic Slithering -> c "hands spreading across your bulging belly,"
			f -> bodyFail InflationMouth f
		/ "the mess in your gut kicking back. His open mouth distends, lazily forgetting to be mouth-sized, yawning wider and wider as he thrusts forward again, tongue-tentacle gliding back into your already-prepared throat. You gulp, drinking down black water and smooth clay, gagging and sputtering from the slow, implacable push forward. His "
		/ case locoplan b of
			Basic Quadruped -> "hands stroke "
			_ -> "hand strokes "
		/ "up and down your stomach, "
		/ hasDick ? ("idly tugging on your" / Cock^s / ",")
		/ "smearing you inside and out with clay -- the thick tentacle shoves its way back down your throat, flattening and shifting minutely against your gags, feeding you an endless stream of thick clay: its dense, cool weight pushing "
		/ case mouthType b of
			Muzzle -> "over your jowls"
			_ -> "past your lips"
		/ ", down your throat, settling with heavy thumps into your stomach. Your gut is already swollen, and the clay is so much more denser than come, a solid weight resting heavily inside you."
		/ Paragraph / "The clay man pulls back just long enough for you to suck in an unnecessary breath, his body dissolved into only the vaguest of silhouettes, head-and-shoulders simply rising up from a mound, tentacle-tongue pulled back fractionally in front of your panting mouth before he shoves back inside. Clay migrates up -- "
		/ case locoplan b of
			Basic x | x `elem` [Biped, Naga, Centaur] -> c "your hands are fisted against his chest, wet clay wedges in your hands, half-submerged in the continual tide of water and clay streaming up his body"
			Basic Quadruped -> c "half-submerging your forelegs and head in a churning mass of clay, huge clumps crawling up your sides to merge with the primary mass of his body"
			Basic Slithering ->
				"burbling up your sides and his, splattering down across your" / materialWord Tail
			f -> bodyFail InflationMouth f
		/ ". Clay surges up through the length of his tongue-tentacle, forming an unbroken arch traveling down your throat and into your stomach. "
		/ case locoplan b of
			Basic Biped -> "The mass squirms, knocking you forward, and the clay man eases you both down to your knees without once ceasing to pump more clay inside you. Clay squelches under your knees, squirming up in unformed slabs to crawl up your sides, and inside your flooded stomach the clay squirms downward, pushing into your guts with a slow slide."
			Basic Naga -> do
				"The mass squirms, bulging your gut, weight shifting as it floods your stomach and then surges lower into your guts, the cool, heavy weight dropping down into your"
				case bodySpecies Tail b of
					Just x -> if bodySpecies Chest b == Just x then "lower" else animalName x
					_ -> "lower"
				"half, slowly swelling your underbelly just as much as your"
				case bodySpecies Chest b of
					Just x -> if bodySpecies Tail b == Just x then "upper" else animalName x
					_ -> "upper"
				"stomach."
			Basic Slithering -> "The mass squirms, bulging your gut, weight shifting as it floods your stomach and then surges lower into your guts, bloating you like you've swallowed a week's worth of prey."
			Basic Centaur -> do
				"The mass squirms, kicking at your stomach, and the clay man eases you both down to your knees without once ceasing to pump more clay inside you. Your underbelly presses against the clay field, squirming up in unformed slabs to crawl up your sides, and inside your flooded stomach the clay squirms downward, a heavy weight dropping down into your"
				case bodySpecies Legs b of
					Just x -> if bodySpecies Chest b == Just x then "lower" else animalName x
					_ -> "lower"
				"half, slowly starting to fill your underbelly just as much as your"
				case bodySpecies Chest b of
					Just x -> if bodySpecies Chest b == Just x then "upper" else animalName x
					_ -> "upper"
				"stomach."
			Basic Quadruped -> "The mass squirms, kicking at your stomach, weight growing as it floods your stomach and then surges down into your guts. Your stomach swells, and the clay field beneath you surges up to meet it."
			f -> bodyFail InflationMouth f
		/ Paragraph / "Hands caress the curve of your hanging gut, skin aching, feeling like your body is only a thin layer of flesh sandwiched between clay inside you and clay outside. Hands are" / em "inside" / "you, fingers tugging at the catch at the bottom of your throat, pressing against the walls of your stomach, fingers tugging the opening to your guts wider. The clay man's kiss continues, deeper, his immense tentacle-tongue hardly even that now, just an immense upwelling of clay, internal structure shifting and pulling to feed more and more of it into your bloated body, gut tumescent and aching, thick roils of black water sloshing inside, churning into the mass of heavy clay to make it slicker and more easily worked."
		/ Paragraph / hasDick
			? "Your cock is pressed tight to the underside of your fat gut, pre forgettable dribbles mixed into the mess of clay coating your entire body -- "
			?: "You're a mess all coated in clay -- "
		/ case locoplan b of
			Basic Biped ->
				"you probably look exactly like a clay man yourself, a fat figure on your knees in the clay field, "
				/ case bodyMat_ Chest b of
					Solid (FMat _ Fur) -> "your fur so thickly matted down"
					Solid (FMat _ Skin) -> "flesh so thickly coated"
					_ -> "body so thickly coated"
				/ "that it's impossible to tell that there's something else under the clay."
			Basic Naga -> c "you probably look like a clay man yourself, a fat figure bloating out into a lumpy swell that merges with the clay field, flesh so thickly coated with clay that it's impossible to tell that there's something else under there."
			Basic Slithering ->
				"you probably look like nothing so much as a swollen arch of clay, half-merged together with the clay man's dissolving body, your" / materialWord Tail / "so thickly coated with clay that it's impossible to tell that there's something else under there."
			Basic Centaur -> "it's only your"
				/ case bodySpecies Legs b of
					Just x -> if bodySpecies Chest b == Just x then "lower" else animalName x
					_ -> "lower"
				/ "half that distinguishes you from a clay man yourself, a fat figure in the clay field. Even that's debatable, your lower body so swollen with clay and with the field reaching up around your sides that it just looks like a particularly large swell of clay around your bloated body."
			Basic Quadruped ->
				"body looking more like a bloated swell of clay itself, "
				/ case bodyMat_ Chest b of
					Solid (FMat _ Fur) -> "fur so thickly matted down and coated with clay"
					_ -> "so thickly coated"
				/ "that it's impossible to tell that there's something else under there."
			f -> bodyFail InflationMouth f
		/ Paragraph / "The clay man keeps pumping more and more clay down your throat, weight bearing down inside and out, slathered in an inch-thick layer of clay slip, belly aching from the weight, bulging out grotesquely, flesh stretched beyond taut, stinging stretch marks seaming up across your sides"
		/ case bodyMat_ Chest b of
			Solid (FMat _ Fur) -> ", tearing ragged stripes through your sodden fur"
			Solid (FMat _ Scales) -> ", bulging your scales until there's white flesh stretched between them"
			_ -> mempty
		/ "."
		/ case locoplan b of
			Basic Biped -> "You slump even lower, a mess of hands and arms reaching up from the clay bed to ease you down to your hands and knees. "
			Basic Naga -> "You bow back, body stretched out under the increasing pressure of the clay, tail in a straight line. Your underbelly bulges out in a huge, lopsided swell, like you swallowed a week's worth of prey. "
			Basic Slithering -> "Your upper body, held erect, struggles against the increasing weight of your gut. Your underbelly bulges out in a huge, lopsided swell, anchoring you solidly to the ground."
			Basic Centaur -> "You slump even lower, bowing forward over your stuffed gut as much as you can, and even then the swell of your human half is nothing compared to the bloated, immense weight of your swaying underbelly. "
			Basic Quadruped -> "You gag and gurgle, jaw reflexively biting down on the mass of clay, teeth all gummed up. "
			f -> bodyFail InflationMouth f
		/ "The entire lower half of your face is encased in a twisted pillar of clay, mouth yawning wide, clay like water simply pouring and pouring unceasingly into you."
		/ case locoplan b of
			Basic Slithering -> mempty
			_ -> "Your stuffed gut sways, smearing through the clay beneath you, the heavy drag slowly turning into a curve of contact: your drooping belly meets the ground, your weight shifting as your stuffed gut comes to rest in the clay mire instead of hanging down."
		/ "Pressure across your straining flesh grows, your grotesquely-swollen body out of room to grow beneath you."
	] <> inflationEnd FromMouth b cl

inflationEnd :: Reached -> MarkedScene Index () ClayMan
inflationEnd from b cl =
	[ Narration2 $
		"It's impossible to tell how long it goes on for, or how long it's been going on for; eventually the continual push of clay slows. It seems less that the clay man is sated, or tired, and more maybe that he's" / em "bored" / "; or maybe that it's you're running up hard against the physical limits of your body -- your" / materialWord Chest / "is widely seamed, huge zebra-stripes of raw red flesh all across"
		/ case locoplan b of
			Basic Biped -> "your hips and gut"
			Basic Slithering -> "your bloated stomach"
			Basic Naga -> "your bloated underbelly"
			Basic Centaur -> "both swollen, heavy bellies"
			_ -> "your gut"
		/ "; each slow pump of clay down your throat"
		/ case from of
			FromSpitroast -> "or into your ravaged" / primaryFuckableCloaca ? "vent" ?: "ass"
			_ -> mempty
		/ "meets more and more resistance against the pressure within. Whatever the cause, the clay man slowly peels away and reforms kneeling before you. You gag at the withdrawal, coughing up messy slabs of brilliant red ochre clay, slip staining your throat as you heave over and over, coughing up only some tiny fraction of the immense mass of clay nearly pinning you to the riverbank"
		/ case from of
			FromSpitroast -> ", " / primaryFuckableCloaca
					? "your lips bruised into thick, puffy slabs"
					?: "your asshole a massive bruised ring"
				/ ", aching from the stretch, and convulsing as clay sluggishly pours from your wrecked guts"
			_ -> mempty
		/ "."
	] <> inflationClosingDialog from b cl


data Reached = FromMouth | FromAss | FromSpitroast
	deriving (Eq, Ord, Enum, Bounded, Show)

inflationClosingDialog :: Reached -> MarkedScene Index () ClayMan
inflationClosingDialog r b cl =
	[ dialog cl $ "Easy,"
	, Narration2 $
		"he says, and it's like sound swims back into the world, your mind abruptly picking up the thread: water slopping across the shore, "
		/ case locoplan b of
				Basic Biped -> "clay squelching under your" / hands / "and" / feet / ","
				Basic Naga -> c "tail mired in a mess of clay and crackling through it as it sways, "
				Basic Slithering -> c "body mired in a mess of clay, "
				Basic x | x `elem` [Centaur, Quadruped] -> "legs mired knee deep, " / feet / "sucking at the clay as you twitch, "
				f -> bodyFail failFrom f
		/ "the slow wet noises the clay man makes as he moves."
		/ case locoplan b of
			Basic Slithering -> c "Your underbelly is bloated nearly to immobility, deforming the line of your body cartoonishly."
			_ -> "He can hardly help you up -- his clay body just as solid as the clay inside you; his hands and arms stretch and compress cartoonishly as he tries to bear some of your weight -- "
				/ case r of
					FromMouth -> case locoplan b of
						Basic x
							| x `elem` [Biped, Naga] -> "but he helps you sit back on" / case x of
									Biped -> "your ass"
									Naga -> "your tail"
									f -> bodyFail failFrom f
								/ ", your gags finally giving way to breathless pants, mouth still slimy with clay, tickling the back of your throat."
							| x `elem` [Centaur, Quadruped] -> "but he helps you up to your" / feet / ", clay beneath slowly disgorging you in a rising swell, even as your bloated gut still drags through the mire."
						f -> bodyFail failFrom f
					FromAss -> case locoplan b of
						Basic x
							| x `elem` [Biped, Naga] -> "but he helps you sit back on " / case x of
									Biped -> "your knees "
									Naga -> "your tail "
									f -> bodyFail failFrom f
								/ "," / ("broken asshole"^cloaca "wrecked cloaca") / "spilling a continual slurry" / hasLocotype Naga ? "down your underbelly " / "into the furrowed and ploughed ground below."
							| x `elem` [Centaur, Quadruped] -> "but he helps you up to your" / feet / ", clay beneath slowly disgorging you in a rising swell, even as your bloated gut still drags through the mire, your wrecked asshole spilling a continual slurry of churned-up clay, brilliant red sienna streaming down your flanks in a sloppy spill."
						f -> bodyFail failFrom f
					FromSpitroast -> case locoplan b of
						Basic x
							| x `elem` [Biped, Naga] -> "but he helps you sit back on " / case x of
									Biped -> "your knees "
									Naga -> "your tail "
									f -> bodyFail failFrom f
								/ ", wetly gagging still, " / ("broken asshole"^cloaca "wrecked cloaca") / "spilling a continual slurry" / hasLocotype Naga ? "down your underbelly " / "into the furrowed and ploughed ground below."
							| x `elem` [Centaur, Quadruped] -> "but he helps you up to your" / feet / ", clay beneath slowly disgorging you in a rising swell, even as your bloated gut still drags through the mire, your wrecked asshole spilling a continual slurry of churned-up clay, brilliant red sienna streaming down your flanks in a sloppy spill."
						f -> bodyFail failFrom f
		/ Paragraph / "He reaches out to feel across your gut, just that light pressure nearly enough to make you heave"
		/ (if (r /= FromAss) then "again" else mempty)
		/ ", each spasm of the abused muscles of your gut sending a low wave of dizzy nausea through you."
	, dialog cl $ "Not many mortals get into this."
	, Narration ["There's a fractional pause:"]
	, dialog cl $ "Or can manage to fit that much in them."
	, Narration ["The clay man leers down at you, all but panting as his hands smear across your gut, feeling its bloated heft. Maybe not bored or tired after all."]
	, dialog cl $ "Lemme help you up,"
	, Narration2 $
			"he says, and tries to help you up again and mostly fails. "
			/ case locoplan b of
				Basic Biped -> "You stagger to your" / feet / ","
				Basic Naga -> c "You squirm and lurch to the side, tail slowly finding purchase in the churning clay below and letting you work yourself upright, "
				Basic Slithering -> c "You squirm and lurch to the side, body slowly finding purchase in the churning clay below and letting you sluggishly lift some part of your body up erect, raising your head, "
				Basic Centaur -> "You stagger to your" / feet / ","
				Basic Quadruped -> c "You drag yourself up, "
				f -> bodyFail failFrom f
			/ "and the slow slosh of your overstuffed gut nearly knocks you back down. "
			/ case locoplan b of
				Basic Biped -> c "Your feet sink, incrementally, in the clay, "
				Basic Naga -> c "Your tail sinks into the clay, "
				Basic Slithering -> c "Your body drags lurching tracks in the clay, "
				Basic Centaur -> "The clay sucks at your" / feet / "as you try to move, "
				Basic Quadruped -> "The clay sucks at your" / feet / ","
				f -> bodyFail failFrom f
			/ "and you struggle to breathe, each breath spiking the pressure within you to nearly painful levels."
	, dialog cl $ "Hey, there's always more clay."
	, Narration ["The clay man gestures at the clay banks, effectively unchanged save for the churned-up crater surrounding the two of you."]
	, dialog cl $ "Come back later and I'll"
		/ case r of
			FromMouth -> "feed"
			FromAss -> "fuck"
			FromSpitroast -> "use"
		/ "you more."
	]
	where
		failFrom = if r == FromMouth then InflationMouth else InflationFuck


inflationFuck :: MarkedScene Index () ClayMan
inflationFuck b cl =
	[ dialog cl $ "Okay sure. Let's see what you can take."
	, Narration
		[ "He sits back just fractionally, enough for you to see his cock over his gut. He strokes it, smearing his hands up and down his shaft, and it thickens under his attention, clay piling up as he smooths it out. His cock sags under its own weight, dipping down from its taut arch pressed against his gut, and he shifts, his oversized balls smearing backwards in the clay field, cock jutting out, so thick it's almost crumbling apart."
		]
	, dialog cl $ "I guess you sucking me off would be too much to ask for, huh."
	, Narration2 $
			case locoplan b of
				Basic x | x `elem` [Biped, Naga, Slithering] ->
					"He says it with a grin, reaching out" / case dickLocation b of
						Just _ -> "to stroke your cock, smearing it with cool, smooth clay, "
						_ -> "to slide a hand down your stomach"
					/ "and then" / case x of
						Biped -> hasExternalBalls
							? "reaching back under your balls"
							?: "reaching down between your legs"
						Naga -> hasCloaca
							? "sliding across your flushed cloaca"
							?: "reaching down to press against your asshole"
						Slithering -> hasCloaca
							? "sliding across your flushed cloaca"
							?: "reaching down to press against your asshole"
						f -> bodyFail InflationFuck f
					/ ". He tips you back, hands on"
					/ case locoplan b of
						Basic Slithering -> "your sides"
						_ -> "your hips and sides"
					/ "for a second, each touch leaving a splotchy smear of opaque clay slip, "
					/ case locoplan b of
						Basic Slithering -> "dragging a heavy loop of your body up from its bed of wet clay"
						_ -> "settling you on your back in a bed of wet clay"
					/ "while his hands smear across"
					/ case x of
						Biped -> c "the backs of your thighs, raising your legs up, and his fingers slide down between your cheeks, reaching for your hole. "
						x | x `elem` [Naga, Slithering] -> "your underbelly, sliding up against the"/ ("tight pucker"^ cloaca "flushed vent") / "of your"/ ("asshole"^ cloaca "cloaca") / "."
						f -> bodyFail InflationFuck f
				Basic Quadruped -> "He says it with a grin, petting across your" / muzzle / "and down your side"
					/ case bodyMat_ Chest b of
						Solid (FMat _ Fur) -> ", touch soaking your fur into matted hanks, leaving sodden clumps of clay in your tangled fur"
						Solid (FMat _ Coat) -> ", touch smearing your coat with clay"
						_ -> mempty
					/ ". He slides around your body, hand curving over your hip, wasting no time to press his fingers down"
					/ hasTail ? "under your tail" ?: "against your asshole"
					/ "."
				Basic Centaur -> "He says it with a grin, hands fanning across your chest and"
					/ case bodyMat_ Chest b of
						Solid (FMat _ Skin) -> "smearing your skin with streaks of cool clay"
						Solid (FMat _ Scales) -> "smearing your scales with streaks of cool clay"
						_ -> "smearing it with clay"
					/ ", bringing his hands down to grab your hips for a moment, rutting the immense swell of his oversized cock against your sexless front, down between your forelegs where your cock would be if you were humanoid. He wades around your side, "
					/ case bodyMat_ Legs b of
						Solid (FMat _ Coat) -> c "hand leaving a trail of clay all over your coat, soaking it to your skin"
						_ -> "hand leaving a trail of clay over your" / hips
					/ ". He wastes no time, hand curling over your" / animalAss / "and pressing against your asshole."
				f -> bodyFail InflationFuck f
			/ "The touch is strange, slick and yielding, black water and clay slip strange lube as he shoves a finger, or maybe two, into your" / ("ass"^cloaca "cloaca") / "."
		/ Paragraph / "He lines his cock up, bloated cockhead digging into your hole, and bears down, the arch of his cock bending before he reaches down to brace it with both hands, cockhead smearing and dimpling as he shoves forward into your"
		/ hasAsshole
			? "ass, hole clenching through layers of sloppy slip before finding resistance deeper within its core."
			?: "cloaca, your puffy folds gaping, their fluttering edges smearing through layers of sloppy slip."
		/ Paragraph / "His cock surges, twisting a little, clay spiralling up his shaft to reinforce it, and he thrusts in, the first gush of pre -- thin, sloppy slip -- taking you by surprise, gushing"
		/ hasAsshole
			? "across the walls of your ass"
			?: "deep up inside your vent"
		/ ". The clay man groans, "
		/ case locoplan b of
				Basic Biped -> "hands sliding across your ass and thighs, "
				Basic Naga -> "hands sliding across your hips and stomach, "
				Basic Slithering -> "hands sliding over your looped coils, "
				Basic x | x `elem` [Centaur, Quadruped] -> "hands gripping your hips just where they meet your flanks, "
				f -> bodyFail InflationFuck f
		/ "smearing you thickly with clay, and he thrusts forward, the sheer mass of him cramming a few more inches of his cock into you, even as his cock itself deforms, squashing shorter and thicker. His thrusts don't so much slide his dick as reshape it, each thrust pumping a new few inches inside, cock steadily pulsing and drooling as he, to a certain degree, drops the pretense of being a" / em "human" / "precisely and just starts pouring clay inside you with each thrust. His hands curl around your body, maybe not \"hands\" precisely anymore, just thick branching cords of clay "
		/ case locoplan b of
			Basic Biped -> c "spiraling up your legs and wrapping around your cock."
			Basic x | x `elem` [Naga, Slithering] -> "twisting around your tail; "
				/ hasAsshole
					? (case dickLocation b of
						Just DickExternal -> "stroking your cock"
						Just DickSheathed -> "stroking your unsheathed cock"
						Just _ -> "smearing across your flushed cloaca"
						Nothing -> "smearing across your flushed cloaca")
					?: "budding out across your gaping cloaca"
				/ "."
			Basic x | x `elem` [Centaur, Quadruped] -> case dickLocation b of
					Just DickExternal -> "spilling down your underbelly and wrapping around your cock"
					Just _ -> "spilling down your underbelly and wrapping around your unsheathed cock"
					Nothing -> "wrapping in thick cords around your flanks"
				/ "."
			f -> bodyFail InflationFuck f
		/ Paragraph / case dickLocation b of
			-- TODO: this should be slightly different if yr getting cloaca fucked
			Just _ -> hasAsshole
					? ("You" / groan / ", rocking into the clay man's grip, hands or mouth or ass wrapped around your" / Cock^s / ": a tight hole that you rock into, squeezing and clenching, fingers or tongues lapping around the tip, stroking the shaft. ")
					?: ("You" / groan / ", his endless surge of clay burying your" / Cock^s / "in its stream, half-formed hands or mouths or asses wrapped around" / "it"^p "them" / ": a sloppy, suckling pressure even as more and more clay surges up inside your guts through your fucked-open cloaca.")
				/ "He's little more than a massive heap of animate clay: body cast off as he fucks you, clay crawling across your body. Your cock twitches, orgasm building, and the massive clay cock inside you drags over your prostate, fucking you through your orgasm -- you erupt with a long groan, "
				/ case locoplan b of
					Basic x | x `elem` [Biped, Slithering, Naga] -> "spurting come into the mess of runny slip, "
						| x `elem` [Centaur, Quadruped] -> "spurting come into the churning clay below, "
					f -> bodyFail InflationFuck f
				/ "tight bands of fingers or lips milking you over and over, "
				/ hasExternalBalls ? "tugging your balls, "
				/ "digging into your prostate, keeping you feeding the hungry clay until you're entirely spent."
			Nothing ->
				"You groan, taking each thrust, feeling your"
				/ hasAsshole ? "ass" ?: "vent"
				/ "stretch and gape even around his soft flesh as he pumps more and more heavy clay inside you. He's little more than a massive heap of animate clay: body cast off as he fucks you, clay crawling across your body."
		/ Paragraph / "The clay inside you surges and moves, thick bands"
		/ case locoplan b of
			Basic Slithering -> "looping around your body"
			_ -> "grabbing your hips"
		/ "for better traction, ploughing what has to be buckets of clay into your gaping" / ("asshole"^cloaca "cloaca") / ". There's a rumbling groan, warbling from the mouths of the clay-man but coming from the ground itself, and then there's an upswell. The ground beneath you surges up, pressure building below you, and finally erupts, gallons of watery slurry pumping through the core of the monstrous cock sunk inside you, washing away the vague cock-shape inside you; simply stuffing you with more and more, deeper and deeper. It's a mess of sludgy fluid: runny clay slip, chill and gritty and oozing as the clay keeps pumping inside; clumps of tarry clay; sloppy gushes of black water, all of it pouring into your" / ("ass"^ cloaca "cloaca") / ", erupting back out in sudden squirts as you spasm and groan against the growing pressure."
		/ Paragraph / "The clay surrounding you churns, sluggish currents forming in it as more and more clay surges into your gaping, broken-wide" / ("asshole"^cloaca "vent") / ". Your bloated gut swells and swells, bearing down against the clay outside you. Your skin is pinned inside and out against vast churning seas of clay, each easing of the pressure bearing down on your outsides matched perfectly by an increase inside."
		-- this is mostly a repeat shared b/t scenes
		/ Paragraph / "It's impossible to tell how long it goes on for, or how long it's been going on for; eventually the continual push of clay slows. It seems less that the clay man is sated, or tired, and more maybe that he's" / em "bored" / "; or maybe that it's you're running up hard against the physical limits of your body -- your" / materialWord Chest / "is widely seamed, huge zebra-stripes of raw red flesh all across"
		/ case locoplan b of
			Basic Biped -> "your hips and gut"
			Basic Slithering -> "your bloated stomach"
			Basic Naga -> "your bloated underbelly"
			Basic Centaur -> "both swollen, heavy bellies"
			_ -> "your gut"
		/ "; each slow pump of clay into your" / ("ass"^cloaca "guts") / "met more and more resistance against the pressure within. Whatever the cause, the clay man slowly peels away and reforms kneeling before you. His withdrawal leaves you lying on the bank, "
		/ case locoplan b of
			Basic Biped -> "gaping asshole drooling a messy slurry, purple sienna clay and black water pouring from your ass,"
				/ case bodyMat_ Legs b of
					Solid (FMat _ Fur) -> "spilling down your thighs, over your saturated fur"
					_ -> "spilling across the backs of your thighs"
				/ "and forming a sloppy puddle soaking your hips."
			Basic x | x `elem` [Slithering, Naga] -> "gaping" / ("asshole"^cloaca "cloacal lips") / "drooling a messy slurry all down your clay-coated underbelly, forming a thinner trail of purple sinenna clay and black water cutting through the more solid mass of clay painted all up and down your body. "
			Basic x | x `elem` [Quadruped, Centaur] -> c "gaping asshole drooling a messy slurry all down your hind legs, purple sienna clay and black water pouring from your ass, all but squirting out when you clench your asshole. "
			f -> bodyFail InflationFuck f
		/ "You lay there and try to recover, body painted head to toe in clay."
		/ Paragraph / "A clay-man reforms, slowly, pulling himself up from the mess leaking from your ass like he's dragging himself out from inside, his expression just about as dazed and exhausted as yours."
	] <> inflationClosingDialog FromAss b cl










{-

other things i'd like to have
	* mutual masturbation / the clay guy smearing over top yr body and jerking off yr combined dick
	* gangbanged by a bunch of half-formed clay men










(well maybe try again)
He grins again, mouth lolling open, broad tongue licking a stripe of cool clay up your neck. You press your lips against his muddy flesh, opening wide when he presses his lips to yours, tarry clay and watery grit flooding your mouth.

Clay squirms into your mouth, dissolving into gritty slush at the edges, constantly shedding its outer layer into sludge. You swallow around the thick tentacle of his mouth, drinking down earthy slip, leaning in to suck more of his fat tongue into your mouth.


(cmon dude fuck me)

normal sex scene: (this variant for bipeds)
	he approaches face to face, hands smearing over yr hands & leaving behind messy smears, lifts yr legs and pushes you back against the bank while he shapes himself a ludicrously huge dick. fingers you and lubes you w/ more clay slip, then fucks you and gushes gritty clay come

variants:
	* like a tar-pit where he sucks you midway into the bank and a bunch of half-formed arms and heads grope and kiss their way across you.
	* gangbang that ends w/ him basically losing cohesion into a huge churning mess of clay and just pumping wave after wave of clay into yr ass



-}
