{-# LANGUAGE MultiParamTypeClasses #-}

module Sites.Hell.Events.Hubur.FlareStack
	( FlareStack
	, deck
	, scene

	, name
	, bits
	, variants
	) where

import Prelude hiding ((/), (^))

import Sites.Hell.Events.SceneUtils hiding ((/), Material(..))
import Sites.Hell.Events.Construction ((/))

import Sites.Hell.Events.Hubur

name :: String
name = "flarestack"

data FlareStack = FlareStack
	deriving (Eq, Ord, Show, Read)

instance ToJSON FlareStack where
	toJSON FlareStack = object
		[ pack "name" .= name
		, pack "data" .= ([] :: [Int])
		]

bits :: Value -> Value
bits _ = object
	[ pack "name" .= name
	, pack "data" .= ([] :: [Int])
	]

variants :: [(MapZone, ())]
variants =
	[ (FactoryProcessing, ())
	]

instance FromJSON FlareStack where
	parseJSON (Object vs) = case (parse (.: pack "name") vs, parse (.: pack "data") vs :: Result [Int]) of
			(Success pName, Success [])
				| pName == name ->
				case Just FlareStack of
						Nothing -> mzero
						Just h -> return h
			_ -> mzero
	parseJSON _ = mzero

deck :: RandomGen g => Rand g (Enumerable FlareStack)
deck = return $ pure $ FlareStack

data Index = Dummy
	deriving (Eq, Ord, Enum, Bounded, Show, Read)

instance Scene Index () FlareStack where
	link x = case x of
		_ -> error "dummy index"
	display = fmap toLower . show
	vardisplay = fmap toLower . show

scene :: Encounter Index () FlareStack
scene = approach

approach :: Encounter Index () FlareStack
approach _ _ =
	[ Narration2 $ "There's a massive array of flare stacks jutting up into the sky: tubes of black metal striped in widely-spaced thin red rings, each one surrounded by a mess of triangular scaffolding. There are plumes of fire at the tips: short, small flames on most, but the central one is a torrent of flame, whipping in the air despite the lack of wind. The light burns the sky red, as if the entire array has a backdrop of thick smog."
		/ Paragraph / "There's a faint whistling from the sky that rises and falls at rare intervals."
	]

{-

Sitting atop the flare stack is a spirit of flame. Presumably. The pilot light wavers and bends, warping unnaturally, and after a long enough time watching it seems like it reflects the movements of some thing within it.

Then you approach closer, and the spirit of flame moves out from the pilot light and removes all ambiguity.

It clings to the top of the stack like a massive spider. It looks like a charcoal dragon, or maybe the burnt bones of one. Its body is charred and black, flaking apart into loose sheaves, and parts of it burst into flame from the ambient heat, burning and spreading across its body for a time before the fire burns itself out. It's thin, spiderlike, and all its limbs are attenuated to nearly sticks. It has a sharp draconic muzzle with a single eye set atop its head, burning too bright to look at directly. Its wings are skeletal, fanning out in all directions, intermingling with its limbs so that it seems insectile, a dozen long grasping feelers quivering in the air.

It skitters along the top of the stack, wings slowly fanning the air for balance, sending plumes of overheated air sweeping along the ground.

-->

It doesn't seem inclined to come down, so you start making your way up.

There's ladders and stairwells and mezzanines among the flare stack itself, in sparse structures made mostly from black metal crossbeams.



its sheer size wasn't apparent from the ground. It's massive, body filling the sky above you, wings spreading and spreading until it seems like the sky is covered with impossibly cross-crossing wires, thinner and thinner down to filaments stretching through everything, cutting the air into slices.



 -> so uh you want to fuck?



its flesh cracks open between its haunches, air rippling with billows of fresh heat.



eggs clusters of tiny pea-pods to it, but to you each one is gigantic, an egg catching within its ovipositor and then pushing through into your {ass} as a burning, sizzling ember.


- spirit of flame

	Sitting atop the flare stack is a spirit of flame. It's hard to distinguish it from the pilot light; its body is hidden within the fire nearly entirely, and when it reaches out, its body is just so much more fire.

	It clings to the top of the spout like a massive spider. Huge lashes of flame curl down the structure, like bunched legs or arms with too many joints. It's hard to tell what it looks like. Its entire body is constantly rippling. Its limbs surge out behind it for a moment, looking like vast, skeletal wings, fanning heat down to the ground as it scuttles among the rigging.

	As it moves, you get a better sense of its shape. Its features are pared down to the abstract: it has a sharp, draconic muzzle, so sharp it seems to be a line, or an outline, with no real volume to it. And yet it has an eye set in its head: one, unblinking, too bright to look at directly. Its wings burst out in all directions; closer to a whirling wheel surrounding it than anything fixed to its body.

	As it leaps from crossbar to crossbar, the struts squeal beneath its weight.

structure:

this is generated as a location, 'flare stack'. in its initial state it's just a location where you can't really do anything.

some flame demons tho will be like... something. but like "hey can you check out the flare stack and see if the spirit of flame there is chill"

and then the next flare stack you visit will have a freaked-out spirit of flame at them, which... has some resolution, and then also you can fuck it + that turns the encounter into 'active' mode where you can talk to the spirit.

	or like you say to the flame demon "what are you working on" and he meanders on and at some point you can be like "hey can i help" and that opens up the flare stack thing where yr supposed to go get some flame from it.

-}