{-# LANGUAGE ViewPatterns #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleContexts #-}

module Sites.Hell.Events.Hubur.GanzerSoldier
	( GanzerSoldier
	, deck
	, scene

	, name
	, bits
	, variants
	) where

import Prelude hiding ((/), (^))

import Data.Maybe (catMaybes)
import Data.Monoid ((<>))
import Control.Monad (when)

import Server.JSON
-- import Sites.Hell.Events.GameEvent hiding ((/))
import Sites.Hell.Events.SceneUtils hiding ((/))
import Sites.Hell.Events.Construction ((/), (^))
import Sites.Hell.Events.Hubur

import Description.TfNode (Animal(..), Sex(Cock))
-- import Description.Build
-- import Description.Body.Sample hiding (feet, animalAss, (?))
import Description.Body.Sample (animalAss, legCount)


name :: String
name = "ganzer"

data GanzerSoldier = GanzerSoldier
{-
	{ bodytype :: GanzerBody
	}
-}
	deriving (Eq, Ord, Show, Read)
data GanzerBody = Bipedal | Scorpion
	deriving (Eq, Ord, Enum, Bounded, Show, Read)
-- maybe have a weapon slot too? gunblade, rocket lance, etc
-- or "rank" that changes some dialog / appearance? like, budding thorny spikes out of the chitin in a ruff around its neck / down its back. floating stars over its head. some kinda geometrical rank insignia on its shoulders.
-- color would be nice. like red/black chitin instead of grey/white. or glowing blue or smth

instance Random GanzerSoldier where
	randomR _ = random
	random = getRand $ return GanzerSoldier

instance ToJSON GanzerSoldier where
	toJSON (GanzerSoldier) = object
		[ pack "name" .= name
		, pack "data" .= ([] :: [Int])
		]

bits :: Value -> Value
bits _ = object
	[ pack "name" .= name
	, pack "data" .= ([] :: [Int])
	]

variants :: [(MapZone, ())]
variants =
	[ (FactoryProcessing, ())
	, (FactoryProcessingPlant, ())
	]

instance FromJSON GanzerSoldier where
	parseJSON (Object vs) = case (parse (.: pack "name") vs, parse (.: pack "data") vs :: Result [Int]) of
			(Success pName, Success [])
				| pName == name ->
				case return GanzerSoldier of
						Nothing -> mzero
						Just h -> return h
			_ -> mzero
	parseJSON _ = mzero

deck :: RandomGen g => Rand g (Enumerable GanzerSoldier)
deck = return $ pure $ GanzerSoldier

data Index
	= OpeningChoices | TalkOpening | FuckPrompt | Leave
	| BlowMe | EatOut
	| FuckAss | FuckCloaca | FuckFace
	| BlowHim | GetFucked
	deriving (Eq, Ord, Enum, Bounded, Show)

instance Scene Index () GanzerSoldier where
	link x = case x of
		OpeningChoices -> openingChoices
		TalkOpening -> talkOpening
		FuckPrompt -> fuckOpening
		Leave -> leave
		BlowMe -> blowMe
		EatOut -> eatOut
		FuckAss -> fuckAss
		FuckCloaca -> fuckCloaca
		FuckFace -> fuckFace
		BlowHim -> blowHim
		GetFucked -> getFucked
	display = fmap toLower . show
	vardisplay = fmap toLower . show

description :: GanzerSoldier -> Event GanzerSoldier Index ()
description g = Narration2 $
	"Part of the factory has been peeled open, and its inner workings are on display: gears and tubes and sparking wires, all neatly sandwiched into inner conduits. There's a scorpion-man of Ganzer at work, arms buried to the elbows inside a hatch."
	/ Paragraph / "Its body is entirely covered in thick chitinous armor, geometrical slabs of matte grey, hinged at the edges with rubbery white material. "
		{-case bodytype g of
			Bipedal ->-}
	/ "Down its back its armor thickens and buds outward, forking at its hips into a massive scorpion-tail, sagging to its calves before arching back up to a fat, spade-shaped stinger over its head, dripping black ooze. Its legs are inhumanly thick to support its own weight. "
			{-Scorpion ->
				"Its lower body is that of an enormous scorpion. Its armor fits together in a neat imitation of scorpion chitin. Its legs end in fat, geometrical pegs, irregular pentagons, slamming into the ground as it moves. Its tail extends behind it, arching up into the air. The fat spade-shaped stinger is curled behind its back, tip dripping black ooze across its armor."-}
	/ "Organic-looking veins crawl over the surface of the armor, branching and winding together to form thick lumps of material at the neck, crotch, back, tail. "
	/ "Its head is ensconced inside something like a motorcycle helmet, smooth matte curves with a visor: only, the visor is shattered into a jagged spread of glassy teeth, and there is only darkess within."

scene :: MarkedScene Index () GanzerSoldier
scene b g =
	[ SetFlag (Global MetGanzerWorker) 1
	, description g
	] <> openingChoices b g

dialog :: Convertible a EventReel => GanzerSoldier -> a -> Event GanzerSoldier Index ()
dialog g = Dialog2 "/static/img/icon.png" "Ganzer Worker" . convert

openingChoices :: MarkedScene Index () GanzerSoldier
openingChoices _ _ =
	[ Choices
		[ ("hey lets talk", TalkOpening)
		, ("hey you wanna fuck", FuckPrompt)
		, ("bye", Leave)
		]
	]

talkOpening :: MarkedScene Index () GanzerSoldier
talkOpening b g =
	[ Narration
		[ "The Ganzer worker doesn't turn around."
		]
	, dialog g $ "Look, I'm trying to work here; unless you got something important to say ask somebody else your world history questions."
	, Choices
		[ ("<==", OpeningChoices)
		]
	]

leave :: MarkedScene Index () GanzerSoldier
leave _ _ =
	[ Narration
		[ "You leave."
		]
	]

fuckOpening :: MarkedScene Index () GanzerSoldier
fuckOpening b g = case locoplan b of
	Spec Orb -> fuckOrbReject b g
	Spec FloatingHead -> fuckFloatingReject b g
	Spec FloatingDick -> fuckFloatingReject b g
	Basic x
		| x `elem` [Formless, Complex] -> fuckOrbReject b g
	_ -> fuckOpeningReal b g

fuckOpeningReal :: MarkedScene Index () GanzerSoldier
fuckOpeningReal b g =
	[ Narration
		[ "The Ganzer worker straightens, and a hollow laugh echoes with impossible depth from the shattered visor."
		]
	, Dialog "/static/img/icon.png" "Ganzer Worker"
		[ "Sure, why not."
		, "Beats doing anything else around here."
		]
	, Narration
		[ "It grinds an armored palm across its crotch, fingers digging into the mass of gnarled veins. It reaches up to its helmet and pushes its hand inside its glass mouth, into the darkness within. There's a flicker of movement, shapes sliding across its fingers, and when it pulls back its fingers are dripping oily black ooze. Droplets dribble down from its mouth like drool, spilling the matte grey of its chitinous armor, and it presses its fingers back against its crotch, fingers catching on a crack betwen two slabs of chitin and digging in. It groans, a wet sucking gurgle, as it slides two fingers up inside itself."
		]
	, Dialog "/static/img/icon.png" "Ganzer Worker"
		[ "How about you come over here."
		]
	, Narration
		[ "A wisp of black smoke, or maybe an octopus tentacle, flits across its glass teeth, spilling black drool down its chin, dribbling in inky lines down its chest."
		]
	-- WHAT IF YOU DON'T HAVE A HEAD
	, FauxChoice "make out w/ it"
	, Narration2 $
		case locoplan b of
			Basic x
				-- this is less a quad/slithering split and just a size thing? small wolves or snakes or w/e would get this; large bodies would get the second bit, only w/ a sentence or so of size/bodytype-related introductory blocking
				| x `elem` [Quadruped, Slithering] -> do
					case bodyHeight b of
						SmallAnimal -> "It drops down to its knees with a thud, head lowering enough for you to reach without much difficulty."
						_ -> "You press the front of your body against it, armor smooth and hard, webbing rubbery, almost sticky to the touch."
					"Its legs are spread, knees set wide, and it keeps one hand pressed against its crotch, flesh swelling under the chitin, sending the armored slabs bulging out; "
				| x `elem` [Biped, Centaur, Naga] -> "You press the front of your body against it, armor smooth and hard, webbing rubbery, almost sticky to the touch. One armored hand wraps around your side, the other still pressed against its crotch, flesh swelling under the chitin, sending the armored slabs bulging out; "
			f -> bodyFail FuckPrompt f
		/ "the thin slit it's shoved its fingers inside is more obvious now, pallid white flesh the same as the webbing between its chitin slabs, smeared with its black drool."
		/ Paragraph / case locoplan b of
				Basic Quadruped -> case bodyHeight b of
					SmallAnimal -> "You climb up on its knees to kiss it, and it drops its head minutely to meet you, "
					_ -> "You lift your head to kiss it, and it drops its minutely to meet you, "
				Basic Slithering -> "You rear up and then dart around its waist, coiling around it for better purchase, and it drops its head minutely to meet you, "
				Basic x
					| x `elem` [Biped, Centaur, Naga] -> "You bring your face close to its, peering into the void behind its shattered visor. Black shapes shift and slide, "
				f -> bodyFail FuckPrompt f
		/ "octopus-tentacle tongues spilling out over its teeth, slapping with wet impacts across"
		/ case mouthType b of
			Mouth -> c "your face"
			_ -> "the side of your" / muzzle
		/ "."
		/ case mouthType b of
			Mouth -> "You kiss back, nipping at the fat tentacles as they slide over your lips."
			_ -> "You lap across the churning mess of tentacles, your tongue digging in between them."
		/ case bodyMat_ Head b of
			Solid (FMat _ Skin) -> "Their glistening surface leaves smears of oily ink all across your skin, everywhere you touch."
			Solid (FMat _ Scales) -> "Their glistening surface leaves smears of oily ink all across your scales, everywhere you touch."
			Solid (FMat _ Fur) -> "Their glistening surface leaves smears of oily ink over your fur, sticking it together in clumps."
			Solid (FMat _ Coat) -> "Their glistening surface leaves smears of oily ink through your coat, sticking it together in clumps."
			_ -> "Their glistening surface leaves smears of oily ink everywhere you touch."
		/ "You lean in, tentacles curling across the sides of your face, wrapping over the top of your head, and sloppily kiss its glass teeth. "
		/ case locoplan b of
			Basic Quadruped -> "You push forward, chest pressed against its, "
			Basic Slithering -> "You squeeze, coiling tighter around its trunk, "
			Basic x | x `elem` [Biped, Naga, Centaur] -> "You grip its sides and grind hard, "
			f -> bodyFail FuckPrompt f
		/ "its body vibrating under the armor."
		/ Paragraph / "It groans into your mouth, breath hot, tongue-tentacles sliding over your lips and into your mouth, flooding you with its bitter taste. You drool, thinning the ink into a wash of black spit, drooling from your mouths and spilling between you, squelching as your bodies rut together."
	, Choices $ catMaybes
		[ guardC (hasDick b) ("hey cmon and blow me", BlowMe)
		, pure ("eat out its gnarled scorpion cloaca", EatOut)
		]
	]

fuckOrbReject :: MarkedScene Index () GanzerSoldier
fuckOrbReject _ _ =
	[ Narration
		[ "The Ganzer worker straightens, and casts a look over to where you're hovering."
		]
	, Dialog "/static/img/icon.png" "Ganzer Worker"
		[ "You look like an egg."
		, "I could lay you in somebody and hardly tell the difference."
		, "Listen: I got some standards. I'm sure not fucking the soul equivalent of a half-formed fetus."
		]
	, FauxChoice "wow fine"
	, Dialog "/static/img/icon.png" "Ganzer Worker"
		[ "Yeah, bye."
		]
	, Narration
		[ "You leave."
		]
	]

fuckFloatingReject :: MarkedScene Index () GanzerSoldier
fuckFloatingReject b _ =
	[ Narration
		[ "The Ganzer worker straightens, and casts a look over to where you're hovering."
		]
	, Dialog "/static/img/icon.png" "Ganzer Worker" $ case locoplan b of
		Spec FloatingHead ->
			[ "You look like a lumpy egg."
			, "Listen, I got some standards here; I'm not gonna fuck every head that comes floating on by."
			]
		Spec FloatingDick ->
			[ "Listen, I got some standards here; I'm not gonna fuck every oversexed soul that comes flopping on by."
			]
		f -> bodyFail "fuckFloatingReject" f
	, FauxChoice "wow fine"
	, Dialog "/static/img/icon.png" "Ganzer Worker"
		[ "Yeah, bye."
		]
	, Narration
		[ "You leave."
		]
	]

blowMe :: MarkedScene Index () GanzerSoldier
blowMe b g =
	[ Narration
		[ "The Ganzer worker leers, a huff of black smog rolling over its glass teeth."
		]
	, Dialog "/static/img/icon.png" "Ganzer Worker"
		[ "My pleasure."
		]
	, Narration2 $
		"It drops to its knees in front of you, the ridge of its helmet digging up your "
		/ case locoplan b of
			Basic Biped ->
				"thigh"
				/ hasExternalBalls ? ", your balls rolling across the slope of its head as it noses upward"
				/ "."
			Basic Naga -> c "stomach."
			Basic Slithering -> c "underbelly."
			Basic x | x `elem` [Centaur, Quadruped] -> do
				"foreleg, and reaches one hand up to pat "
				/ case locoplan b of
					Basic Centaur -> "across the sensitive flesh where your cock would be were you human, "
					_ -> "across your neck and shoulders, "
				/ "before slowly sliding between your forelegs, stroking along your underbelly. "
				/ (\b -> (legCount b > 4)) ? ("You stomp your" / feet / ", practically pinning it down beneath your huge, heavy body in the channel defined by your" / number (legCount b) / feet / ".")
				/ case dickLocation b of
					Just DickSheathed -> c "Your cock is unsheathed, hanging down half-hard. The Ganzer worker's strokes have it stiffening, a hum of pleasure from its touch spreading across your underbelly, making you unsheath fully, cock stiffening in shuddering bursts."
					Just DickExternal -> "Your cock hangs heavily between your" / hips / ", half-hard. The Ganzer worker's strokes have it stiffening, a hum of pleasure from its touch spreading across your underbelly, making your cock stiffen in shuddering bursts."
					Just _ -> c "Your cock is half-emerged from your vent, jutting out half-hard. The Ganzer worker's strokes have it stiffening, a hum of pleasure from its touch spreading across your underbelly, making you spill out fully, cock stiffening in shuddering bursts."
					Nothing -> bodyFail BlowMe "no dick"
			x -> bodyFail BlowMe x
		/ Paragraph / case locoplan b of
			Basic x
				| x `elem` [Biped, Slithering, Naga] ->
					"Its hands wrap around your " / case x of
						Biped -> c "thighs, "
						Naga -> partAdjective Underbelly / "underbelly, "
						Slithering -> c "body, "
						_ -> bodyFail BlowMe x
					/ "gauntleted chitin-flesh smooth and glossy as it slowly slides them up to your "
					/ case dickLocation b of
						Just DickExternal -> c "hanging cock. It wraps its hands around your shaft, pumping it once, twice, as it thickens in its hand. "
						Just DickSheathed -> "sheathed cock. It strokes along the rim of your sheath, coaxing your" / Cock^s / "to drop, heavy and half-hard, and then it wraps its hands around" / ("your shaft"^p "both shafts") / ", pumping" / ("it"^p "they") / "once, twice, as" / ("it thickens"^p "they thicken") / "in its hands."
						Just _ -> "flushed vent. It slides its fingers around the lips of your cloaca, gurgling in its eagerness as your" / Cock^s / "slowly" / ("everts"^p "evert") / "out into its waiting hands. It pumps once, twice, as" / ("it"^p "they") / "thicken in its hand. "
						f -> bodyFail BlowMe f
				| x `elem` [Centaur, Quadruped] -> "You brace your" / feet / "against the ground, widely, and the Ganzer worker crawls beneath you, hand sliding back until it wraps around your shaft, pumping it once, twice, as it thickens in its hand. "
			f -> bodyFail BlowMe f
		/ "Something wet and hot spills over its glass teeth, firm and prehensile. An octopus-tentacle tongue, and then another, and another, all slick, leaving brushstroke smears of hot fluid across your "
		/ case locoplan b of
			Basic Biped -> "thighs "
			Basic Naga -> "underbelly "
			Basic Slithering -> "underbelly "
			Basic x | x `elem` [Centaur, Quadruped] -> "inner flanks "
			f -> bodyFail BlowMe f
		/ "as it coils its tongues around your half-hard cock and tugs it forward, shaft slipping past its teeth and into the black void of its mouth."
		/ Paragraph / "Things grasp your cock, slick coils smearing around your shaft, puffy flesh like lips pressed across the underside, "
		/ case bodySpecies Cock b of
			Just Wolf -> "sliding along the sharp tip of your dick, "
			Just Unicorn -> "lapping over your wide, flat cockhead, "
			Just Goat -> "curling along your rubbery pizzle, "
			Just Bull -> "lapping over the gnarled lump of your cockhead"
			_ -> "lapping at the base of your cockhead, "
		/ "and you groan and thrust forward, "
		/ case locoplan b of
			Basic x
				| x `elem` [Biped, Naga] -> "tugging its helmet down until it presses against your crotch"
				| x `elem` [Quadruped, Slithering, Centaur] -> do
					"sinking your cock effortlessly and impossibly within its helmet, "
					case dickLocation b of
						Just DickExternal -> "until it presses against your crotch"
						Just DickSheathed -> "until its tongues press against your sheath"
						Just _ -> "until its tongues press against your vent"
						f -> bodyFail BlowMe f
			f -> bodyFail BlowMe f
		/ ", cock getting fully hard in its mouth. Its inky tentacles are like soft, strong fingers stroking you, up and down, base to tip. Your cock shudders, letting loose a spurt of pre, thinning the inky slime into black spit, frothing up into thick bubble clusters spilling down over its teeth, smearing"
		/ case locoplan b of
			Basic Biped -> "across your thighs"
			Basic Naga -> "down your underbelly"
			Basic Slithering -> "down your underbelly"
			Basic x | x `elem` [Centaur, Quadruped] -> "across your inner flanks"
			f -> bodyFail BlowMe f
		/ hasExternalBalls ? "and balls"
		/ "."
		/ Paragraph / "The Ganzer worker sits back, cock popping past its teeth with a wet slurp, a writhing mass of tentacles coming with it -- your cock is stained shiny black, all your flesh coated in its ink. It reaches up with one hand -- the other is pressed against its crotch, fingers still shoved inside its vent, chitin bulging now, its vent very nearly gaping. It strokes your cock a few times, ink slick and slippery, staining its armored palm black."
	, Dialog "/static/img/icon.png" "Ganzer Worker"
		[ "You gonna fuck me with this or what?"
		]
	, Choices
		[ ("yea im gonna fuck yr ass", FuckAss)
		, ("yea im gonna fuck yr gnarled scorpion cloaca", FuckCloaca)
		, ("does fucking yr face here count", FuckFace)
		]
	]

fuckAss :: MarkedScene Index () GanzerSoldier
fuckAss b g =
	[ Narration
		[ "The Ganzer worker rolls backwards smoothly, hands wrapped around its thighs to spread its legs and show off the cleft of its ass -- just a junction where two slabs of chitin meet, three hinged triangles forming its ass, with a mess of smaller triangles around the larger slabs to give it better articulation. The gnarled veins bulging up around its crotch span backwards, a few weaving down between its thighs, crawling up to touch what would be the base of its ass cheeks, if it had any."
		, "It slides one hand across the mess of its oozing vent, sliming its fingers with clear, syrupy pre, and then digs along its ass, rubbery webbing dimpling as it digs down, previously-hidden hole opening around one finger, then two. It pulls away to re-lube its fingers before returning to work its ass open, pallid flesh spread into a tight circle, asshole right at the junction of a few triangular plates."
		]
	, Dialog "/static/img/icon.png" "Ganzer Worker"
		[ "Come on!"]
	, Narration2 $
		"The Ganzer worker reaches out, hand tugging along your shaft, cupping the"
		/ case bodySpecies Cock b of
			Just Wolf -> "tip"
			Just Bull -> "tip"
			_ -> "head"
		/ "."
	, Dialog "/static/img/icon.png" "Ganzer Worker"
		[ "Shove it in me!"]
	, case locoplan b of
			Basic Slithering -> slithering
			Basic x
				| x `elem` [Centaur, Quadruped] -> centaurQuad
				| x `elem` [Naga, Biped] -> bipedNaga x
			f -> bodyFail FuckAss f
	, Narration
		[ "It lurches, rolling to the side, chest heaving. There's black froth drooling out over its glass teeth, its body shuddering from the aftershocks of your orgasm. It slowly scrapes itself up, propping itself up on its elbows. Its voice wheezes more than usual, words nearly incoherent under the gurgling."
		]
	] <> finalEnding b g
	where
		slithering = Narration2 $
			"You loop around it, coils sliding over its chitin as you bear down, squeezing: rutting your cock along its sides and stomach, grinding against its cloaca for a fleeting moment before you slow your crawl as your" / Cock^s / ("slides"^p "slide") / "into place, pressing against its tight asshole."
			/ Paragraph / "You bear down, cockhead digging into its ass, spurting pre in gushes, slurping inside it and spilling out, smearing between its chitin and your"
			/ case bodyMat_ (Waist Fore) b of
				Solid (FMat _ m) -> c (matword m)
				Trans (FMat _ t) (FMat _ b) -> "patchwork" / matword t / "and" / matword b
			/ ". Its asshole clenches, sucking wetly around your cockhead, and you bear down, coils clenching tighter all up and down its body, and shove inside, sliding all the way down to"
			/ case dickLocation b of
				Just DickExternal -> "the base"
				Just DickSheathed -> "your sheath"
				Just _ -> "your flushed vent"
				f -> bodyFail FuckAss f
			/ "in a single slow thrust."
			/ Paragraph / "You buck slowly, body rippling as you drive your cock in and out, filling it with sloppy pre until it starts spurting out around your cock with each thrust. The Ganzer worker reaches back, pulling your body towards it, letting out a strangled wheeze every time you hilt. Its own slimy pre pours down from its gaping cloaca in a jiggling line, spur jutting out like a spike."
			/ Paragraph / "You hiss and glide faster, churning into its ass as the heat racing through your body grows hotter, pulse growing faster until you let out a sharp hiss and rear forward, burying your cock to the hilt as you come, spurting your load into its sloppy ass; you thrust the whole time, come sheening your shaft and building up into a foamy lather, slopping down to the ground in frothy dollops. You pull out with a wet" / em "slop" / ", its fucked-open ass drooling your load all down its thighs, your cock smearing a messy line across its thigh."
		centaurQuad = Narration2 $
			"You step forward, forelegs bracketing its body -- its raised legs dig against your" / partAdjective Underbelly / "underbelly, hooked around your sides. It strokes your shaft, smearing its pre along with yours up and down your shaft, "
			/ case bodySpecies Cock b of
				Just x | ridgedCockhead x -> "fingers tugging just under your cockhead"
				_ -> "fingers sliding over the thin ridge of your cockhead"
			/ ". It lines you up, cockhead skidding over its chitin, other hand twisting inside itself to also grasp your cockhead, press it right into its palm, pressed flush against its spread hole. Heat runs up your shaft, a blast of pre gushing out, splattering all up and down its body, lubing its ass in sloppy piles of runny pre, and then you buck forward, rearing up for a moment. You shove forward, head slamming against its hole for a moment before you breach inside and blow its clenched ring wide, chitin bulging out around its hole's sudden spread as you cram your cockhead along with the first few inches of your shaft inside. It groans, body arching, its insides clenching and flexing around your"
			/ case bodySpecies Cock b of
				Just x -> c (animalName x)
				_ -> mempty
			/ "cock before going limp, breathing hard. It slides its hands up, "
			/ case firstOf [Medial, Knotted] dickAttrs b of
				Just Medial -> "stroking your shaft all the way to your medial ring, fingers wrapping around the big bulging ridge and squeezing"
				Just Knotted -> "stroking your shaft all the way to your knot, fingers wrapping around the half-swollen bulge and squeezing"
				_ -> mempty
			/ ". You buck again, its body lurching against the ground, and you shove more inside, erupting with another gush of pre, and pull back minutely, cock emerging slick and shining; its hands stroke the mess of pre further up your shaft, "
			/ case firstOf [Medial, Knotted] dickAttrs b of
				Just Medial -> "slopping back and forth over your ring, "
				Just Knotted -> "slopping it in waves over your knot, "
				_ -> mempty
			/ "each stroke a shuddering spang of pleasure bursting up inside, a counterpoint to the tight clenching heat of its guts."
			/ Paragraph / "You start thrusting for real, hips jerking, its body half-puppeted under your bulk: shoved forward with each thrust, dragged backwards on the withdrawal. "
			/ case firstOf [Medial] dickAttrs b of
				Just Medial -> "Your medial ring slams against its gaping hole, a hot squirt of pre erupting around its gaping ass, splattering across your underbelly, and then the next thrust it pops inside -- the Ganzer worker letting out a short, sharp cry -- to rest just inside its spasming asshole, your pre continually leaking out of its hole, streaming down its upturned ass."
				_ -> "Your shaft slams into its gaping hole, a hot squirt of pre erupting as you sink inside. The Ganzer worker lets out a short, sharp cry, asshole spasming around your shaft."
			/ Paragraph / "You cram your entire shaft into it, in few-inch increments, working until its speared on the entire length of your cock, "
			/ case dickLocation b of
				Just DickExternal -> "your hips pressed flush against its spread lips"
				Just DickSheathed -> "your fat sheath kissing its gaping ass, flesh wrinkling up as you slide the root of your cock into it"
				Just _ -> "your flushed, spread lips pressing against its own in an obscene kiss"
				f -> bodyFail FuckAss f
			/ hasExternalBalls ? ", your pendulous balls coming to rest against its ass with a smack"
			/ ". After that you thrust shortly, only pulling a few inches out, "
			/ case bodySpecies Cock b of
				Just Unicorn -> "leaving the crown of your cock shoved deep deep inside, the swollen ridge grinding against thick, gristly flesh inside, "
				Just Wolf -> "leaving your sharp cocktip shoved deep deep inside, thick bands of gristly flesh"
				Just Goat -> "your pizzle lurching inside its ass, slapping all across its inner ass as you spurt pre all over. You shove your cockhead past thick bands of gristly flesh deep inside, "
				_ -> "your cockhead digging into thick bands of gristly flesh, "
			/ "like a second or third asshole clenching and squeezing. You trumpet, rearing up, forelegs windmilling the air for a moment as you slam forward again, "
			/ case firstOf [Flaring, Twisting, Knotting] climaxAttrs b of
				Just Flaring -> "cockhead flaring up deep inside, "
				Just Twisting -> "thick cock twisting and then corkscrewing sharply, "
				Just Knotting -> "knot crashing against its gaping cloaca, "
				_ -> mempty
			/ hasExternalBalls ? "balls thundering against its ass, "
			/ "shaft spasming and thickening further as you spurt your load. The first pulse blossoms inside it, heat washing down your shaft, and then again, and again, until the first pulse finally erupts out around the base of your cock, overflowing the Ganzer worker's tight confines. You" / groan
			/ case bodySpecies Head b of -- if human head, pick highest rated animal attr maybe? so satyrs still bleat :V
				Just Bull -> c Comma // "grunting and lowing"
				Just Wolf -> c Comma // "howling wildly"
				Just Goat -> c Comma // "bleating"
				_ -> mempty
			/ "as you unload, making short sharp thrusts, cock jumping and lurching with each spurt as you flood its guts with your load, pulse after pulse until it's streaming out of its broken ass just as fast as you pump inside."
			/ Paragraph / "When you finish, you sluggishly pull back, half-hard cock still an immense weight, spilling out -- your" / {-c (matcolor . bodyMat_ Cock) //-} "shaft shiny and dripping with your load, more mess spilling out around it as the Ganzer worker's ass clenches and squeezes, as if trying to keep you lodged inside it. Finally your cockhead, "
			/ case firstOf [Flaring] climaxAttrs b of
				Just Flaring -> "half-flared still, "
				_ -> mempty
			/ "hits the rim of its ass and pulls, " -- maybe should be only for cocks w/ a big cockhead?
			/ "rubbery flesh distending as its gaping ass spits out your cockhead, leaving its hole gaping, the inner flesh of its ass all on display, grubby white flesh soaked in your load, a continual flow drooling out of its wrecked ass."
		bipedNaga x = Narration2 $
			(if x == Biped
				then "You go down on your knees, "
				else "You wrap your tail around its legs, ")
			/ "sliding your cock along the plane of its ass, cockhead digging against its hole. It clenches, rubbery muscles flexing and squeezing against the pressure of your cockhead, its fingers and yours rubbing its hole, pressing down inside. It gurgles, head thrown back, when you push inside -- first fingers, and then sliding your cockhead in alongside, tugging the swelling lips of its asshole as you pull your fingers out, letting its hole clench tight and slick around the tip of your shaft."
			/ Paragraph / "You lean in, grinding your cock down harder, shaft sliding into its ass. It groans louder, black froth spilling over its glass teeth, and bucks back, ass taking in half of your shaft, internal muscles clenching and squeezing and swallowing. You let out a gush of pre, pulling back, and the flesh of your cock emerges shining and slick. Then you drive further in, wrapping your hands around its raised thighs as you start thrusting -- you drive most of your cock into it, back and forth, and then slam forward, hips smacking its ass"
				/ hasExternalBalls ? ", your balls slapping against its chitin"
				/ "."
			/ Paragraph / "You fuck it hard, slamming the full length of your cock into its spasming hole and dragging out against resistance, the Ganzer worker clenching down to keep your cock stuck inside it. Your cock twitches, gushing pre in sloppy spurts into its ass, your shaft coming out shiny, "
			/ case dickLocation b of
				Just DickExternal -> "dribbles of pre spilling down the underside"
				Just DickSheathed -> "dribbles of pre flooding your sheath and spilling over"
				Just _ -> "dribbles of pre flooding your vent and gurgling out"
				f -> bodyFail FuckAss f
			/ ". The Ganzer worker reaches back, pulling your ass towards it, letting out a strangled wheeze every time you hilt."
			/ Paragraph / "You groan, hand braced against its chest as you lean in, thrusting shorter and faster, the clench of its ass sending hot sparks up through your body. Your cock twitches, "
			/ hasExternalBalls ? "balls hammering against its chitin,"
			/ "and you come with a moan, cock unloading in pulse after pulse into its ass, flooding it fast, come spilling down your shaft and bursting from its ass in sloppy gushes, "
			/ hasExternalBalls ? "smearing across your balls and"
			/ (if x == Biped
				then case bodyMat_ (Waist Hind) b of
					Solid (FMat _ Fur) -> "tangling in your fur"
					Solid (FMat _ Coat) -> "soaking your coat"
					Solid _ -> "spilling down your thighs"
					Trans _ _ -> "spilling down your thighs"
				else "spilling down your underbelly")
			/ "."
			/ (if x == Biped
				then "Your thighs clap its ass, "
				else "Your underbelly claps its ass, ")
			/ "impacts wetter as your load drools out from its used hole, until finally you sag forward, cock dribbling out the final few drops into its ass, you nearly lying on top of it for a long moment."
			/ Paragraph / "You pull out slowly, come oozing out around your softening shaft, head pulling out with a" / em "pop" / ", and for a moment its hole gapes, grubby white inner flesh on display, streaked with your load, before it squeezes shut."

fuckCloaca :: MarkedScene Index () GanzerSoldier
fuckCloaca b g =
	[ Dialog "/static/img/icon.png" "Ganzer Worker"
		[ "Well good."
		]
	, Narration2 $
		case locoplan b of
			Basic x
				| x `elem` [Biped, Naga, Slithering] -> "The Ganzer worker sits back on its ass, fingers tugging at its spread vent -- thick gauntleted fingers curling inside itself, a mess of clear slime spilling down its hand. You move forward, into the vee of its thighs, " / Cock^s / "butting against its stomach, sliding down across the hard, flat chitin, catching on the lines of rubbery webbing between them."
				| x `elem` [Centaur, Quadruped] -> c "The Ganzer worker shifts under you, chitin sliding across your underbelly -- it hikes itself up, tentacle-tongues lapping up your underbelly until its head presses between your forelegs, legs raised up against your underbelly as if it's riding you upside-down."
			f -> bodyFail FuckCloaca f
		/ Paragraph / "Its fingers slip from its vent, curling around your shaft -- its slime warm and slick, letting its fingers glide smoothly. It guides your cock into place, "
		/ case locoplan b of
			Basic x | x `elem` [Centaur, Quadruped] -> "sliding up between your forelegs until it can press the tip to the flushed lips of its vent, "
			_ -> "digging against the flushed lips of its vent, grinding against the still-sheathed ridge of its cloacal spur, "
		/ "before your cockhead presses between its spread, gaping lips. You slide in, the inside of the Ganzer worker hot, tight, muscles clenching around your cockhead, its spur a heavy, iron-hard plane jammed tight against the apex of its vent, shifting against your cock as you thrust deeper."
		/ Paragraph / "It gurgles, tentacle-tongues spilling past its glass teeth, black froth building up at the sides of its mouth, "
		/ case locoplan b of
			Basic Centaur -> "and it wraps its arms around your lower body, bringing itself down on your cock, until it's pinned to your underbelly "
			Basic Quadruped -> "and it wraps its arms around your sides, bringing itself down on your cock, until it's pinned to your underbelly "
			Basic Slithering -> "and it tugs your thick anaconda body closer, cupping your back and bringing itself down"
			Basic x
				| x `elem` [Biped, Naga] -> "and one of its hands settles against the small of your back, dragging you forwards, bringing itself down on your cock, until you're chest-to-chest, "
			f -> bodyFail FuckCloaca f
		/ "with the entire length of your cock shoved inside its vent. "
		/ case locoplan b of
			Basic Slithering -> "Its breath spills across"
				/ case mouthType b of
					Mouth -> c "your face"
					_ -> "the side of your" / muzzle
				/ ", inky tentacles spilling across the arch of your body as you move together, your slow coiling shifts sending your cock dragging back and forth through its cloaca."
			Basic x
				| x `elem` [Centaur, Quadruped] ->
					let (lower, waist) = if x == Centaur
							then ("lower ", "hips ")
							else ("", "shoulders ")
					in "It pants against your " / lower / "chest, inky tentacles spilling out across your forelegs and " / waist / "as you move together, cock jabbing in and out."
				| x `elem` [Biped, Naga] -> c "Its breath spills across your face, inky tentacles trailing across your shoulders and neck as you move together, cock jabbing in and out."
			f -> bodyFail FuckCloaca f
		/ Paragraph / "Its body thrums, buzzing under the surface, the muscles of its vent spasming hard, spur shifting along the top of your shaft with each slick, gushing squeeze. It groans, louder, fucking itself on your cock as its spur finally unsheaths, a thick inverted-V of flesh jutting out from its gaping vent, your shaft notched along the underside. It clenches, a sloppy gush of slime squirting out, traveling up the underside of its spur in a sloppy wave and erupting in a spray that splatters all across your stomachs."
		/ Paragraph / "You thrust, your cockhead sliding across the still-sheathed depths of its spur, dimpling against the implacable plane of muscle, each motion sending a frission of pleasure through you. You" / groan / ", humping deeper, slime gushing out "
		/ case locoplan b of
			Basic Biped -> "across your thighs in thick, messy squirts "
			Basic Naga -> "down your underbelly in a sloppy spill "
			Basic Slithering -> "down your underbelly in a sloppy spill "
			Basic Quadruped -> "against your inner flanks in thick, messy squirts "
			Basic Centaur -> "against your inner flanks in thick, messy squirts "
			f -> bodyFail FuckCloaca f
		/ "with each thrust, its vent spasming and clenching."
		/ Paragraph / "You come with a low moan, cock spasming and then erupting, pumping your load into its vent. Slime floods out cloudy, thick filaments of come threaded through the ooze as you unload inside, each thrust a wet, soggy" / em "plap" / "as your" -- {low moan}
		/ case locoplan b of
			Basic Naga -> "belly meets"
			Basic Slithering -> "belly meets"
			_ -> "hips meet"
		/ "its own, slime coursing down your" / sides / ", spilling over the Ganzer worker's chitin, soaking the ground below."
		/ Paragraph / "You pull out, cock emerging thickly webbed with lines of slime, cords hooked back inside its gaping vent, shuddering and smearing together with each twitch of your cock."
	] <> fuckedEnding b g

fuckFace :: MarkedScene Index () GanzerSoldier
fuckFace b g =
	[ Narration
		[ "The Ganzer worker laughs, tentacles spitting ink across your cock."
		]
	, dialog g $
		"I guess that'll be good enough."
		/ Paragraph / "But only if you go rough."
	, Narration2 $ "Its fingers dig into your "
		/ case locoplan b of
			Basic Biped -> "thighs."
			Basic Centaur -> "flanks."
			Basic Quadruped -> "flanks."
			Basic Naga -> "underbelly."
			Basic Slithering -> "sides."
			f -> bodyFail FuckFace f
	, dialog g $
		"So, c'mon, fuck my face."
	, Narration2 $
		case locoplan b of
			-- this should be small quadruped (e.g., dog) only; the larger ones the worker can fit b/t yr legs
			Basic Quadruped -> case bodyHeight b of
					SmallAnimal -> "You rear up, planting your" / feet / "on the Ganzer worker's back, shoving it down to the ground. "
					_ -> "You take a step forward, grinding your" / unsheathed / "cock against the Ganzer worker's face and chest, nearly shoving it to the ground until it braces itself and shoves back just as hard. You bear down, " / hips / "bracketing its face, sandwiching it in place, gushing pre all down its chest."
			Basic Slithering -> "You slide around it, " / Cock^s / "smearing over its shoulders as you complete the circuit, a thick coil of your body wrapped all the way around. You clench, squeezing it tighter, and use your leverage to knock it down, pinning your" / Cock^s / "against its face, gushing pre all down its chest."
			Basic x | x `elem` [Biped, Naga, Centaur] -> c "You grip its head hard, fingertips digging into the rubbery mesh under its jaw. "
			f -> bodyFail FuckFace f
		/ "You can feel muscles trembling through the material. Your cock drools, twitching against the loose grip of its tentacle-tongues with each pulse of pre. "
		/ case locoplan b of
			Basic x | x `elem` [Centaur, Quadruped, Slithering] -> "You twist your hips, slapping the length of your cock along its face, splattering it even more generously with your drooling precome before you draw back a fraction, letting your cock hang down in front of its face before you slam forward in a single brutal thrust, "
				| x `elem` [Biped, Naga] -> "You twist its head, lining your cock up, and slam it down on your cock, "
			f -> bodyFail FuckFace f
		/ "the whole length swallowed up in a churning mess of squeezing tentacles. Its head smacks against your "
		/ case locoplan b of
			Basic x | x `elem` [Biped, Naga] -> "stomach, "
				| x `elem` [Centaur, Quadruped, Slithering] -> "underbelly, "
			f -> bodyFail FuckFace f
		/ "glass teeth grinding against your skin for a moment before you "
		/ case locoplan b of
			Basic x | x `elem` [Biped, Naga] -> "pull it back "
				| x `elem` [Centaur, Quadruped, Slithering] -> "pull back "
			f -> bodyFail FuckFace f
		/ "with a wet squelch, rivulets of ink drooling down your shaft. It pants, frothy gurgles coming from deep inside its helmet as its tentacles work on your cockhead. "
		/ case locoplan b of
			Basic x | x `elem` [Quadruped, Centaur, Slithering] -> "You slam sheath-deep into its throat again, "
				| x `elem` [Biped, Naga] -> "You slam its head down on your cock again, "
			f -> bodyFail FuckFace f
		/ "a spray of ink gushing out over its teeth, splattering "
		/ case locoplan b of
			Basic Slithering -> "all across your underbelly"
			Basic x | x `elem` [Biped, Naga] -> "all across your thighs and belly"
				| x `elem` [Quadruped, Centaur] -> "all across your inner flanks"
			f -> bodyFail FuckFace f
		/ case dickLocation b of
			Just DickExternal -> c $ hasExternalBalls ? ", dripping down your balls"
			Just DickSheathed -> ", smearing black ink across your bunched sheath"
				/ hasExternalBalls ? "and hanging balls"
			Just _ -> c "and burbling over your flushed lips"
			f -> bodyFail FuckFace f
		/ ". You don't give it a moment to pause before you "
		/ case locoplan b of
			Basic Slithering -> "slither back minutely, clutching its head tigher in your coils and start up a rough rhythm"
			Basic x | x `elem` [Biped, Naga] -> "tug its head back up, starting up a rough rhythm"
				| x `elem` [Quadruped, Centaur] -> "tug backwards, starting up a rough rhythm"
			f -> bodyFail FuckFace f
		/ "; you slam "
		/ case locoplan b of
			Basic x | x `elem` [Biped, Naga] -> "its face against your cock, "
				| x `elem` [Quadruped, Centaur, Slithering] -> "your cock past its teeth and down whatever 'throat' it has, "
			f -> bodyFail FuckFace f
		/ "thrusting up with enough force to jar its teeth, and then again, and again, thrusting deep into the clenching mass of its tentacles for just a second before sawing back, letting it gag and gurgle around your shaft."
		/ Paragraph / "It's jerking itself off, one hand shoved between its thighs, fingers jammed into its spread cloaca, fat spurs shoved up over its palm, dribbling down across its gauntleted hand. It groans and shudders, tentacles spilling over its teeth and fanning out across your "
		/ case locoplan b of
			Basic Slithering -> "underbelly"
			Basic x | x `elem` [Biped, Naga] -> "hips"
				| x `elem` [Quadruped, Centaur] -> "flanks"
			f -> bodyFail FuckFace f
		/ "as you facefuck it, until your cock never really leaves the churning mess of tentacles, tight sucking coils always squeezing and milking your shaft."
		/ Paragraph / "You come with a groan, slamming "
		/ case locoplan b of
			Basic x | x `elem` [Biped, Naga] -> "its head down on your ink-streaked length "
				| x `elem` [Quadruped, Centaur, Slithering] -> "your ink-streaked length down into it "
			f -> bodyFail FuckFace f
		/ "with extra force for the final few thrusts before your entire body shudders, "
		/ hasBalls ? (hasExternalBalls
			? "balls churning in your sac, "
			?: "balls spasming inside you, ")
		/ "cock twitching and flaring as you erupt, gushing your load straight into the dark mass of the Ganzer worker's body. Each sloppy squirt is swallowed down easily into the hot, sucking darkness within it. Thinned ink churns down your shaft, spilling in a messy drool down your "
		/ case locoplan b of
			Basic Naga -> c "underbelly"
			Basic Slithering -> c "underbelly"
			Basic x | x `elem` [Biped, Quadruped, Centaur] ->
				c $ hasExternalBalls ? ("balls and" / sides)
			f -> bodyFail FuckFace f
		/ "."
		/ Paragraph / "The Ganzer worker shudders and gurgles, wet strings of slime gushing across its hand, splattering in droplets and lines "
		/ case locoplan b of
			Basic Biped -> c "across your calves"
			Basic x | x `elem` [Quadruped, Centaur] -> "across your" / feet
				| x `elem` [Naga, Slithering] ->
					"along your" / case bodySpecies Tail b of
						Just Snake -> "snaky"
						Nothing -> "wormlike"
						_ -> mempty
					/ "lower body"
			f -> bodyFail FuckFace f
		/ "as it comes too, in a few shuddering jerks, tentacles still squeezing and swallowing around your shaft."
		/ Paragraph / "You draw back, cock spilling from its mouth and slapping half-hard against your "
		/ case locoplan b of
			Basic Naga -> c "stomach"
			Basic Slithering -> c "stomach"
			Basic x | x `elem` [Biped, Quadruped, Centaur] -> c side
			f -> bodyFail FuckFace f
		/ ", covered in splotchy lines of ink, still dribbling slowly; a tentacle licks out to swipe across your cockhead, collecting a fat dewdrop of come. It kind of grins up at you, gurgling with every breath, and slowly pulls its fan of tentacles back into its helmet."
	] <> fuckedEnding b g

eatOut :: MarkedScene Index () GanzerSoldier
eatOut b g =
	[ Narration2 $
		case locoplan b of
			Basic x
				| x `elem` [Biped, Centaur, Naga] -> "The Ganzer worker sags back, shoulders braced against the wall behind, hips jutting out, obscenely on display -- its fingers shove into its now-spread vent, clear slime slicking down its hand and dragging out into long, jiggling lines across the underside of its hand. The flesh under its vent is bulging hard, vein-riddled armor distended, and it's easily sliding three fingers back and forth, working its vent wider and wider."
				-- quadruped / slithering
				| x `elem` [Quadruped, Slithering] -> "The Ganzer worker spreads its legs wider, arm moving out of the way so you can press your head against its vent, tongue lolling from your mouth to drag a slobbery streak across its hand, three of its fingers shoved inside, pumping back and forth. It tastes of salt, bitter like an underripe fruit."
			f -> bodyFail EatOut f
		/ Paragraph / case locoplan b of
			Basic x
				| x `elem` [Biped, Centaur, Naga] -> do
					case x of
						Centaur -> "You fold your legs beneath your animal body and drop down to let you run your hands over its legs, and then "
						Biped -> "You drop to your knees, hands running up its legs, and "
						Naga -> "You let your upper body sink lower, coils churning all around you, and "
						f -> bodyFail EatOut f
					"press your face against the junction of its thighs, "
					case bodySpecies Head b of
						Just Snake -> "tasting its flesh in ever-increasing flits of your tongue"
						_ -> "lapping up a trail of clear slime drooling down over the thick, corded veins"
					"until you bump against its hand. It tastes of salt, bitter like an underripe fruit. "
				| x `elem` [Quadruped, Slithering] -> "Its vent is spread wide, clear slime slicking down its hand and dragging out into long, jiggling lines along the back of its palm. The flesh under its vent is bulging hard, vein-riddled armor distended. "
			f -> bodyFail EatOut f
		/ "You curl your tongue over its fingers, slowly sliding in to replace them as it pulls away and pats"
		/ case mouthType b of
				Mouth -> c "the side of your face"
				_ -> "your" / muzzle
		/ "with its slime-streaked hand. You kiss its vent, sloppy, open-mouthed, a roll of thick, slick fluid spilling over your tongue."
		/ Paragraph / "It's feverishly hot inside, muscles convulsing and pumping sloppy gushes of glistening ooze, slime spilling down the walls of its vent. Flesh slides against flesh, spreading its vent to gaping, as its spur slowly spills out, a broad inverted-V shape pressed against the upper arch of its vent, swollen so thick it only pushes out in tiny, fractional increments, each one coaxing a gurgling moan from the Ganzer worker. Its spur is the same pallid white as the rest of its inner flesh, save for the tip of the ridge; that's flushed a murky grey-purple, its black spiderweb veins branching under the surface. Its fingers tug against the back of your head as you lap across its inner walls, tongue sliding across the smooth flesh of its spur."
		/ hasArms ? "You rub your hands over its trembling thighs, thumbs digging into the chitin plates cracked around its gaping vent and tugging them wider, your tongue swiping up and down across its rim."
		/ Paragraph / "The tip of its spur digs against the arch of its vent, pushing out in shuddering lurches, flesh clenching down against your tongue. The spur has a sharp tip, not all that unlike its stinger -- a sharp point that fans out to a thick spade-shaped wedge -- but below that it folds over itself, forming thick, rubbery swells of flesh, each one bulging the rim of its gaping vent before its flesh peels away, unsheathing another swooped ridge. A thick groove runs down the underside, each flex sealing it closed for a moment, forming a tube that spurts slime up to the tip, where it gushes out in messy bursts, hot droplets splattering all across your skin."
		/ Paragraph / "Its hand"
		/ case bodySpecies Head b of
			Just Human -> c "digs into your scalp"
			Just x -> "cups your" / animalName x / "head"
			Nothing -> c "cups your head"
		/ ", tugging you up -- "
		/ case mouthType b of
			Mouth -> c "nose"
			_ -> c muzzle
		/ "grinding against the underside of its spur, sloppy gushes of slimy fluid drooling down its length and spilling across your face. It gurgles out a growl, head thrashing side to side, hips rutting up in sharp motions, smearing the flesh of its vent across your face"
		/ case bodySpecies Head b of
			Just Human -> ", spur drooling into your hair"
			_ -> mempty
		/ "."
	, Choices
		[ ("keep going until it blows", BlowHim)
		, ("hey how abt you fuck me w/ this", GetFucked)
		]
	]

blowHim :: MarkedScene Index () GanzerSoldier
blowHim b g =
	[ Narration2 $
		"Its spur unsheathes more; not particularly long but incredibly fat. The chitin across its stomach bulges out hugely, the white webbing between the slabs stretched into straining curves. Its tumescent flesh shudders, each motion forcing another ridge of its spur out into the open, jutting out like an immense stinger, the grooved underside steadily pulsing, pumping clear slime up to stream from the tip."
		/ case bodySpecies Head b of
			Just Human -> "Slime coats your hair, spilling down"
			_ -> "Slime spills down"
		/ case mouthType b of
			Mouth -> c "the sides of your face, "
			_ -> "your" / muzzle / ","
		/ "all but tethering your head to its crotch, vent gaping, pallid white flesh clenching and then spreading, gnarled lips spitting out ooze to splatter across your face."
		/ Paragraph / "Its hand clenches, fingers digging against your skull, tipping you up as it ruts across your face, sloppy spur dragging back and forth, unsheathed muscle iron-hard, hardly giving at all when it grinds down. Its gurgles sound the same as the slime spilling from its vent, all wet" / em "plaps" / "and bubbling noises, black froth building up across its teeth, lines of ink spilling down its chin, dribbling in dots and lines down its chest."
		/ Paragraph / "It groans loud, the sound just more gurgling, its tentacle-tongues spilling over its teeth and curling against the air. Its spur shudders, sides flexing, groove flexing against your tongue. A mass of slime gushes out, all but drenching your face, and then another, before it bucks forwards once more, hard, pinning your face against the underside of its spur. Its inner walls shudder and clench, spasms running up its spur, and it unloads with a mass of black froth."
		/ Paragraph / "Thick bubbles bulge the length of its spur, gristly muscle flexing around them as its rhythmic spasms pump them one after the other from the tip, thick-walled bubbles sloshing with black ink, near-opaque slime coating them in dangling tails, slapping across your face as it pumps a few dozen out, one after another, rutting its spur against your head the whole time until you're sopping wet, wet" / em "plaps" / "sounding as streamers snap and splatter down "
		/ case locoplan $ b of
			Basic Biped -> "your chest and legs"
			Basic Naga -> "your chest and tail"
			Basic Slithering -> "your body"
			Basic Centaur -> "your chest and folded forelegs"
			Basic Quadruped -> case bodyHeight b of
				SmallAnimal -> "your chest and forelegs"
				_ -> "your chest and folded forelegs"
			f -> bodyFail BlowHim f
		/ "."
		/ Paragraph / "It pulls back, fingers digging along the underside of its spur, reaching up inside the channel to tug on a bubble that got stuck, peeling it out with a wet squelch and then flinging it aside. It settles down, chest heaving, breath coming from its body in heavy, wet gurgles."
	] <> fuckedEnding b g

getFucked :: MarkedScene Index () GanzerSoldier
getFucked b g =
	[ dialog g $
		"Hey, sure."
	, Narration
		[ "The Ganzer worker pulls back, leaving sloppy cords of slime drawing out between your face and its spur."
		]
	, dialog g $ case locoplan b of
		Basic Biped -> "Get on your hands and knees."
		Basic Naga -> "Lie back."
		Basic Quadruped -> "Turn around and show me that ass."
		Basic Centaur -> "Turn around and show me that ass."
		Basic Slithering -> "Rut against me."
		f -> bodyFail GetFucked f
	, Narration2 $ case locoplan b of
		Basic Biped -> do
			"You get on your hands and knees."
			/ Paragraph / "The Ganzer worker moves around you, keeping one hand planted on your back, slowly dragging down your spine."
		Basic x | x `elem` [Naga, Slithering] ->
			case x of
				Naga -> "You lie back against the side of your own long tail"
				Slithering -> "You slither forward"
				f -> bodyFail GetFucked f
			/ (hasDick
					?
						(", your"
						/ case cockCount b of
							1 -> "cock"
							2 -> "twin cocks"
							_ -> "cocks"
						/ "jutting up"
						/ case dickLocation b of
							Just DickExternal -> mempty
							Just DickSheathed -> "from your sheath"
							Just _ -> "from your spread slit"
							Nothing -> mempty
						/ (hasAsshole ? ", just above the tight pucker of your asshole")
						/ ".")
					?: ("," / ("putting the tight pucker of your asshole on display"^cloaca "putting your flushed cloacal slit on display") / ".")
					)
				/ (not . hasAsshole) ? ("The Ganzer worker reaches out, flat-capped fingers leaving smears of slime as it trails them over your flushed slit, digging in, and you rut against it"
					/ hasDick ? (", grinding your" / Dick^s / "against its hand")
					/ ".")
			/ Paragraph / "The Ganzer worker touches down your sides, sliding"
				/ case bodyMat_ (Waist Fore) b of
					Solid (FMat _ Scales) -> c "down your scales"
					Solid (FMat _ Fur) -> c "through your fur"
					Solid (FMat _ Coat) -> c "through your coat"
					Solid _ -> c "down your body"
					Trans (FMat _ t) (FMat _ b) ->
						"over"
						/ case t of
							Skin -> "the skin of your stomach"
							Fur -> "your ruffled fur"
							Coat -> "your sleek coat"
							_ -> "your stomach"
						/ "and then"
						/ case b of
							Scales -> "the smooth scales of your underbelly"
							_ -> "down lower"
				/ ", flat-capped fingers leaving smears of slime. It steps closer, spur digging hot against the side of your coils, and then straddles you, rubbing its spur across your underbelly."
		Basic x | x `elem` [Quadruped, Centaur] ->
			"You turn around. It glides its hand down your sides as you move, ending with its hand splayed against your flank, thumb digging against your hole."
			/ hasBalls ?
					((hasExternalBalls
						? " Your balls shudder and twitch in their loose sac "
						?: " Your ball clench and squeeze internally ")
					/ "as the Ganzer worker rubs its fingers against your tight asshole"
					/ hasDick ? (", your" / unsheathed / "cock dribbling onto the ground")
					/ "."
					)
			/ Paragraph / "It moves closer, spur touching the back of one thigh for a brief instant before it presses against your hole. "
			/ hasTail
					? "The Ganzer worker grabs your tail with its other hand and gently tugs it aside, fingers sliding"
					?: "The Ganzer worker slides its fingers"
			/ "from your ass cheeks to your hole, smearing its mess of pre around and then -- bearing down -- inside, as its finger pushes through, asshole clenching against the intrusion."
		f -> bodyFail GetFucked f
	, Narration2 $
		"Its spur is enormous: not particularly long, but immensely broad, jutting out from its gaping cloaca in a sharp inverted V, its hole continually drooling gushing streams of clear, thick slime. Its spur pulses, pumping slime up its underside, and now splattering "
		/ case locoplan b of
				Basic x | x `elem` [Quadruped, Centaur] -> c "over your asshole, syrupy cords splattering against your thighs and balls, streaking down your flanks. "
					| x `elem` [Biped, Naga, Slithering] ->
						"across your"
						/ case x of
							Biped -> "lower back"
							_ -> "underbelly"
						/ case bodyMat_ Chest b of
							Solid (FMat _ Skin) -> ", puddling and then spilling over your skin"
							Solid (FMat _ Fur) -> ", drenching your thick fur into matted tassels"
							_ -> mempty
						/ "."
				f -> bodyFail GetFucked f
		/ (let (pooling, drags, smearing) = if locoplan b `elem` [Basic Quadruped, Basic Centaur]
				then (mempty, "smears ", "working")
				else ("pooling ", "drags handfuls of ", "smearing ")
			in "The Ganzer worker brings its hand down, smearing through the " / pooling / "slime, and " / drags / "it down, " / smearing / "it ")
		/ case locoplan b of
			Basic Biped -> c "between your cheeks"
			_ -> c $ "over your hole"^cloaca "over your flushed lips"
		/ ". Its armored fingers are thick,"
		/ hasAsshole
			? "digging against your asshole"
			?: ("parting your lips "
				/ hasDick ? ("even wider than your" / Cock^s / Does^s)
				)
		/ ", working slime up and down. It bears down, finger sliding in with a hot rush, a second already wedged next to it, shoving in alongside."
		/ Paragraph / "It could fit its entire hand in your"
		/ (hasAsshole ? "ass" ?: "cloaca")
		/ "and that still wouldn't be as wide as the broad, punishing width of its spur, though."
		/ Paragraph / "Still, it pulls its fingers out, using both hands to pry your "
		/ case locoplan b of
			Basic x | x `elem` [Biped, Centaur, Quadruped] -> "cheeks"
			_ -> if hasAsshole b
				then "asshole "
				else "vent"
		/ "wider, fingertips teasing over the rim "
		/ case locoplan b of
			Basic x | x `elem` [Biped, Centaur, Quadruped] -> "of your hole "
			_ -> mempty
		/ "as it comes closer, smearing the sharp, pointed tip of its spur against your hole, pumping sloppy gushes of slime all over" / ("your ass"^cloaca "your slit") / ", sloppy cords spilling"
		/ case locoplan b of
			Basic x | x `elem` [Biped, Centaur, Quadruped] -> "down your" / sides
				| x `elem` [Naga, Slithering] -> c "down your underbelly"
			f -> bodyFail GetFucked f
		/ hasBalls ? "and hanging from your balls "
		/ "as it"
		/ case bodyMat_ (Waist Hind) b of
			Solid (FMat _ Skin) -> "layers gush after gush of slime over your skin"
			Solid (FMat _ Fur) -> "soaks your fur with gush after gush of slime"
			_ -> "spills down your body"
		/ ". The tip digs inside, that much going in easily, and then it bears down, spur just getting wider and wider as it goes"
		/ ((\b -> not (hasAsshole b) && cockCount b > 0) ? ", sliding roughly against the root of your cocks as it bears down harder")
		/ ". It ruts into you, thrusting the first few inches back and forth, fingers sliding along the hollow of its underside to curl over the rim of your hole, gently tugging you wider."
		/ Paragraph
		/ case locoplan b of
				Basic x | x `elem` [Naga, Slithering] ->
					"You groan, "
					/ case x of
						Naga -> "reaching out to wrap your hands over its shoulders, tugging it closer -- "
						_ -> mempty
					/ "pressure bearing down as it shifts its weight forward, spur sinking deeper into" / ("your ass"^cloaca "your cloaca") / "with a wet slurp. Your hole gapes, spread wide enough to catch half of each messy spurt of slime, the rest spilling all down your underbelly. It thrusts"
					/ case bodyMat_ Tail b of
						Solid (FMat _ Scales) -> ", thighs clenching over your scales"
						_ -> mempty
					/ ", spur working inside you, fingers digging into your"
					/ case x of
						Naga -> "hips"
						Slithering -> "sides"
						f -> bodyFail GetFucked f
					/ "."
				Basic Biped -> c "You groan, head and shoulders pressed against the ground, panting and whining each time it bears down, testing the stretch of your hole against its ever-widening spur. Your hole gapes, more than half of its slimy pre squirting right into your ass, the rest spurting across your cheeks, spilling down in messy gurgles. "
				Basic x | x `elem` [Quadruped, Centaur] -> "You" / groan / "and push back, nearly knocking the Ganzer worker to the ground. It steadies, hands gripping your" / "ass"
					-- / animalAss -- ??
					/ ", grinding forward. Its voice buzzes and gurgles as your asshole spreads, fat lips slurping over more and more of its brutally-wide spur. "
				f -> bodyFail GetFucked f
			/ "It works its spur deeper in sliding increments, hardly a fraction of it in you. Your hole is stretched taut, clenching and spasming, only to be broken wider when its spur shudders and flexes, its sides bending out, straightening the sharp arch of its inverted-v into something flatter and that much wider. "
			/ case locoplan b of
				Basic x | x `elem` [Quadruped, Centaur] -> "The bottom rim of your hole gapes, half spilling-out with no pushback from the hollow underside, just a constant burble and patter from its messy gushes of slime, churning and gurgling as more spills into your hole and the rest flecks your flanks, spilling down your legs in thick streams."
				_ -> mempty
		/ Paragraph / "The space between you is a mess of slime, gushing from its cloaca and corded all up and down "
			/ case locoplan b of
				Basic Biped -> "your ass and thighs, "
				Basic x | x `elem` [Naga, Slithering] -> "your underbelly, spilling all down your sides in syrupy streams, "
				Basic x | x `elem` [Quadruped, Centaur] -> "your hind legs, "
				f -> bodyFail GetFucked f
			/ "finger-thick ropes intersecting and smearing together, being dragged out in frothy, bubbling planes of viscous ooze, squelching and slurping every time either of you move."
		/ Paragraph / "The Ganzer worker fucks you, not even half its spur inside you, each thrust breaking your hole a fraction wider, spur gliding back and forth through the wet, oozing mess of its own slime. It gurgles, "
			/ case locoplan b of
				Basic x | x `elem` [Naga, Slithering] ->
					"inky tongue-tentacles spilling from its mouth, and"
					/ case x of
						Naga -> "you tug on its shoulders"
						Slithering -> "you tug your loop around its neck down"
						f -> bodyFail GetFucked f
					/ ", pulling it"
					/ case x of
						Naga -> "down"
						Slithering -> "in"
						f -> bodyFail GetFucked f
					/ "for a slick kiss, your mouth flooded with the bitter taste of its ink."
				Basic x | x `elem` [Biped, Centaur, Quadruped] -> c "droplets of ink drooling down onto your back in sudden splatters, clumps of froth building up over its glass teeth and then slowly peeling away to rain down on you."
				f -> bodyFail GetFucked f
		/ Paragraph / "Its thrusts grow ragged, the spasming clench of its cloaca coming stronger and stronger, squirting and gushing slime all across "
			/ case locoplan b of
				Basic Naga -> "your underbelly, "
				_ -> "your ass, "
			/ "all into"
			/ hasAsshole
				? "your ass, ooze spilling inside you as a hot, heavy weight, churning and gurgling as it slowly floods your guts"
				?: (
					"your cloaca, ooze spilling"
					/ hasDick
						? ("along the root of your" / Shaft^s)
						?: "inside you"
					/ "in a hot, heavy weight, gurgling as it slowly floods your guts"
					)
			/ ". It comes with a groan, breath popping from its throat, spur flexing hard enough inside you to make you wail" -- wail
			/ case locoplan b of
				Basic x | x `elem` [Naga, Slithering] -> " into its mouth"
				_ -> mempty
			/ ". It pumps hard, forcing thick, slimy bubbles of heavy slime into" // ("your ass"^cloaca  "your cloaca") / ", each one with a long tail of dense, congealed ooze -- again and again, bubbles shoving against your gaping hole and sinking inside only when the next bubble forces it in, some of them bursting out from the groove on the underside of its spur and spilling "
			/ case locoplan b of
				Basic x | x `elem` [Naga, Slithering] -> "down your underbelly, "
				Basic Biped -> "down your thighs, "
				Basic x | x `elem` [Quadruped, Centaur] -> "down your flanks, "
				f -> bodyFail GetFucked f
			/ "slowly, nearly glued to your skin from the mess of slime stuck all over you."
		/ Paragraph / "It collapses on top of you with a groan, tentacle-tongues lazily "
			/ case locoplan b of
				Basic Biped -> "dragging across your shoulders, "
				Basic x | x `elem` [Naga, Slithering] -> "coiling in your mouth, twisting against your tongue, "
				Basic Quadruped -> "pressing wet inky kisses up your back, "
				Basic Centaur -> "twisting your upper body around to press a sloppy kiss against your neck and jaw, "
				f -> bodyFail GetFucked f
			/ "spur shuddering as it spits the last of its heavy, slimy load into and across" // ("your ass"^cloaca "your cloaca") // ", fingers sliding up the underside of its spur to catch the last few bubbles and shove them into your gaping, wrecked hole as it pulls out"
			/ case locoplan b of
				Basic x | x `elem` [Biped, Naga, Slithering] && hasDick b -> ", absently tugging on your flushed, slime-coated" / Cock^s
				_ -> mempty
			/ "."
	] <> fuckedEnding b g

fuckedEnding :: MarkedScene Index () GanzerSoldier
fuckedEnding b g =
	[ Dialog "/static/img/icon.png" "Ganzer Worker"
		[ "Yeah."
		, "Yeah, that was good."
		]
	, Narration
		[ "It takes a few wobbling steps back and settles down, spurs still a huge spike bursting out from its straining cloaca, sluggishly drooling clear slime in ropy strands."
		]
	] <> finalEnding b g

finalEnding :: MarkedScene Index () GanzerSoldier
finalEnding _ _ =
	[ Dialog "/static/img/icon.png" "Ganzer Worker"
		[ "That was worth the time it took at least."
		, "I gotta get back to work, but hey if you come through again, stop by, huh?"
		]
	, FauxChoice "uh sure"
	, Dialog "/static/img/icon.png" "Ganzer Worker"
		[ "Well later."
		]
	]

{-

chitin peels open over his dick and he starts trembling and gurgling continually & black froth spills out the side of his visor. his dick's like white/grey w/ dark black veins w/ clear pre. he comes real thick chunky grey goo


bulging outwards, the chitin hot to the touch, and almost buzzing from the internal pressure. its flesh parts in a series of shuddering cracks, the lump of its cock straining against the growing seam until in a single lurch it spears outward, glistening ropes of translucent slime pouring from the split seam and spilling down its legs in a wash


a huge cock, the whole thing oval-shaped, the middle twice as thick as the tip or base. it's a grubby near-white, flesh smooth and unmarred save for squiggles of thick black veins. he reaches down and wraps his gauntleted hands around it and squeezes, pulpy flesh bulging out from the pressure, and his entire body shudders. sloppy gurgles come from his shattered visor

-}


{-
-- i think this is just duplicate for the getting fucked scene but this is backup in case i cut something out :VV

-- biped
You groan, head and shoulders pressed against the ground, panting and whining each time it bears down, testing the stretch of your hole against its ever-widening spur. Your hole gapes, more than half of its slimy pre squirting right into your ass, the rest spurting across your cheeks, spilling down in messy gurgles. It thrusts, working its spur back and forth, hardly a fraction of it in you. Your hole is stretched taut, clenching and spasming, only to be broken wider when its spur shudders and flexes, its sides bending out, straightening the sharp arch of its inverted-v into something flatter and that much wider.

The space between you is a mess of slime, gushing from its cloaca and corded all up and down your ass and thighs, finger-thick ropes intersecting and smearing together, being dragged out in frothy, bubbling planes of viscous ooze, squelching and slurping every time either of you move.

The Ganzer worker fucks you, not even half its spur inside you, each thrust breaking your hole a fraction wider, spur gliding back and forth through the wet, oozing mess of its own slime. It gurgles, droplets of ink drooling down onto your back in sudden splatters, clumps of froth building up over its glass teeth and then slowly peeling away to rain down on you.

Its thrusts grow ragged, the spasming clench of its cloaca coming stronger and stronger, squirting and gushing slime all across your ass, all into your ass, ooze spilling inside you as a hot, heavy weight, churning and gurgling as it slowly floods your guts. It comes with a groan, breath popping from its throat, spur flexing hard enough inside you to make you wail. It pumps hard, forcing thick, slimy bubbles of heavy slime into your ass, each one with a long tail of dense, congealed ooze -- again and again, bubbles shoving against your gaping hole and sinking inside only when the next bubble forces it in, some of them bursting out from the groove on the underside of its spur and spilling down your thighs, slowly, nearly glued to your skin from the mess of slime stuck all over you.

It collapses on top of you with a groan, tentacle-tongues lazily dragging across your shoulders, spur shuddering as it spits the last of its heavy, slimy load into and across your ass, fingers sliding up the underside of its spur to catch the last few bubbles and shove them into your gaping, wrecked hole as it pulls out.

-- naga
You groan, reaching out to wrap your hands over its shoulders, tugging it closer -- pressure bearing down as it shifts its weight forward, spur sinking deeper into your ass with a wet slurp. Your hole gapes, spread wide enough to catch half of each messy spurt of slime, the rest spilling all down your underbelly. It thrusts, thighs clenching over your scales, spur working back and forth, fingers digging into your hips.
	It thrusts, working its spur back and forth, hardly a fraction of it in you. Your hole is stretched taut, clenching and spasming, only to be broken wider when its spur shudders and flexes, its sides bending out, straightening the sharp arch of its inverted-v into something flatter and that much wider.

	The space between you is a mess of slime, gushing from its cloaca and corded all up and down {your ass and thighs // your underbelly, spilling all down your sides in syrupy streams}, finger-thick ropes intersecting and smearing together, being dragged out in frothy, bubbling planes of viscous ooze, squelching and slurping every time either of you move.

	The Ganzer worker fucks you, not even half its spur inside you, each thrust breaking your hole a fraction wider, spur gliding back and forth through the wet, oozing mess of its own slime. It gurgles
		{, inky tongue-tentacles spilling from its mouth, and you tug on its shoulders, pulling it down for a slick kiss, your mouth flooded with the bitter taste of its ink.}
		{, droplets of ink drooling down onto your back in sudden splatters, clumps of froth building up over its glass teeth and then slowly peeling away to rain down on you.}

	Its thrusts grow ragged, the spasming clench of its cloaca coming stronger and stronger, squirting and gushing slime all across {your ass // your underbelly}, all into your ass, ooze spilling inside you as a hot, heavy weight, churning and gurgling as it slowly floods your guts. It comes with a groan, breath popping from its throat, spur flexing hard enough inside you to make you wail {into its mouth}. It pumps hard, forcing thick, slimy bubbles of heavy slime into your ass, each one with a long tail of dense, congealed ooze -- again and again, bubbles shoving against your gaping hole and sinking inside only when the next bubble forces it in, some of them bursting out from the groove on the underside of its spur and spilling {down your thighs // down your underbelly}, slowly, nearly glued to your skin from the mess of slime stuck all over you.

	It collapses on top of you with a groan, tentacle-tongues lazily {dragging across your shoulders, // coiling in your mouth, twisting against your tongue, }spur shuddering as it spits the last of its heavy, slimy load into and across your ass, fingers sliding up the underside of its spur to catch the last few bubbles and shove them into your gaping, wrecked hole as it pulls out.




-}