{-# LANGUAGE MultiParamTypeClasses #-}
module Sites.Hell.Events.Hubur.Humbaba
	( Humbaba(..)
	, deck
	, scene

	, name
	, bits
	, variants
	) where

import Prelude hiding ((/), (^))

import Sites.Hell.Events.SceneUtils hiding ((/))
import Sites.Hell.Events.Construction ((/))

import Sites.Hell.Events.Hubur

name :: String
name = "humbaba"

data Humbaba = Humbaba
	deriving (Eq, Ord, Show, Read)

instance Random Humbaba where
	randomR _ = random
	random = getRand $ pure Humbaba

instance ToJSON Humbaba where
	toJSON Humbaba = object
		[ pack "name" .= name
		, pack "data" .= ([] :: [Int])
		]

bits :: Value -> Value
bits _ = object
	[ pack "name" .= name
	, pack "data" .= ([] :: [Int])
	]

variants :: [(MapZone, ())]
variants =
	[ (Glade, ())
	]
instance FromJSON Humbaba where
	parseJSON (Object vs) = case (parse (.: pack "name") vs, parse (.: pack "data") vs :: Result [Int]) of
			(Success pName, Success [])
				| pName == name -> return Humbaba
			_ -> mzero
	parseJSON _ = mzero

deck :: RandomGen g => Rand g (Enumerable Humbaba)
deck = return . pure $ Humbaba

data Index = Dummy
	deriving (Eq, Ord, Show, Read)

instance Scene Index () Humbaba where
	link f = case f of
		_ -> error "bad link"

	display = fmap toLower . show
	vardisplay = fmap toLower . show

scene :: Encounter Index () Humbaba
scene b z = describe b z -- <> error "bad scene"

--- actual event start

describe :: Encounter Index () Humbaba
describe _ z =
	[ Narration2 $ "A mighty Humbaba-beast."
		/ Paragraph / "He stands on two legs, but runs on all fours. His entire body is coarsely haired, with thick wedges of spiny scales surfacing between the hair in chunky curves across his shoulders, sides, and hips. His hands are immense paws, like a lion's, and his feet are massive talons, like a vulture. He has a pair of wickedly-sharp horns jutting out from his head, swept forward so that he could gore his prey with a savage charge. His tail lashes behind him, covered in scales, and the tip ends with a snake's head, twisting and licking at the air."
		/ Paragraph / "His body is covered in brilliant, billowing auras, casting strange light all across the ground, illuminating it with his multi-colored radiances."
	]
