module Sites.Hell.Events.Hubur.LesserDemon
	( LesserDemon(..)
	, deck
	, scene

	, name
	, bits
	, variants
	) where

name :: String
name = "lesser demon"


data LesserDemon = Glowing GlowColor AccentGlowColor | Masked | Crystal | Asymmetrical | Withered
	deriving (Eq, Ord, Show, Read)

data GlowColor = DullRed | Purple | Black | BlueBlack
	deriving (Eq, Ord, Show, Read)

data AccentGlowColor = BrightRed | Pink | RoyalPurple | Blue | Yellow
	deriving (Eq, Ord, Show, Read)

data GeneralAccept = MostlyHairless | CoarseHair Color | CraggyHide | Lanky | HugeBrawny | Musculed | Fat | LeatheryHide Color | DarkRedSkin
	deriving (Eq, Ord, Show, Read)
{-accent:
	mostly hairless
	with tufts of coarse {coloration} hair on its shoulders and elbows
	covered in craggy, leathery hide
	lanky
	huge and brawny
	thickly-muscled
	fat and round-bodied
	with leathery {green | grey} hide
	with dark red skin

-}


{-
instance ToJSON LesserDemon where
	toJSON ... = object
		[ pack "name" .= name
		, pack "data" .= ([] :: [Int])
		]

bits :: Value -> Value
bits _ = object
	[ pack "name" .= name
	, pack "data" .= ([] :: [Int])
	]
-}

variants :: [(MapZone, ())]
variants =
	[ (FactoryQuarry, ())
	, (FactoryProcessing, ())
	, (FactoryResearch, ())
	]
{-
instance FromJSON LesserDemon where
	parseJSON (Object vs) = case (parse (.: pack "name") vs, parse (.: pack "data") vs :: Result [Int]) of
			(Success pName, Success [])
				| pName == name -> return Asakku
			_ -> mzero
	parseJSON _ = mzero
-}

deck :: RandomGen g => Rand g (Enumerable LesserDemon)
deck = do
	liftRand $ shuffle
		$ mconcat
			[ pure $ Glowing DullRed BrightRed
			, Glowing Purple <$> [Pink, RoyalPurple]
			, Glowing Black <$> [Blue, Yellow]
			, pure $ Glowing BlueBlack Blue
			]

{-

DEMON {
	skincolor = <skincolor>
	desc = It's a glowing demon. It's humanoid, <accent>, wiuth thick claws and a pair of gnarled horns. Its skin is $skincolor, and its extremities -- forearms, calves, and horns -- <dappling> $skincolor.tinge and glow with a pale light.
}
dappling = are dappled | are ringed with | smoothly fade into
skincolor = dull red | purple | black | blue-black | green | grey

dull red {
	tinge = bright red
}
purple {
	tinge = pink | royal purple | green
}
black {
	tinge = pallid white | blue | yellow | purple
}
blue-black {
	tinge = blue | purple
}
green {
	tinge = light green | purple
}
grey {
	tinge = ashen | black
}

-}

{-
it's a glowing demon. it's humanoid, {accent}, with thick claws and a pair of gnarled horns. it's got {dull red | purple | black | blue-black | green | grey } skin, and its extremities -- forearms, calves, and horns -- are dappled {bright red | {pink | royal purple | green} | {blue | yellow} | blue | {light green | purple} | <ashen | black> } and glowing.

it's a masked demon. it's humanoid, {accent}, and wearing a
	{{grey stone | purple obsidian} mask,
		{ carved or maybe naturally formed in a mess of circling ridges around a central opening, not the right placement for an eye or a mouth
		| with two rows of tiny dots struck through it, none the right placement for an eyehole}
	| black iron mask,
		{in the shape of a gruesome leering face
		| completely featureless}
	| copper mask
			{in the shape of a shining sun with long metal rays
			| in the shape of a gibbous moon
			| in the shape of an asymmetrical starburst}
		, gone green with verdigris
	| gold mask
		{of an androgynous humanoid with a {placid | tragic | beautific} expression}
	| round wooden mask, {striped with paint | laquered and shiny}, but completely featureless
	}
	that entirely covers its face
	{ , with a pair of upright horns that stick out over top
	| , save for a pair of long tufted ears that stick out over top
	| , save for a shaggy, goatlike beard that spills from the bottom}.

it's a crystal-reinforced demon. it's humanoid, and built to giant scale,
		{
				{ with legs made of crystal-machinery and fashioned like a goat's
				| with a left arm fashioned from crystal-machinery, forearm bloated out in a lozenge like a built-in buckler shield}
			, inner area a cloudy purple-black, facets on the surface catching the light, all etched with glyphs in glowing red.
		| with a crystal right arm that's hugely oversized, fashioned into a massive weapon somewhere between a pile bunker and harpoon. cooling components glow beneath its crystalline skin, the surface etched all over with glyphs in burning red.
		}
		even beyond that, its body is half-rebuilt with machine parts,
		-- pick two:
			{ opaque glass fitted over its eyes in a visor
			| crystalline conducting rods sunk into the flesh of its back, in four pairs from shoulder to hip
			| muscles reinforced, grown hypertrophic from half-surfaced crystalline structures poking through its skin
			}.

it's an asymmetrical demon, mostly humanoid, {asymmetrical accent} and
	{ left arm twice the size as the right, brutish knuckles scraping across the ground
	| three-armed, both left arms small and withered}.

it's a withered demon, humanoid but so gnarled and folded in on itself that it's stick-thin and hardly half as tall as a human.

it's a hulking purple demon with a skull for a head. its leathery hide is pockmarked with rough spots, like acid burns.




-- some of these would only apply to some of the types
accent:
	mostly hairless
	with tufts of coarse {coloration} hair on its shoulders and elbows
	covered in craggy, leathery hide
	lanky
	huge and brawny
	thickly-muscled
	fat and round-bodied
	with leathery {green | grey} hide
	with dark red skin

asymmetrical accent
	with <material adjective> <bonus part> all over its body
	with <wet material adjective> <wet bonus part> all over its body

material adjective:
	gnarled, serrated, branching, thick, glossy, tumescent, bulging, budding, translucent, overlapping, clustered, bloated, lopsided, fat, scaly, thorny, leathery, pulsing, blubbery, spotted, hairy

bonus part:
	horns, star marks, chitin plating, scars, hide, quills, veins, blisters, warts

wet material adjective:
	drooling, oozing, gaping, pustulent, crusted

wet bonus part: mouths, eyes, gills
-}
