{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleContexts #-}

module Sites.Hell.Events.Hubur.MinotaurMiner
	( MinotaurMiner(..)
	, Pref(..)
	, deck
	, scene

	, name
	, bits
	, variants
	) where

{-
TODO:

* there's no FuckJO support for centaur/quad/slithering, so they all jump to DeepPenetration. this is probably fine.

* read through for stage-2 parametricity; finish marking up bodytype shunts?? i don't know if there's anything still missing precisely


TO ADD:
* rimming scene

-}

import Prelude hiding ((/), (^))

import Data.Maybe (catMaybes, isJust)

import Server.JSON
import Sites.Hell.Events.SceneUtils hiding ((/))
import Sites.Hell.Events.Construction ((/), (^))

import Sites.Hell.Events.Hubur

import Description.TfNode (Animal(..))

name :: String
name = "minotaurminer"

data MinotaurMiner = MinotaurMiner
	{ pref :: Pref
	}
	deriving (Eq, Ord, Show, Read)

data Pref = Top | Bottom
	deriving (Eq, Ord, Enum, Bounded, Show, Read)

instance Random MinotaurMiner where
	randomR _ = random
	random = getRand $ MinotaurMiner <$> genRandom

deck :: RandomGen g => Rand g (Enumerable MinotaurMiner)
deck = do
	pref <- liftRand $ shuffle [Top, Bottom]
	return $ MinotaurMiner
		<$> from pref

instance ToJSON MinotaurMiner where
	toJSON (MinotaurMiner p) = object
		[ pack "name" .= name
		, pack "data" .= [fromEnum p]
		]

bits :: Value -> Value
bits _ = object
	[ pack "name" .= name
	, pack "data" .= [Null]
	]

variants :: [(MapZone, ())]
variants =
	[ (FactoryQuarry, ())
	, (FactoryMineTunnels, ())
	]
instance FromJSON MinotaurMiner where
	parseJSON (Object vs) = case (parse (.: pack "name") vs, parse (.: pack "data") vs) of
			(Success pName, Success [p])
				| pName == name ->
				case MinotaurMiner
					<$> safeToEnum p of
						Nothing -> mzero
						Just enc -> return enc
			_ -> mzero
	parseJSON _ = mzero

data Index
	= Talk Convo | Leave
	| CockSuck | CockShow Pref | FuckAss How
	| JO | GetFuckedChoices | Rim
	| DeepPenetration Via | FuckJO
	| Facial | FuckThroat
	| YouTop | FuckHim | FistHim
	deriving (Eq, Ord, Show, Read)

data Convo = Opener | HitOn | Nah
	deriving (Eq, Ord, Show, Read)

data How = Directly | FromBJ
	deriving (Eq, Ord, Show, Read)

data Via = ViaBiped | ViaQuad | ViaSnake
	deriving (Eq, Ord, Show, Read)

instance Scene Index () MinotaurMiner where
	link f = case f of
		Talk convo -> talk convo
		Leave -> leave
		CockSuck -> cockSuck
		CockShow pref -> cockShow pref
		FuckAss how -> fuckAss how
		Facial -> facial
		FuckThroat -> fuckThroat
		DeepPenetration via -> deepPenetration via
		FuckJO -> fuckJO
		JO -> jo
		GetFuckedChoices -> getFuckedChoices
		YouTop -> youTop
		Rim -> rim
		FuckHim -> fuckHim
		FistHim -> fistHim
	display = fmap toLower . show
	vardisplay = fmap toLower . show

dialog :: Convertible a EventReel => MinotaurMiner -> a -> Event MinotaurMiner Index ()
dialog _ = Dialog2 "/static/img/icon.png" "Minotaur Miner" . convert

scene :: Encounter Index () MinotaurMiner
scene b m =
	[ Narration2 $ "In the winding mine tunnels you come across a minotaur miner."
		/ Paragraph / "It's a big minotaur-looking thing that looks like it's mostly made out of cooling lava. It's using a drill that looks like it's made from black iron and lava to tear into the rock."
		/ Paragraph / description m
	, Choices
		[ ("hey whats up", Talk Opener)
		, ("just leave", Leave)
		]
	]

description :: MinotaurMiner -> EventReel
description m = "Its face is a gnarled whorl of semi-molten basalt, with glowing seams spiraling out from a central point. Its horns jut out on either side as big rocky crags. Its hooves, fingernails, and horns are made from rough, unhewn obsidian, a rich purple-black in color."
	/ Paragraph / "A thick ruff of coarse black hair covers its neck and chest, dusted so thickly with crushed coal that it seems to glitter dully. Its torso is mostly humanoid: deep black hide, inhumanly muscular. Across its shoulders and thighs thick veins of lava bulge up under its skin, and its hide thickens even further until it segments into rocky plates all over it arms and legs. Nubby spikes cover its rocky hide from the waist down, like an imitation of fur."
	/ Paragraph / "It's naked aside from the armor it's wearing: gauntlets and greaves of black iron. The metal is roughly-worked, and seems to have crystallized as it cooled: there are asymmetrical blotches of hexagonal iron prisms surfacing out of the metal. The armor is etched with glowing blue-black runes."

leave :: Encounter Index () MinotaurMiner
leave b m =
	[ Narration2 $ c "You turn back to your travel through the mines."
	]

talk :: Convo -> Encounter Index () MinotaurMiner
talk con b m = case con of
	Opener ->
		[ Narration2 $ "The minotaur stops its drill and looks your way. It's not really clear if it uses its faceless lava-gyre face to see, or if it's just being polite."
			/ Paragraph / "Its voice, when it speaks, is a grinding, crackling sound, like rocks being scraped together. The eye/mouth of its face convolves in time, waves of half-molten rock spilling out from the unblinking gyre at the center."
		, dialog m $ "Hey there, soul."
			/ Paragraph / "What brings you down here?"
		, FauxChoice "oh you know just looking around"
		, dialog m $ "Mm. And what have you seen?"
		, Choices
			[ ("well im currently seeing a big hot minotaur i wanna fuck around w/", Talk HitOn)
			, ("NAH, YOU KNOW, NOT MUCH ACTUALLY", Talk Nah)
			]
		]
	HitOn -> fuckPrompt b m
	Nah ->
		[ dialog m $ "It's a dim realm down here; not much besides rock and void."
		, Narration2 $ c "The minotaur shoulders its drill."
		, dialog m $ "Take care in the dark."
		]

{-
scene total: ~20

start:
	description, intro, miner mining coal w/ some lava pickaxe kinda thing
	-> hey you wanna fuck
		yea sure}
		there's a little dialog thing here w/ a choice/reponse that's basically like "do you want him to top or not" but like in dirty talk. also it would change depending on the minotaur's top/bottom/vers status. }
			X mino top}
				-> hell yeah (he tops)
				-> nah lemme show you my cock
					he's like, hey nice, stroking you both off if that's anatomically possible, and then like. you wanna get that in me, huh}
						-> yea (you top)
						-> nah fuck me (he tops)
			mino bottom: like spreading his legs & showily playing w/ his ass while his cock unsheathes all on its own, like, 'yeah u wanna play w/ my ass huh'}
				-> yeah gimmie yr ass (you top)
				-> hey lemme suck on yr cock
					he strokes himself off a lil and spurts some pre over yr face, smears it around w/ his fingers, like, so that's what you want huh}
						-> yeah cmon (he tops)
			mino vers if it exists would just be like. yea whattddya want, huh. my cock or my ass b/c i'm itching for both}
				-> lemme suck on yr cock
				-> fuck me
				-> lemme at that ass
		-> he tops
			~> SLITHERING
			he's like "look yr basically a cock sleeve how abt you just wind around my cock and swallow the whole thing"}
			so you do that}
			~> QUADRUPED
			& then he like tugs on his sheath until his cock starts to jut out and then just pulls yr head down so you can suck on it as it emerges from his sheath}
			then after a while he's like "yea you want me to cum in yr mouth or up yr ass"}
			-> ass
				he flips you around and shoves in and blows in like three or four strokes, after getting hilted}
			-> mouth
				he just tugs yr head down a little more and thrusts harder and then bellows when he cums}
			~> CENTAUR, BIPED, NAGAS
			& then he gropes himself and is like "how abt you get on yr knees first"}
			-> sure okay make out w/ his sheath / blow him
			then you slobber on his cock for a while}
			-> cum on my face
				he jerks off and hoses yr front down w/ glassy obsidian cum}
			-> cum down my throat
				he shoves you down until his sheath is pressed against yr face, which given his cock length means his cock isn't just down yr throat it's in yr stomach and probably down into yr guts.}
			-> fuck me
				~> BIPED, NAGAS
				he flips you backward and fucks you on yr back, like, flooding yr guts w/ glowing glass pre}
				then he cums and it's v. hot and yr basically flooded w/ magma}
				afterwards he jerks you off w/ three fingers shoved up yr ass (or in yr cloaca, if applicable)}
				~> CENTAUR
				he turns you around and fucks yr ass}
				then he cums and it's v. hot and yr basically flooded w/ magma}
				afterwards he jerks you off w/ three fingers shoved up yr ass (or in yr cloaca, if applicable)}
		-> you top
			~> BIPED, NAGAS, CENTAUR
			he's like braced against the wall w/ his back to you and you tug on his balls and play w/ his ass}
			-> fist him
				you shove like a fist in his ass}
				-> try to work yr other hand in
					big ol gaping ass, wetly sucking on yr fists. he cums all over the wall}
				-> shove in bicep deep
					see above only more w/ yr shoulder pressed against his cheeks as you tug and squeeze on his burning-hot guts}
			-> fuck him (centaur would get the quadruped branch below)
				you line up yr dick(s) and shove inside, all bending him over etc, boiling pre burbling out and steaming away etc etc}
			~> QUADRUPED
			you mount him and just fuck him hard while his arms are braced against the wall, pushing back at you}
			~> SLITHERING
			-> slither all up inside his ass
				you totally bust his ass cramming half yr body inside and he cums all over himself + yr dicks (if present) erupt all across his ass and legs}
			-> fuck him
				you do the usual "wrap him up in yr coils" thing and then just cram a cock or two inside}
-}

-- FIXME: this is gonna explode on pcs w/ no dicks + bottom minotaurs. there's a kludge so if you don't have a dick it just uses the top scene, but like. that seems less than ideal.
fuckPrompt :: Encounter Index () MinotaurMiner
fuckPrompt b m = case locoplan b of
	x | x `elem` [Spec Orb, Spec FloatingDick, Spec FloatingHead, Basic Formless, Basic Complex] -> bodyRejection b m
	_ -> case pref m of
		Bottom | isJust (dickLocation b) ->
			[ dialog m $ "Oh yeah? Let's see what you got."
			, Jump $ CockShow Bottom
			]
		_ ->
			[ Narration2 $ c "He snorts."
			, dialog m $ "I've heard worse."
				/ Paragraph / "I'm down, if you can take what I've got."
			, Narration2 $ "He props his drill against the cavern wall and stands straight up, facing you. Standing like that, it's impossible to miss his sheath: jutting out from his body, hanging fat and heavy between his thighs, the most animal part of him. It hangs low, drooping down from its own weight, and his balls hang even lower beneath, big fist-sized -- his fists -- orbs, hanging asymmetrically, lurching now as the flesh of his sac starts to tense and furrow."
				/ Paragraph / "He reaches down and wraps one gauntleted hand around his sheath, gives it a shake, and his balls shake with it, audibly clapping against his thighs. The wrinkled tip of his sheath bulges out in a fat knob, his hand tugging his loose flesh back and forth. The very tip of his cock unsheathes, a gnarled lump of flesh that tugs his opening sheath out into a teardrop shape. He coaxes a single bead of pre out: thick and clear, dimly incandescent from the heat of his body."
			, dialog m $ "What're you after?"
			, Narration2 $ c "He gives his cock another tug and shake, the gnarled ridge of his knobby cockhead pushing out from the folds of his sheath, slurping wetly."
			, Choices $ catMaybes
				[ guardC (hasHead b) ("how abt i suck on yr dick for a bit", CockSuck)
				, if hasNagaCloaca b
					then Just ("i want yr cock in my cloaca", FuckAss Directly)
					else Just ("i want yr cock in my ass", FuckAss Directly)
				, guardC (hasDick b) ("lemme show you my cock", CockShow Top)
				]
			]

bodyRejection :: Encounter Index () MinotaurMiner
bodyRejection b m =
	[ dialog m $ "Y'know I'm flattered, but I'm not really going for"
		/ case locoplan b of
			Spec Orb -> "orbs"
			Spec FloatingHead -> "floating heads"
			Spec FloatingDick -> "floating dicks"
			Basic Formless -> "churning flesh-masses"
			Basic Complex -> "whatever it is you are"
			f -> bodyFail "bodyRejection" f
		/ "right now."
		/ Paragraph / "Maybe mix up some limbs and try again, uh, later."
	, FauxChoice "well fine"
	, Narration2 $ c "You leave."
	]

minotaurCockUnsheath :: EventReel
minotaurCockUnsheath = c "His cock keeps unsheathing, more and more spilling out from his taut sheath, long and comparatively thin -- which is to say it's brutally fat, wrist-thick even near the tip where it's thinnest, and covered all over in messes of overlapping veins and thick gnarled ridges, but it's so long that even that seems thin, when it spans entirely up his stomach and chest to his neck in a long, unbending spike."

cockShow :: Pref -> Encounter Index () MinotaurMiner
cockShow pref b m =
	case locoplan b of
		Basic x | x `elem` [Naga, Biped] ->
			[ Narration2 $ "You reach down and"
				/ case dickLocation b of
					Just DickExternal -> "cup your flaccid length"
					Just DickSheathed -> "cup your swollen sheath"
					Just _ -> "rub your fingers across your bulging slit"
					f -> bodyFail "cockShow" f
				/ "."
				/ case dickLocation b of
					Just y | y `elem` [DickSheathed, DickVent, DickCloaca] -> "Your" / Cock^s / Stirs^s / "from inside, thickening to add to your bulge before" / "it spills"^p "they spill" / "out from your" / sheath / "into the open air, hanging in a heavy arc."
					_ -> mempty
				/ "Your" / Cock^s / Shudders^s / "to life, filling out as" / "it hardens"^p "they harden" / "."
				/ case dickLocation b of
					Just DickExternal -> "Your"
						/ (case cockCount b of
							1 -> mempty
							2 -> c "twin"
							q -> c $ number q)
						/ Cock^s / Arcs^s / "up across your stomach"
					Just _ -> "Your"
						/ (case cockCount b of
							1 -> mempty
							2 -> c "twin"
							q -> c $ number q)
						/ partAdjective Shaft / Shaft^s / Arcs^s / "up from your" / sheath
					f -> bodyFail "cockShow" f
				/ ", shuddering slightly with your pulse, and you slide your fingers across your" / partAdjective Cockhead / "cockhead, coaxing out a slimy bead of pre."
			, dialog m $ "Hey, nice."
			, Narration2 $ "He reaches out with his other hand, thick brutish fingers wrapping around" / manyCocks ? "both your cocks" ?: "your cock" / "and giving" / "it"^p "them" / "a firm squeeze, thumb digging into your half-hard cockflesh, your heartbeat thudding up where his fingers dig in."
				/ Paragraph / minotaurCockUnsheath / "It's all coated in molten-glass pre, dully glowing."
			]
		Basic x | x `elem` [Centaur, Quadruped, Slithering] ->
			[ FauxChoice "uh"
			, FauxChoice "well actually"
			, FauxChoice "you gotta get down to check it out since i can't really reach it myself"
			, Narration2 $ c "The minotaur snorts, but obligingly drops down on his knees, pressing his face to your"
				/ case x of
					Centaur -> "hip"
					Quadruped -> "shoulder"
					Slithering -> "side"
					_ -> bodyFail "cockShow" x
			, dialog m $ "You need a helping hand, huh?"
				/ Paragraph / "I guess I could oblige."
			, Narration2 $ case x of
				Slithering -> "He slides a hand down your underbelly to"
					/ case dickLocation b of
						Just DickExternal -> "grab your hanging cock"
						Just DickSheathed -> "grab your sheath, squeezing none-too-gently"
						Just _ -> "press againt your vent, rubbing none-too-gently over your flushed lips"
						f -> bodyFail "cockShow" f
					/ "."
				_ -> "He feels across your" / hasLocotype Centaur ? "lower" / "chest, down across your underbelly -- shifting to the side to get a proper look once he's feeling down between your hindlegs -- and"
					/ case dickLocation b of
						Just DickExternal -> c "wraps both hands around your hanging cock"
						Just _ -> "rubs one hand none-too-gently over your flushed" / sheath / ", the nubby" / Tip^s / "of your" / Cock^s / "already peeking out"
						f -> bodyFail "cockShow" f
					/ "."
				/ case dickLocation b of
					Just DickExternal -> mempty
					Just l -> case l of
							DickSheathed -> "He wraps his hand around your" / Cockhead^s / "and squeezes, fingers stroking up inside your sheath, and your" / Cock^s / Spills^s
							_ -> "Your" / Cockhead^s / Grinds^s / "against his palm, and more spills"
						/ case x of
							Slithering -> c "out, hanging down across your underbelly"
							_ -> "out, hanging heavy between your" / hips / "."
					f -> bodyFail "cockShow" f
				/ Paragraph / (hasExternalBalls
					? ("He"
						/ hasLocotype Slithering ? "slides down" ?: "reaches back"
						/ "to play with your balls, fist wrapping around their heavy heft and tugging gently"
						/ case bodyMat_ Crotch b of -- i guess??
							Solid (FMat _ Fur) -> ", thumb scraping through your fur as your"
							Solid (FMat _ Coat) -> ", thumb dragging across your stubbly coat;"
							Solid (FMat _ Scales) -> ", thumb sliding along your soft scales;"
							_ -> "as your")
					?: c "Your")
				/ Cock^s / Shudders^s / "in his grip, thickening and lengthening until" / "it's"^p"they're" / "at full mast"
				/ hasLocotype Slithering ? "up across your underbelly" ?: "beneath you"
				/ ", drooling pre that he catches on his fingers and smears back down along"
				/ case cockCount b of
					1 -> "your shaft"
					2 -> "one shaft and then the other"
					_ -> "one shaft and then another, and another, until they're all glazed"
				/ ", the touch of his fingers sending hot frissions of pleasure rippling out over your skin."
			, dialog m $ "It's"^p "They're" / "pretty nice."
			]
		f -> bodyFail "cockShow" f
	<> [ Narration2 $ case locoplan b of
			Basic Slithering -> c "You press together, cocks clashing, his cock scraping across your underbelly and drooling heavy, molten-glass pre all over. He uses both hands to wrap around your cocks, pumping you both."
			Basic x
				| x `elem` [Naga, Biped] -> c "You press together, cocks clashing, your hands and his knocking against each other and against your shafts, the both of you stroking the other."
				| x `elem` [Quadruped, Centaur] -> "He kneels closer, tugging on his own sheath for a moment." / minotaurCockUnsheath / "He leans in, angling his cock beneath you, scraping across your underbelly and coating your cock in his heavy, molten-glass pre, smacking together with heavy, elastic impacts."
			f -> bodyFail "cockShow" f
		/ "Your pre bubbles and burns into acrid smoke as his molten-glass pre sluices down, smearing across your shaft as he strokes you to full hardness. He tips his head slightly, looking down at you, hands"
		/ case firstOf [Medial, Knotted] dickAttrs b of
			Just Medial -> "coaxing around your medial ring"
			Just Knotted -> "squeezing your half-inflated knot"
			_ -> "tugging on your shaft"
		/ "."
	, dialog m $ "You wanna get that in me, huh?"
	, Choices
		[ ("yea gimmie yr ass", YouTop)
		, ("how abt we jerk each other off", JO)
		, ("nah i'm more interested in yr dick", GetFuckedChoices)
		]
	]

jo :: Encounter Index () MinotaurMiner
jo b m = case locoplan b of
		Basic x | x `elem` [Biped, Naga] ->
			[ dialog m $ "Sure."
			, Narration2 $ "His grip around your cock tightens, getting a lot more insistent. Not just playing around watching you get hard."
				/ Paragraph / "Your cocks grind together, slick and slippery. The gristled knob of his cockhead digs against"
				/ case firstOf [Barbs, Flared] dickAttrs b of
					Just Barbs -> "your rasping barbs"
					Just Flared -> "the ridge of your flare"
					_ -> "yours"
				/ "for a while, rutting your cockheads together, and then he thrusts forward, cock skidding up across your stomach and chest, rubbing against the side of your head as he grabs the base of your cocks, grinding your" / Shaft^s / "against the huge gristly pipe of his urethra, bulging out all along the underside of his shaft."
				/ Paragraph / manyCocks
					? "You reach down too, and pin his cock between yours, stroking his impossibly long shaft and cupping your two fat shafts against his near the bottom."
					?: "You reach down too, stroking your cocks all together, wrapping around your shaft and his to glide up and down the sloppy flesh."
				/ "Your hands collide, knocking against each other before you start spreading your hands looser; his rocky hands pressing against yours, rough palms over the backs of your hands, your fingers sliding up over the gnarled humps of his knuckles."
				/ Paragraph / sharedPreLeak
				/ Paragraph / "You can feel the tension in his body increase, his cock flexing in your grip, his strokes becoming firmer and faster. You rut up against him, humping against the underside of his shaft, catching the" / Streamer^s / "of pre that gush from your" / Cocktip^s / "and stroking the middle of his shaft in short sharp strokes while he squeezes and milks his cockhead, letting huge oozing cords of molten-glass pre spill from between his fingers."
				/ Paragraph / "He throws his head back, groaning, and his cock shudders hard before he erupts. Brilliant heat and a muted glow races up his shaft, finally erupting out in a torrent of molten-lava come. His urethra bloats further, entire shaft sagging lower from the weight of it, and he erupts again, painting a messy line of come all across your pressed-together chests."
				/ Paragraph / sharedClimax
				/ Paragraph / case locoplan b of
					Basic Naga -> "You sit back across your tail"
					_ -> "You stand up"
				/ ", and thick glossy webs of come follow you, stretching out in glowing arcs. Your mingled load is too heavy to stretch far; the threads thin and snap apart between you, lines hitting the ground with a smack."
				/ Paragraph / "You're both a mess;" / sharedDisheveled / ", and your chest got the other half of the load,"
				/ case bodyMat_ Chest b of
					Solid (FMat _ Skin) -> "skin soaked in thick runnels of hot slime"
					Solid (FMat _ Fur) -> "fur drenched and stuck to your chest, ruffled out in tufting spikes"
					Solid (FMat _ Coat) -> "coat stuck to your skin in a sloppy mess"
					Solid (FMat _ Scales) -> "sluicing down over your scales"
					_ -> "drenching you in burning slime"
				/ "."
				/ Paragraph / "Your cock drools out the last of its load,"
				/ case locoplan b of
					Basic Biped -> "lolling across your thigh"
					Basic Naga -> "lolling acros your underbelly"
					Basic x | x `elem` [Centaur, Quadruped] -> "drooping down across your underbelly"
					f -> bodyFail "jo" f
				/ ", and the minotaur wrings his cock, thumb pressed against his bulging urethra and pushing up, pumping a half-cooled mess of gummy tar from his cock."
			]
			| x `elem` [Centaur, Quadruped, Slithering] ->
			[ dialog m $ "Oh yeah? And how you gonna do that when you can't reach your dick?"
			, Narration2 $ "You grin right back at him and then"
				/ case x of
					Slithering -> "strike, wrapping around his body and pulling him into your coils," / Cock^s / "pressed up against his."
					_ -> case x of
							Quadruped -> "butt against him"
							Centaur -> "shove him forward, reaching out to pull him down-and-forward,"
							f -> bodyFail "jo" f
						/ "so that you can all but straddle him: him lying on his back,"
						/ case x of
							Centaur -> "your lower body"
							Quadruped -> "your chest"
							f -> bodyFail "jo" f
						/ "pressed against his front"
						/ hasLocotype Quadruped ? ", face-to-face"
						/ "."
				/ case x of
					Centaur -> mempty
					_ -> Paragraph / "You loll your tongue out and lap across his face, spit sputtering and steaming up in messy clouds as it soaks into the molten-lava furl of his face."
				/ Paragraph / "You grind your cock against his, both lengths pressed against your"
				/ case x of
					Centaur -> "underbelly"
					Quadruped -> "chest"
					Slithering -> "underbelly"
					f -> bodyFail "jo" f
				/ ", and his hands clap against your belly before he wraps them around your cocks, stroking as you rut against him. Your cocks slide between your bellies, becoming slick and slippery with your mingled issue, mess streaking down over his sides as you rut across his chest."
				/ Paragraph / sharedPreLeak
				/ Paragraph / "Your" / Cock^s / Cannonades^s / "across his body, catching against his shaft, smearing over his huge, meaty muscles, and you" / growl / "and" / groan / ", sides heaving as you fuck your" / Cock^s / "along his body, his hands guiding" / manyCocks ? "all" / "your cocks together in a slimy mess."
				/ Paragraph / "The minotaur groans, and his cock shudders hard against yours before he erupts, spewing out a heavy mess of molten-lava come, waves of heat washing up across your body as you both grind the mess into your"
				/ case bodyMat_ (if locoplan b == Basic Slithering then Tail else Legs) b of -- should be Underbelly or smth, idk
					Solid (FMat _ Fur) -> c "shaggy fur"
					Solid (FMat _ x) -> c $ matword x
					_ -> c "flesh"
				/ ", drenching your"
				/ case x of
					Centaur -> "underbelly"
					Quadruped -> "chest"
					Slithering -> "underbelly"
					f -> bodyFail "jo" f
				/ "with heavy tassels of glowing come."
				/ Paragraph / sharedClimax
				/ Paragraph / case x of
					Slithering -> "You relax your hold, your heavy coils sliding down his body as you spill off him," / Cock^s / "leaving behind thick trails on the way down --" / sharedDisheveled / "; you're in basically the same state:"
					_ -> "You step off him, cock smearing across his chest --" / sharedDisheveled / ". Your underbelly isn't much better;"
				/ case bodyMat_ (if locoplan b == Basic Slithering then Tail else Legs) b of -- see above
					Solid (FMat _ Fur) -> "fur hanging in long tassels, soaked to the skin"
					Solid (FMat _ Coat) -> "coat hidden under the smear of mixed come, grimy and molten"
					Solid (FMat _ Scales) -> "scales nearly hidden under the layers of mixed-together come"
					_ -> "utterly drenched and soaked with your smeared-together come"
				/ "."
				/ Paragraph / "You dribble out the last of your load, a stringy mess spilling to the ground, and the minotaur sits up, giant abs flexing, a slimy pool of come sluicing down his chest and spilling to the ground. He reaches up and shoves some of the mess off him; it's thick and heavy enough for that to work, mass falling to the ground with a wet" / em "thock" / ", droplets splattering across your" / feet / "."
			]
		f -> bodyFail "jo" f
	<>
		[ dialog m $ "Yeah, y'did good."
			/ Paragraph / "You know where to find me, if you wanna tear up my ass more."
		, FauxChoice "yea"
		, Narration2 $ c "You set off, still dripping with come."
		]
	where
		sharedPreLeak = "He's leaking pre all over, huge heavy blobs of molten-glass pre, glowing dimly, hissing and burning when it smears down his shaft far enough to touch your own. You're spurting up in bursts, more when he reaches down to" -- was {far enough to touch your own}; branch on dicksize
			/ case (dickLocation b, hasExternalBalls b) of
					(Just _, True) -> c "coax your balls"
					(Just _, False) -> "coax your" / sheath -- the rare application of sheath to dickexternal (it's 'foreskin' ftr)
					(f, _) -> bodyFail "jo" f
			/ ", gushing across your chest and spilling back down along the minotaur's cock. Your fluids mix together into a dense, heavy cream, molten and slimy webbed all up and down your shafts, catching in thick puddles in his palms when he runs his hands down along the underside of his cock."
		sharedClimax = "Your" / Cock^s / Shudders^s / ", bathed in the dense hot weight of his come, and you find yourself rutting up against his stomach, against his spurting cock," / groaning / "as you add your own load to the mess. Your" / Cock^s / Shudders^s / "against his: come erupts out in messy lines, bubbling and boiling into a steaming slurry as it mixes together with the minotaur's load, drenching the both of you. Sloppy come smears"
			/ case locoplan b of
				Basic x | x `elem` [Biped, Naga] -> "between your chests"
					| x `elem` [Centaur, Quadruped, Slithering] -> "between you"
				f -> bodyFail "jo" f
			/ ", hanging in heavy, swaying arcs from your spurting cocks, slithering in snaky lines along your shaft when you pull back."
		sharedDisheveled = "he's disheveled, chest sprayed with a sloppy mound of your mingled loads, spray webbing out in glossy strings all across his body: head, shoulders, stomach, thighs, all splattered with smeared ooze"


getFuckedChoices :: Encounter Index () MinotaurMiner
getFuckedChoices b m =
	[ dialog m $ "Oh yeah? What're you thinking about doing with it?"
	, Narration2 $ c "He tugs on his cockhead idly, more slowly unsheathing, glassy pre drooling over his fingers and dripping to the ground in thick dollops."
	, Choices $ catMaybes
		[ guardC (hasHead b) ("i'm gonna suck on it", CockSuck)
		, Just $ if hasLocotype Naga b && hasCloaca b
				then ("i'm gonna get it in my cloaca", FuckAss Directly)
				else ("i'm gonna get it in my ass", FuckAss Directly)
		]
	]

cockSuck :: Encounter Index () MinotaurMiner
cockSuck b m = case locoplan b of
	Basic x | x `elem` [Naga, Quadruped, Slithering] ->
		[ Narration2 $ "His hand rubs along his sheath, stroking the leathery flesh back and forth." / minotaurCockUnsheath
		, dialog m $ case x of
			Slithering -> "Yeah, you're basically a cock sleeve, huh? So how about you wind all up my cock and swallow the whole thing?"
			_ -> "Yeah, how about you suck on it a little, first."
		, Narration2 $ "He tugs his hand, slapping you across the" / muzzle / "with his unsheathed cock, smearing your"
		/ case bodyMat_ Head b of
			Solid (FMat _ x) -> matword x
			_ -> "head"
		/ "with goopy molten-glass pre. His other hand wraps around the back of your head and tugs you down, until your"
			/ case mouthType b of
				Mouth -> c "lips"
				_ -> c muzzle
			/ "bumps against his shaft"
			/ case x of
				Slithering -> ". You coil across his legs, keeping your head level with his cockhead, winding your body around his immense shaft."
				_ -> "; you have to take a few steps back before his cockhead dips down, pressing against your lips"
			/ "."
		]
	Basic x | x `elem` [Biped, Centaur] ->
		[ dialog m $ "How about you get on your knees first, then."
		, Narration2 $ "He raises his hand, fingers like a weight crashing against your shoulder, and you drop down onto your knees in front of him with a thump"
			/ hasLocotype Centaur ? ", your own cock sandwiched under the bulk of your underbelly, pulsing nearly in time with the visible throb minotaur's shaft"
			/ ". His cock towers over you, jutting nearly straight up, and he wraps his other hand around his sheath and tips the whole colossal thing down, slapping against your neck and shoulder. You have to sit back to even comfortably reach the tip."
			/ Paragraph / "His shaft spans out enormously long;"
			/ (armCountMatching 4
				? "it takes all four of your hands, plus his, to fully cover its length, and still the gnarled cockhead juts out"
				?: "even with yours and his hands wrapped around it, there's a bare foot or so left uncovered")
			/ ". You slide your hands up, wrapping" / armCountMatching 4 ? "two" ?: "them" / "around the head. It's hot in your palms like an ember, molten glass pre steadily drooling from the tip in thick, rubbery streams, drenching your fingers. His cockhead has a rippling, wrinkled rim, a thick ridge of gristly flesh, and his urethra juts out in a fat, stubby cone from the tip of his cockhead, twitching and twisting with each pulse of pre. The molten-glass pre smears down your arms, slowly cooling, forming a hard brittle crust that shatters apart into shards every time you shift your arms."
		]
	f -> bodyFail "cockSuck" f
	<> [ Narration2 $ "You lean in, heat radiating up from his cock, and open wide."
		/ case bodySpecies Head b of
			Just Snake -> "Your jaw unhinges wide, and you suck in his fat cockhead, swallowing to fit more down your throat."
			_ -> "His cockhead barely fits into your mouth; his heavy, dense flesh scrapes up along your teeth, stretching your jaw, bulging your cheeks."
		/ "You huff, panting, and your breath comes out as billows of steam. He groans, and his hand settles across the side of your head, his heavy fingers digging into your flesh. His cock trembles, shuddering, and a mess of pre hits the back of your throat, hot and heavy, already cooling into lumpy clots as you swallow and swallow. You wetly slurp on his cockhead, frothing messes of half-molten glass spilling over your lips"
		/ case locoplan b of
			Basic Slithering -> "and down along your coils."
			Basic Quadruped -> "and spattering to the ground."
			_ -> "and down your chest."
		/ "His cockhead knocks against the back of your mouth, spurting pre directly into your spasming throat, and you cough weakly, a filmy, heavy mess of glass pouring from your mouth."
	, Choices
		[ if hasNagaCloaca b
			then ("okay cmon fuck my cloaca", FuckAss FromBJ)
			else ("okay cmon fuck my ass", FuckAss FromBJ)
		, ("cmon rly fuck my throat", FuckThroat)
		, ("cum on my face", Facial)
		]
	]

fuckAss :: How -> Encounter Index () MinotaurMiner
fuckAss how b m =
	case how of
		Directly ->
			[ Narration2 $ c "He tips his head, looking down at you."
			, dialog m $ case locoplan b of
				Basic x | x `elem` [Biped, Naga] -> "Yeah, we can do that. Lie back."
					| x `elem` [Quadruped, Centaur] -> "Yeah, we can do that. Turn around."
				Basic Slithering -> "Yeah, we can do that. Flip over."
				f -> bodyFail "fuckAss" f
			, Narration2 $ case locoplan b of
					Basic x | x `elem` [Biped, Naga] -> c "He gently pushes you back -- still nearly enough to bowl you over -- and you sit back on the rocky ground."
						| x `elem` [Quadruped, Centaur] -> mempty
					Basic Slithering -> "He tugs back across your underbelly, practically flipping you onto your back all by himself, and slides a hand down lower across your underbelly, to your" / hasCloaca ? "cloaca" ?: "asshole" / "."
					f -> bodyFail "fuckAss" f
			]
		FromBJ ->
			[ Narration2 $ c "You pull off to say it, catching a frothy mess of bubbling glass across your face, and the minotaur looks down with his unblinking gyre of a face, hand tipping your head up."
			, dialog m $ case locoplan b of
				Basic x | x `elem` [Quadruped, Centaur] -> "Turn around, then."
					| x `elem` [Biped, Naga] -> "Lie back, then."
				Basic Slithering -> "Flip over, then."
				f -> bodyFail "fuckAss" f
			]
	<> case locoplan b of
		Basic Slithering ->
			[ Narration2 $ (case how of
					FromBJ -> "You squirm and flip over, showing him your underbelly, and he presses a hand down"
						/ case bodyMat_ Tail b of
							Solid (FMat _ Scales) -> "across your fine scales"
							_ -> mempty
						/ ", sliding down to your" / hasCloaca ? "cloaca" ?: "asshole" / "."
						/ Paragraph
					Directly -> mempty)
				/ "His fingers"
				/ hasCloaca
					? "push against your cloacal lips, digging in between them, making them spread around his fingers"
					?: "dig into the split between your scales, slowly and implacibly working your asshole open"
				/ "."
				/ hasCloaca &*& hasDick ? ("His fingertips mash down against your" / Cockhead^s / ", sliding against" / "it"^p "them" / "as he pushes deeper, along your still-sheathed" / Shaft^s / ".")
				/ Paragraph / "He works his fingers back and forth, stretching your flesh; he presses two fingers together and shoves them deep; he spreads them apart into a thick V; he tugs back and forth, making the flesh of your underbelly warp and bulge, the rest of his fingers stroking across"
				/ hasCloaca ? "your rapidly-flushing lips" ?: "your spread asshole"
				/ "."
				/ case dickLocation b of
					Just l -> "Your" / Cock^s / case l of
							l' | l' `elem` [DickExternal, DickSheathed] -> "stiffen across your underbelly, dribbling pre; he uses his other hand to idly stroke your" / Cock^s / "while he plays with your ass"
							_ -> Unsheathes^s / "along his fingers," / Tip^s / "dribbling pre across your underbelly; his only response is to tug along the shafts from the inside, stroking up and down the inner portion of" / "its"^p "their" / "unsheathing lenth"
						/ "."
					Nothing -> mempty
				/ Paragraph / "He finally pulls out with a soft" / em "pop" / ", keeping his thumb pressed against your hole to keep it spread, while he uses his other hand to stroke his cock. It's immense, cock sticking up ramrod-hard, with a slight upward curve, they underside visibly bulging with the mass of heavy, molten pre slowly working its way up to the tip. He leans in, minutely, and it brushes all along your underbelly, its heat flashing"
				/ case bodyMat_ (Waist Fore) b of
					Solid (FMat _ x) -> "across your" / matword x
					Trans (FMat _ t) (FMat _ b) -> "through your body, under the flesh where your" / matword b / "turns to" / matword t
				/ ". His grip tightens, his gristled flesh bulging slightly around his fingers, and he tips his cock down,"
				/ case bodyMat_ Chest b of
					Solid (FMat _ Scales) -> c "scraping it back and forth over your scales"
					Solid (FMat _ Protoplasm) -> c "mashing it against your soggy protoplasmic form"
					Solid (FMat _ x) | x `elem` [Fur, Skin, Coat] -> "sliding it over your" / matword x
					_ -> c "over your underbelly"
				/ ", sliding the tip just far enough up that it presses against your"
				/ hasCloaca ? "splayed lips" ?: "spread hole"
				/ ", drooling heavy molten-glass pre in thick, glossy globs. The minotaur cups the tip in his hand, thumb still notched against your"
				/ hasCloaca ? "lips" ?: "hole" / ", and guides it into place, sliding inside you."
				/ Paragraph / "His cock's burning hot, heat radiating out through your entire body, scorching as it shudders inside and sprays a burst of molten-glass pre all across your inner walls. You" / groan / ", squirming, coils knotting up over themselves as the minotaur properly mounts you, kneeling astride your underbelly, enormous balls lolling over your tail, sliding more and more of his cock into you. He keeps one hand wrapped around his shaft, braced against your"
				/ hasCloaca ? "vent" ?: "hole"
				/ ", knuckles always pushing inside as he plunges more and more of his lengthy shaft inside"
				/ case dickLocation b of
					Just d -> case d of
							DickExternal -> ", and he twists his fingers, rubbing his thumb along the arch of your hard" / Cock^s
							DickSheathed -> ", and he brings his other hand up, stroking your sheath, rubbing his thumb against the root of your unsheathed" / Cock^s
							_ -> ", and he grinds his knuckles up against the underside of your" / Cock^s / ", working back and forth over the root of your unsheathed" / Shaft^s
						/ "; dim stimulation compared to the scorching hot-metal bar of his cock sinking inside"
					Nothing -> mempty
				/ "."
				/ Paragraph / "His cock spurts again, much, much higher up inside you now, and the weight of his pre settles there, only slowly warping and stretching like taffy as it rolls down his shaft, finally emerging from your"
				/ hasCloaca ? "flushed vent" ?: "gaping asshole"
				/ "as a glassy smear bulging out all around his shaft, its half-molten surface dimly imprinted by the clenching, shuddering muscles of your inner body."
				/ Paragraph / "The minotaur drags himself closer, rutting shallowly back and forth -- his thrusts can only pull his cock back and forth a few inches, nothing compared to the titanic length, seeming like it hardly budges his cockhead where it's shoved deep up inside your guts, just making the entire length of his cock shudder and slide inside you, pulling through your tight guts. His balls have been dragging closer"
				/ case bodyMat_ (Waist Fore) b of
					Solid (FMat _ Scales) -> ", rubbing the wrong way up your scales,"
					_ -> mempty
				/ "and now they're nearly all the way up,"
				/ hasCloaca
					? "pressed against your swollen lips"
					?: "pressed against the bruised rim of your asshole"
				/ ", and the minotaur grunts and lurches forward one final time, sheath pressing against"
				/ hasCloaca ? "your lips" ?: "your hole"
				/ "with a splat, cockhead shoving yet deeper up into your guts as he hilts inside you, entire cock sheathed within your body."
				/ Paragraph / "Giant beads of pre roll down your guts, smearing together into a slimy mass against your spasming"
				/ hasCloaca ? "vent" ?: "asshole"
				/ ", only sluggishly leaking out, and the minotaur swipes a hand through the mess, stroking his shaft, feeding the hot weight of his pre back into your ass even as he spurts more and more inside you, the weight of it dragging against your guts, weighing you down."
				/ Paragraph / "He groans, rutting faster, and the dense, sloppy roll of his pre starts to overflow your"
				/ hasCloaca ? "cloaca" ?: "ass"
				/ ", spilling down your sides in hot runnels, smearing across his balls, catching in the spiky char across his haunches."
			, Jump $ DeepPenetration ViaSnake
			]
		Basic x | x `elem` [Biped, Naga] ->
			[ Narration2 $ (case how of
				Directly -> "You obligingly sit back, and he kneels"
				FromBJ -> "He kneels")
			/ "with a ground-rattling" / em "thump"
			/ case locoplan b of
				Basic Naga -> "over your tail, his giant balls draping across your underbelly, cock jutting straight up like a spear. Its underside is visibly bulging from the mass of heavy, molten pre slowly working its way up to the tip. His hands reach down to your"
					/ hasCloaca
						? ("cloaca, probing into your slit and spreading your lips wide"
							/ hasDick ? (", his knuckles brushing against the tips of your unsheathed" / Cock^s))
						?: c "ass, digging into the thin slit and spreading it with his fat, brutish fingers"
					/ "."
				Basic Biped -> ", cock spanning between your spread legs, underside visibly bulging with the mass of heavy, molten pre slowly working its way up to the tip. His hands grip your thighs and tip you all the way onto your back,"
					/ hasDick ? "your cock pressing against your stomach," -- was {stomach/chest}; branch on dick size
					/ "slowly sliding up until he's"
					/ hasExternalBalls ? "reaching beneath your balls,"
					/ "sliding fat fingers down the crack of your ass."
				f -> bodyFail "fuckAss" f
			/ Paragraph / "He reaches out for his cock and catches a rubbery, molten blob of pre, crackling as it cools, and uses that for lube, fingers spreading and stretching the pre in taffy-like arcs before he smears it around"
			/ hasCloaca ? "your cloaca lips" ?: "the rim of your ass"
			/ ", fat thumb digging"
			/ hasCloaca ? "around the curve of your spread opening" ?: "against your asshole"
			/ "until it shoves inside. Molten glass makes particularly bad lube, but it doesn't really matter. His fingers probe around inside, the hard metal ridges of his gauntlets digging into"
			/ case locoplan b of
				Basic Naga -> c $ hasCloaca
					? "your flushed lips"
					?: "the flesh of your underbelly"
				_ -> c "the flesh of your ass"
			/ hasProstate ? ", and you shudder when he hits your prostate"
			/ hasDick ? ", your cock oozing out a slimy string of pre across your stomach" -- was {stomach/chest}; branch on dick size
			/ "."
			/ Paragraph / "He pulls out, knees scraping on the floor as he scoots backwards to get enough room to bring his cock down: grabbing it by the sheath and tugging it until the head points"
			/ hasLocotype Naga ? "straight across your underbelly" ?: "between your raised legs"
			/ ", the heat of his pre washing across your skin. He leans in, gristled cockhead meeting your hole, the first gush of pre just a sudden impact of heat, bursting all across"
			/ hasCloaca ? "your inner flesh" ?: "the walls of your ass"
			/ ". He shoves inside, cockhead lurching in with a pop, and rocks, slowly opening you up as his cock stabs around"
			/ hasCloaca
				? (hasDick
					? ("along the root of your" / Cock^s)
					?: c "inside your cloaca")
				?: c "inside your ass"
			/ ", smearing molten pre all over as he slowly shoves the first foot-or-so of cock into you, just opening you up for the rest of it. His pre is gummy, slurping and squelching inside you in thick, rubbery folds, only coming out as a slimy smear all across the scant amount of his shaft he's managed to fit inside you, sluggishly dribbling down the underside to the vast amount left."
			/ Paragraph / "He huffs, hands squeezing"
			/ case locoplan b of
				Basic Naga -> "your hip, your waist"
				_ -> "your thigh, your side"
			/ ", as he jerks forward. He half-lifts you up across his knees, driving another few inches of his cock into you. Your gut bulges, a lump sliding up across your stomach, shifting back and forth as he thrusts shallowly. It feels like a lead pipe: implacable and hot, rigidly solid as it shoves its way deeper inside. The cockhead rams against something deep inside you, knocking the breath from your lungs in a" / em "whoof" / ", and the minotaur pauses for a moment, cock steadily gushing heavy heat into your guts."
			, dialog m $ "You good?"
			, Choices
				[ ("yeah cmon shove the rest in me", DeepPenetration ViaBiped)
				, ("actually maybe just jerk off the rest", FuckJO)
				]
			]
		Basic x | x `elem` [Centaur, Quadruped] ->
			[ Narration2 $ "You sit back"
				/ case bodySpecies Legs b of
					Just a -> case animalFootType a of
						Hooves -> ", hooves clopping on the rocky ground,"
						ClovenHooves -> ", hooves clopping on the rocky ground,"
						_ -> mempty
					_ -> mempty
				/ "and turn around so your ass is pressed against his haunches."
				/ Paragraph / "The minotaur presses his hands against your ass, fingers digging into your meaty flesh. He slides a fat finger down between your cheeks"
				/ hasTail ? ", flitting your tail out of the way,"
				/ "and presses it against your fat pucker. He digs in, pushing through your ring, and drags back and forth for a moment, fingerfucking you with one thick, stubby finger. He steps closer, using his other hand to tug his cock down"
				/ case how of
					FromBJ -> ", all slathered and shiny with your spit,"
					_ -> mempty
				/ "and presses the tip against your hole. It's hot; his pre is hotter. His cock shudders, head flexing against your clenching hole, and spits out a heavy mass of molten pre, spilling across your inner walls and dribbling out around his cockhead, squelching when he smears it around with his fingers, sliming up his shaft."
				/ Paragraph / "His cock is long enough he can't just thrust forward; he grips your ass with both hands and shoves forward, hooves clomping on the ground, shoving his shaft into you in a two-step process. It's like a burning spear stabbing into your guts, a shock of heat spilling through your body, punctuated by the heavy" / em "slap" / "of his giant balls smacking against your ass, nearly all his shaft shoved straight up your ass. Your guts shudder and clench, spasming around the invading shaft, and the minotaur groans, a fiery burst of pre working its way up through his cock before it erupts as a tarry, semisolid mass deep in your guts. He thrusts, pre spilling down his shaft in semisolid beads, rubbery as they knead their way down through your guts. The minotaur's fingers dig into your hips, and he shoves the last of his shaft in, the thing so deep"
				/ case x of
					Centaur -> "it feels like it's sunk nearly all the way through your lower body"
					Quadruped -> "it feels like it's pressed against your lungs"
					f -> bodyFail "fuckAss" f
				/ ". He jerks back, a few inches of cock emerging with a" / em "slurp" / ", and shoves in again, starting up a rough, brutal pace."
				/ Paragraph / "Giant beads of pre roll down your guts, smearing together into a slimy mass against your spasming asshole, only sluggishly leaking out, and the minotaur swipes a hand through the mess, stroking his shaft, feeding the hot weight of his pre back into your ass even as he spurts more and more inside you, the weight of it dragging against your guts, pulling you down."
				/ Paragraph / "He groans, rutting faster, and the dense, sloppy roll of his pre starts to overflow your ass, spilling down your" / hips / "in hot runnels, smearing when his legs press against yours."
			, Jump $ DeepPenetration ViaQuad
			]
		f -> bodyFail "fuckAss" f


fuckJO :: Encounter Index () MinotaurMiner
fuckJO b m =
	[ Narration2 $ "His hands wrap around his shaft. You can feel his strokes, hands tugging his shaft one way on the upstroke and another down, making it lurch where half of it is embedded inside your"
		/ hasNagaCloaca ? "cloaca" ?: "ass"
		/ ". He snorts, thrusting forward, fucking you with half of it and stroking the rest. His hand slides up and the crest of his knuckles crashes against your"
		/ hasNagaCloaca ? "lips" ?: "ass"
		/ ", digging into"
		/ hasNagaCloaca
			? "your puffy, swollen lips"
			?: "the puffy, spread flesh of your spread asshole"
		/ ". He twists his hand, wrapped around his shaft just before it vanishes into your"
		/ hasNagaCloaca ? "cloaca" ?: "ass"
		/ ", and his knuckles drag around"
		/ hasNagaCloaca ? "your lips" ?: "the rim of your ass"
		/ ", thumb sliding below for a second before he tugs back, hand sliding back down his shaft."
		/ Paragraph / "Still, he fucks you hard. He pulls out and slams forward, fist smacking against your"
		/ hasLocotype Naga ? "underbelly" ?: "ass"
		/ "to stop him from going too deep, but his cockhead still slams against your diaphragm, knocking the breath from your lungs, leaving you breathlessly gasping. His hands pick up the pace, only shallowly thrusting now, huffing and bleating as the flow of his heavy pre increases."
		/ Paragraph / "His hands squeeze down on his cock, the whole thing bloating fractionally with blood, and he" / sharedBellow / ", all his pre and come flooding your stomach, pumping thick ropes of come into your guts until the bulge of his cock starts to smear and even out, his load swelling your stomach more and more. His cock spasms, spasming hard, and his strokes keep him coming, hands manually pumping thick, rubbery clots of come up his shaft. His load spills from his cock, forming dense, churning pockets of heavy come, hammered apart into rubbery chunks by his unrelenting thrusting, grunting and groaning as he unloads."
		/ Paragraph / minotaurAnalCumshot b m
	] <> postAnalCloser b m

sharedBellow :: String
sharedBellow = "bellows, cock jerking hard inside you, spasming once, twice, before the whole thing twists and curls in a sickening lurch, cock corkscrewing around as he starts to unload, cock gushing even denser, hotter, molten-lava come inside your guts. He keeps thrusting, cock far too deep for much of it to spill out -- the base of his cock emerging slick and shining"

deepPenetration :: Via -> Encounter Index () MinotaurMiner
deepPenetration via b m =
	case via of
		ViaBiped ->
			[ dialog m $ "You asked for it."
			, Narration2 $ "His hands dig into your sides, forming a solid grip, and then he just" / em "plows" / "the rest of his cock into you. It's white-hot, your insides twisting and squirming bizarrely to keep up with the sheer length of his cock. The bulge of your stomach bloats, a fat tube of flesh rising up all the way to your ribs, vanishing under them. You bellow, panting breathlessly, aware of the heft and pressure of the minotaur's cock jarring against your lungs. The minotaur grinds his sheath against your"
				/ hasNagaCloaca ? "lips" ?: "ass"
				/ ", cockhead burrowing a few scant inches deeper, and you just wheeze, hands groping across your stomach, feeling the warped flesh churning as his cock pulses inside you."
			]
		ViaQuad -> mempty
		ViaSnake -> mempty
	<>
	[ Narration2 $ "The minotaur fucks you hard: he jerks back, a few inches of his cock spilling out, and rams forward again, short sharp thrusts"
		/ case locoplan b of
			Basic Slithering -> " that keep his cockhead sunk far up your sinuous body"
			_ -> ", his cockhead never leaving beneath your ribcage"
		/ ". His balls hammer your"
		/ case locoplan b of
			Basic x
				| x `elem` [Biped, Centaur, Quadruped] -> "ass"
				| x `elem` [Naga, Slithering] -> "underbelly"
			f -> bodyFail "deepPenetration" f
		/ ", smacking across your flesh with each thrust, leaving behind stinging bruises."
		/ case locoplan b of
			Basic x | x `elem` [Centaur, Slithering] -> mempty
			_ -> "You wheeze, breath knocked out of your lungs with each lurch of his cock."
		/ "His pre piles up, forming dense, rubbery clots, discrete chunks bubbling against each other, only slowly smearing together or breaking apart. His cockhead jars against them, pressure springy, jostling around inside you in gummy blobs. The weight is immense, heavy cords of pre spilling high up in your insides, forming an unrelenting pressure."
		/ Paragraph / "His hands dig into your" / hips / "and he" / sharedBellow / ","
		/ case locoplan b of
			Basic x | x `elem` [Centaur, Slithering] -> "his pre and come"
			_ -> "all his pre and come erupting against your lungs,"
		/ "pressing against your ribs, forming dense, churning pockets of heavy come, hammered apart into rubbery chunks by his unrelenting thrusting, grunting and groaning as he unloads."
		/ Paragraph / minotaurAnalCumshot b m
	] <> postAnalCloser b m

minotaurAnalCumshot :: BodyGlob -> MinotaurMiner -> EventReel
minotaurAnalCumshot b m =
	"He takes a half-step back, cock spilling out"
	/ case locoplan b of
		Basic Slithering -> c "fractionally from your bloated body, guts forming lumpy swells all up across your underside."
		_ -> ", and his spurts suddenly bloat your"
			/ case locoplan b of
				Basic x | x `elem` [Centaur, Quadruped] -> "underbelly"
				_ -> "stomach"
			/ ", bulging out just under your ribs."
	/ "He pulls out slow, still thrusting, but his load starts to sluggishly wind down his shaft, emerging from your"
	/ hasNagaCloaca ? "gaping vent" ?: "wrecked ass"
	/ "in boiling clots, molten-lava come streaming down his shaft in sizzling lines. He steps back again, cock lurching, your"
	/ hasNagaCloaca ? "cloaca" ?: "ass"
	/ "flooded with pulse after pulse of his load, oozing continually now from"
	/ hasNagaCloaca ? "your wrecked vent" ?: "your broken ass"
	/ "in glassy, basaltic flows, the incandescent flow moving in syrupy layers, coated in a thin skin of cooling come, all wrinkled and black. He finally pulls out entirely, cock slithering out with a tarry" / em "slurp" / ", shaft dragged down horizontal by the sheer weight of his load, still shuddering and spurting out burning yellow-red cords of come onto the floor."
	/ Paragraph / case locoplan b of
		Basic Slithering -> "Your body"
		_ -> "Your stomach"
	/ "is bloated, his cooling come forming lumpy bulges as it hardens into dense clots all up and down your guts, slowly spurting from"
	/ hasNagaCloaca ? "between your spread lips" ?: "your gaping ass"
	/ ". The minotaur leans in, fingers tugging in past your wrecked"
	/ hasNagaCloaca ? "opening" ?: "hole"
	/ ", and he drags out an uneven clump of black glass and basalt, like a naturally-formed dildo shoved up inside your guts. He lets it fall, cracking apart when it hits the floor, and sloppily works your"
	/ hasNagaCloaca ? "cloaca" ?: "ass"
	/ "around his fingers,"
	/ hasLocotype Naga |*| hasLocotype Slithering
		? (case dickLocation b of
			Just x | x `elem` [DickCloaca, DickVent] -> "rubbing along your aching" / Shaft^s / ","
			_ -> mempty)
	/ "fishing out the tarry, semisolid mess of his load."
	/ case dickLocation b of
		Just _ -> "You" / groan / ", huffing, and he reaches"
			/ case locoplan b of
				Basic x | x `elem` [Biped, Naga, Slithering] -> "up"
					| x `elem` [Centaur, Quadruped] -> "between your hind legs"
				f -> bodyFail "minotaurAnalCumshot" f
			/ "to tug on your" / Cock^s / ", wrapping around your" / Length^s / "and tugging as he fingers you, smearing"
		Nothing -> c "He smears"
	/ "his load all across"
	/ hasNagaCloaca ? "your bruised lips" ?: "the flesh of your ass"
	/ ". He peels the hardening clots out, thick pillars studded with fat pearls, and he works their knobs back and forth over"
	/ hasNagaCloaca ? "the clenching tunnel of your wrecked cloaca" ?: "over the rim of your ass"
	/ "until you sob"
	/ case dickLocation b of
		Just _ -> "and erupt," / case locoplan b of
			Basic x | x `elem` [Biped, Naga, Slithering] -> "cock spraying all across your front in slimy cords"
				| x `elem` [Centaur, Quadruped] -> "cock spraying all across your underbelly in slimy cords"
			f -> bodyFail "minotaurAnalCumshot" f
		Nothing -> c $ hasNagaCloaca
			? "and come, squirting all up his arm"
			?: "and orgasm hard"
	/ "."

postAnalCloser :: Encounter Index () MinotaurMiner
postAnalCloser b m =
	[ Narration2 $ "The minotaur keeps going until you're wrung dry, a flushed mess,"
		/ hasNagaCloaca
			? "cloaca swollen and half-prolapsed, forming a bloated mass across your underbelly"
			?: "asshole splayed and pouting out between your cheeks"
		/ "."
	, dialog m $ "That do it for you?"
	, Narration2 $ "He claps your"
		/ hasLocotype Naga |*| hasLocotype Slithering ? "side" ?: "ass"
		/ ", not quite a spank, and almost idlly slides his fingers into your wrecked hole, smearing his cooling load all around your inner walls."
	, dialog m $ "Got what you expected?"
	, FauxChoice "yea that was p good"
	, Narration2 $ case locoplan b of
			Basic x | x `elem` [Naga, Slithering] -> "You get up"
			_ -> "You get to your feet"
		/ ", wobbling -- weighed down, unexpectedly, by the sheer weight of his load, dense and heavy where it's still trapped up inside you"
		/ case locoplan b of
			Basic Slithering -> "in a heavy line all down your body"
			Basic Naga -> "in a heavy pit across your underbelly"
			Basic Centaur -> ", making your underbelly droop and hang low"
			_ -> mempty
		/ "."
		/ Paragraph / "The minotaur adjusts his cock, huge length slowly retreating back into his leathery sheath."
	, dialog m $ "Well. You know where to find me if you want more of that."
	, Narration2 $ case locoplan b of
		Basic x | x `elem` [Slithering, Naga] -> c "It takes you a minute or two, but you manage to slither away."
			| otherwise -> c "It takes you a minute or two, but you manage to limp away."
		Spec _ -> c "It takes you a minute or two, but you manage to float away."
	]

fuckThroat :: Encounter Index () MinotaurMiner
fuckThroat b m = case locoplan b of
	Basic Slithering -> [
		Narration2 $ "You pull off to say it, and the minotaur tips his head down, staring at you with his unblinking gyre. You squirm down, letting his cock plunge down your throat. Your body curls around itself, most of your weight hanging off his cock by this point, loops twisted over and around his giant thighs. His cock shudders, flooding your throat with a mass of heavy, dense pre, and you lurch even lower, swallowing up more of his cock. It pulses again, deeper, thudding against the underside of your neck, hosing down the inside of your throat with rubbery, heavy pre, forming a plug that it shoves through as you keep swallowing more and more of his cock."
			/ Paragraph / "The minotaur's hands wrap around your body, part holding you in place and part tugging you further down. He thrusts, using your body like an enormous cock sleeve, shoving in with a sharp jerk and then dragging back out, fighting against your swallowing muscles. Your" / case mouthType b of
				Mouth -> c "lips"
				_ -> c muzzle
			/ "nearly brushes against his sheath when he shoves in again, almost the entire length of his cock sunk down inside you, a hot fiery spear steadily shuddering, spurting dense pre into your stomach."
			/ Paragraph / "He cups your underside, milking his cock through your"
			/ case bodyMat_ Chest b of
				Solid (FMat _ m) -> matword m
				_ -> "flesh"
			/ ", pulling you back and forth. A mess of pre drools from your mouth in glassy, half-molten globs, spilling down across his sheath, sticking in clumps to his low-hanging balls. He thrusts forward, the lip of his sheath ramming against your mouth and then shoving inside"
			/ case mouthType b of 
				Mouth -> mempty
				_ -> "your" / muzzle
			/ ", hairy and coarse as he drags your head all the way down to the root."
			-- shared, partly
			/ Paragraph / "Glassy slime pours in dense, heavy lines from your nose and open, drooling" / muzzle / "as you slurp on his cock, tongue pinned under his sheath, coarse fur matted down to his leathery skin from your drool."
			/ Paragraph / "The weight of it has the most impact: each spurt adding to the churning, boiling mass of molten pre, forming a pit in your stomach, semisolid and heavy as the minotaur snorts and gushes blast after blast of pre straight into your swollen stomach."
			/ Paragraph / "The minotaur wraps a hand around"
			/ case mouthType b of
				Mouth -> c "your jaw"
				_ -> "your" / muzzle
			/ "and pins it closed, making a tighter tunnel for him to fuck."
		, dialog m $ "I said you'd make a nice cocksleeve, huh?"
		, Narration2 $ c "he says, and wipes a glob of pre from the corner of your mouth, pulling you back and smearing it across his sheath before he shoves you back down onto it."
		]
	_ ->
		[ Narration2 $ "You pull off to say it, and the minotaur tips his head down, staring at you with his unblinking gyre. His hands feel across your" / muzzle / ", tugging at your hanging jaw, and guide his cock back into your mouth with a sloppy pop. Then his hands settle across your head and shoulders, digging down. His cock lurches in your mouth, flooding your throat with a mass of heavy, dense pre, and he tugs you forward, cock hitting the back of your throat, building up pressure against your clenching muscles, before with a sudden lurch it breaks through, bending slightly but mostly forcing your head up as his fat shaft shoves its way into your throat. It pulses again, thudding against the underside of your neck, hosing down the inside of your throat with rubbery, heavy pre."
			/ Paragraph / "From the base of the minotaur's sheath, all the way to where your eyes cross"
			/ case locoplan b of
				Basic Quadruped -> "at"
				Basic x | x `elem` [Biped, Centaur, Naga] -> "where your hands are still wrapped around"
				f -> bodyFail "fuckThroat" f
			/ "the shaft just beyond what's in your mouth, there's a lot to go. His fingers grind against the back of your head, tugging you back and forth -- rutting the ridge of his gnarled cockhead back and forth past the back of your throat -- before he pulls further, sheathing his cock in your throat, inch by inch. You gag and gurgle, coughing up a steaming, bubbling mess of spit and molten glass, heavy and burning as some erupts up your sinuses to dribble from your nose as the minotaur implacably pulls you further and further down: head tipped up, mouth and neck and throat aligned to make a nearly-straight channel for him to sink his cock into."
			/ Paragraph / "He snorts, holding your head in both hands, and starts dragging you back and forth, pulling out until you can feel the spurt of his pre just against the back of your mouth, and then plunging you down with a muffled squelch, shoving his slimy, glistening shaft back into your throat. His grip shifts"
			/ case bodySpecies Head b of
				Just Snake -> "across your head"
				Just Human -> "across your scalp"
				Nothing -> "across your scalp"
				_ -> "behind your ears"
			/ ", pushing you down harder. His cock is this ramrod-straight spike, iron-hard, and your jaw and neck warp around it, the channel spasming as he plunges deeper. You gag and cough up another mess of molten glass even as his cock spurts and lurches, rammed all the way down under your collarbone, into your stomach. Glassy slime pours in dense, heavy lines from your nose and open, drooling" / muzzle / "as you slurp on his cock, tongue pinned under the gnarled, gamy flesh of his gristly shaft."
			/ Paragraph / "The weight of it has the most impact: each spurt adding to the churning, boiling mass of molten pre, forming a pit in your stomach, semisolid and heavy as the minotaur snorts and gushes blast after blast of pre straight into your swollen stomach."
			/ Paragraph / "Even with all that, there's still the base of his cock, nearly a solid foot of his shaft outside your open maw, and a few inches of sheathed shaft after that. The minotaur's hand enters your field of vision, playing with his sheath, stroking it up and down, his thick fingers pushing it down into a bunched mass of flesh, showing off the absolute root of his cock as he uses his other hand to shove more and more of his cock into your throat."
			/ Paragraph / "Your stomach lurches, his cockhead digging against its far end, churning the mess of slime flooding it around. You gurgle, blowing glassy bubbles that cool and shatter, and he stoops minutely, feeling across your jaw and throat, fingers pressing down against the iron-hard flesh of his cock until it sinks under your collarbone. He keeps pulling you down, and slowly your stomach warps, twisting unnaturally. He thrusts, short sharp motions stabbing inside you, cockhead ramming against the wall of your stomach, and then finally it hits just the right place: his cockhead skids up over the twisted flesh of your stomach and punches right through the opening at the end of it, shoving all the way into your guts. He groans, his pulse of pre mostly felt in your mouth, his urethra bulging against your tongue; the eruption in your guts is just a diffuse heat."
			/ Paragraph / "With that, he pulls your slack head all the way down, grinding your nose against his sheath no problem. He says something, noise roaring in your ears, and it takes a second to parse it."
		, dialog m $ em "Now" / "we can get started"
		, Narration2 $ c "is what he said."
		]
	-- end of major slithering branch
	<> [ Narration2 $ "He settles back, leaning against the tunnel wall, and grabs your head in both hands. He pulls back,"
		/ hasLocotype Slithering
			? "making you gag and cough from the fight against your swallowing muscles"
			?: "cock catching on the lip of your stomach and nearly flipping your guts inside out"
		/ ", and then he plunges you back down, nose smacking against his leathery sheath. He uses"
		/ hasLocotype Slithering ? "your body" ?: "your head"
		/ "like a toy, like a sleeve for his cock, just pulling you back and forth, hips jerking as he starts to thrust"
		/ hasLocotype Slithering ? "harder"
		/ ", slamming his cock to the root and pulling back, thumb smearing through the glassy froth spilling past your lips, your throat convulsing and gagging continually now around his shaft, coughing up an unending stream of gummy, half-molten glass beads all mixed in with the slurry of your spit."
		/ Paragraph / "He fucks your throat, sheath smacking against your face, huge heavy balls beating a tattoo against your"
		/ hasLocotype Slithering ? "underbelly" ?: "throat" / "as you drool a mess of pre, painting a gummy, half-molten mess of slime all across his sheath and balls, spilling through the ashy fur of his thighs, falling to the ground in clattering dollops."
		/ Paragraph / "Eventually he bellows, and his cock lurches, jerking hard inside you, twisting up your guts with its motion. It twists, corkscrewing hard, and his balls -- pressed against your"
		/ hasLocotype Slithering ? "jaw" ?: "front"
		/ " -- lurch. His load fountains up, swollen urethra bulging further, bloated and heavy as his molten-lava pre sprays into your guts, flooding you with dense, hot waves of come, crackling and hissing as it smears together with his pre. The weight of it grows and grows, pulse after pulse piling up inside you, your"
		/ hasLocotype Slithering ? "midbody" ?: "gut"
		/ "bloated and dense as he unloads inside you, not even your sloppy gags bringing up any of his load, only what was left of his pre stuck in your flooded stomach."
		/ Paragraph / "He finishes eventually, letting you up, and you lurch to the side,"
		/ case locoplan b of
			Basic Slithering -> "spitting out his cock until you spill entirely off his body and fall to the ground with a" / em "slap" / ". You're basically anchored to the ground, his load intensely heavy inside you, spreading heat all up and down your guts. You lie there wheezing, fat with come, body bloated like you just swallowed some enormous prey -- and his load churning in your guts like it's still kicking."
				/ Paragraph / "His cock bobs above you, still sluggishly spurting come across your coils," / case bodyMat_ Chest b of
					Solid (FMat _ Scales) -> "painting your scales with glossy, molten-lava streaks"
					Solid (FMat _ Protoplasm) -> "drenching your protoplasmic body with dense layers of molten-lava come"
					_ -> "coating your body with molten-lava come"
				/ ". Cooling lines drool down across your head, coating you with the dregs, blackened lines that wrinkle and bulge as the heavy lava spills out in ruddy red blobs."
			_ -> "his cock emerging in a slathered, slimy mess. You're basically anchored to the ground, pinned by the weight of his load inside you, able only to huff and gasp as he finally tips you"
				/ case locoplan b of
					Basic x | x `elem` [Centaur, Quadruped] -> "onto your side"
						| x `elem` [Biped, Naga] -> "onto your back"
					f -> bodyFail "fuckThroat" f
				/ ", letting the last of his cock burst up from your throat. It stands straight up, twitching still, drooling the last of his load in cooling, blackened cords, puddling across your swollen stomach."
		/ Paragraph / "He helps you up, though."
	] <> postBjCloser FromThroat b m

facial :: Encounter Index () MinotaurMiner
facial b m =
	[ Narration2 $ c "You pull off to say it, and the minotaur laughs, hands wrapping around his cock and giving it a pump."
	, dialog m $ "Pushy, huh?"
	, Narration2 $ c "But he pumps one hand around his cock and uses the other to cradle the back of your head,"
		/ case (hasHorns b, bodySpecies Head b) of
			(True, _) -> "grabbing you by the horns"
			(False, Just Human) -> "grabbing you by the hair"
			(False, Just Snake) -> "grabbing you by the head"
			(False, _) -> case bodyMat_ Head b of
				Solid (FMat _ Fur) -> "grabbing you by the fur"
				_ -> "grabbing you by the head"
		/ "dragging you forward, smearing your" / muzzle / "along his shaft as he strokes it. This close it's easy to see the way the line of his urethra down the underside bulges and flexes, heavy with his molten-glass pre. His internal muscles spasm, working hard to pump it up and up his long shaft before it finally erupts all across your face in heavy, sloppy gushes. It smells hot, like hot metal mixed in with his sweat and flesh, glass pouring down your face as you huff and gasp and groan. Glass pours into your mouth, your spit boiling from your open mouth in plumes of steam, and when you swallow his pre rolls down your throat, heavy and semisolid, forming a dense, strange weight in your stomach."
		/ Paragraph / "He paints your face up and down with his pre, until it forms a thick mantle all over your head"
		/ hasLocotype Slithering ? "and neck" ?: "and shoulders"
		/ ", drooling out into rounded icicles that shatter apart when they finally stretch apart and fall to the ground."
	] <> (if hasArms b
		then
			[ Narration2 $ c "On the down stroke he plays with his sheath, smearing his hands over the leathery flesh, and the motion carries down to his balls, jostling them, huge heavy orbs smacking against his thigh. He notices you staring:"
			, dialog m $ "How about you play with my balls?"
			, Narration2 $ c "he says, and cups his balls in his hand for a second, smearing them thickly with spiky tufts of cooling glass. They're heavy and supple under your hands, flesh furrowing as he gets closer; you can feel them lurch and shift in his drooping sac, and when you tug on them he bellows and hoses you with a particularly-heavy burst of pre."
			]
		else
			[ Narration2 $ c "On the down stroke he plays with his sheath, smearing his hands over the leathery flesh, and the motion carries down to his balls, jostling them, huge heavy orbs smacking against his thigh. He notices you staring and wraps his hand tighter around his fuzzy sheath, fingers clenching in a rippling motion, forcing an ooze of pre out across his hands. He cups his balls in his hand for a second, smearing them thickly with spiky tufts of cooling glass. He tugs, snorting, and his cock twitches and splatters you with a particularly heavy burst of pre."
			])
	<> [ dialog m $ "Getting close"
	, Narration2 $ "he says, body tensing, abs clenching, the pace of his strokes getting faster. He tugs your head in, smacking the rubbery tip of his cockhead against your cheek with each thrust, his spurts of pre spurting out directly across your face and splattering in glossy, coin-sized dollops all over his clenching stomach and thighs."
		/ Paragraph / "Then his whole body tenses, hand just squeezing his cockhead, glass drooling between his fingers and crashing to the ground with heavy cracks, before he lets out a loud, bellowing low and his cock erupts, shoving the remaining glass forward in a messy explosion as he starts hosing you down with molten lava. It's so much heavier than the glass, and hotter, half-cooled glass shards shattering from the sudden heat, forming a thick, chunky mess that smears down your body. He jerks off, thumb rubbing the underside of his cockhead, bloated urethra visibly glowing from the lava surging up inside, spraying all across your body like a miniature volcanic eruption, rippling lava forming a wrinkled black crust as it piles up"
		/ hasLocotype Slithering ? "all across your head and down your body" ?: "across your shoulders"
		/ ", heavy enough it starts to drag you down. His knee knocks against"
		/ hasLocotype Slithering ? "your underbelly" ?: "your chest"
		/ ", pushing you backwards, and you topple onto your back, the minotaur following you down, hosing squirts of molten-lava come into your open and panting mouth, practically gluing you to the ground with its heavy weight: all across your body, forming a dense pit in your stomach as you swallow more and more, flooding in messy squirts across your face."
		/ Paragraph / "Finally his flow ebbs, fingers squeezing his shaft and milking out a few final cooling, blackened chunks that he smears across your front. You're basically pinned to the ground by the weight of his load, both inside and out. He helps lever you up, though."
	] <> postBjCloser FromFacial b m

data FromB = FromThroat | FromFacial
	deriving (Eq, Ord, Show, Read)

postBjCloser :: FromB -> Encounter Index () MinotaurMiner
postBjCloser from b m =
	[ dialog m $ "That do it for you?"
	, Narration2 $ case locoplan b of
			Basic Slithering -> "He drags his fingers down your body"
			_ -> "He drags his fingers across your chest"
		/ ", catching some of the globs of come splattered"
		/ case bodyMat_ Chest b of
			Solid (FMat _ Skin) -> c "across your skin"
			Solid (FMat _ Scales) -> c "over your scales"
			Solid (FMat _ x)
				| x `elem` [Fur, Coat] -> "through your" / matword x
			_ -> c "all over"
		/ "."
	, dialog m $ "Got what you expected?"
	, FauxChoice "yea that was p good"
	, Narration2 $ "His load is heavy"
		/ case from of
			FromThroat -> "in your gut"
			FromFacial -> "painted across your skin"
		/ "; still molten-hot and only slowly cooling, sending ripples of heat through your body."
		/ Paragraph / "The minotaur adjusts his cock, huge length slowly retreating back into his leathery sheath."
	, dialog m $ "Well. You know where to find me if you want more of that."
	, Narration2 $ case locoplan b of
		Basic x | x `elem` [Slithering, Naga] -> c "It takes you a minute or two, but you manage to slither away."
			| otherwise -> c "It takes you a minute or two, but you manage to limp away."
		Spec _ -> c "It takes you a minute or two, but you manage to float away."
	]


youTop :: Encounter Index () MinotaurMiner
youTop b m = case locoplan b of
	Basic x | x `elem` [Biped, Naga, Centaur] ->
		[ Narration2 $ case pref m of
				Top -> "You twist him around and push him back against the wall, his face pressed against his meaty bicep, his tail lashing side to side until you grab it in one hand and pull it up. He arches his back to go with the motion of his tail, and that puts his huge, muscular ass on display." / Paragraph
				Bottom -> c "He twists back around, putting his huge, muscular ass on display: legs spread, tilted forward, meaty ass forming a shelf across his lower back. You grab his lashing tail and pull it up, putting his ass on display, and he lows out a moan."
			/ "You cup one fat cheek with your other hand, fingers dimpling his flesh."
			/ Paragraph / armCountMatching 4 -- FIXME: this triggers wrong??
				? "You have to use two hands to really spread his cheeks, with your final one reaching in to touch his hole."
				?: "You have to use both hands, dropping his tail, to really spread his cheeks."
			/ "He's got a plush asshole, darker than the rest of his flesh and pouting minutely out from his crack, but when you slide your finger down, tugging, it parts and opens just enough to let out a glimmer of light: you push your thumbs against the rim of his hole and gently spread him, revealing the yellow-red glow of his inner flesh, just the same as the lava-veins he's got across his arms and legs."
			/ Paragraph / "You slide a finger across his hole, easily sliding it in, and then another, two fingers curling and tugging at his inner walls, your hand splayed across his meaty cheeks."
			/ armCountMatching 4
				? "You drop his tail and swap your hands: tail hand spreading his cheeks, freeing up another hand to trail"
				?: "You slide your other hand"
			/ "down between his thighs, hefting and tugging on his huge, hanging balls. He lets out a rumbling moo, shoulders pressing against the wall, ass pushing further out."
		, Choices
			[ ("make out w/ his asshole", Rim)
			, case locoplan b of
				Basic Centaur -> ("mount him", FuckHim)
				_ -> ("fuck him", FuckHim)
			, ("fist him", FistHim)
			]
		]
		| x `elem` [Quadruped, Slithering] ->
			[ Narration2 $ c "He turns around and braces himself against the wall, back down low and his ass presented out. His tail lashes back and forth wildly. He's got a plush asshole, darker than the rest of his flesh and pouting minutely out from his crack, clenching and flexing, working to spread itself open for your cock."
			, Choices $ catMaybes
				[ pure ("make out w/ his asshole", Rim)
				-- , guardC (hasLocotype Slithering b) ("slither up inside his asshole", SlitherFuck)
				, pure $ case x of
					Quadruped -> ("mount him", FuckHim)
					_ -> ("fuck him", FuckHim)
				]
			]
	f -> bodyFail "youTop" f

rim :: Encounter Index () MinotaurMiner
rim b m =
	[ Narration2 $
		"His ass is right in front of you, his legs widely set, all on display. His skin is supple, stretched over the meaty muscle of his cheeks. His enormous bull-balls hang low between his legs, jostling back and forth as he sets his hooves wider."
		/ Paragraph / "The coarse spikes that coat his legs spread across the bottom half of his cheeks, tapering to nothing over the swell of his ass cheeks. His hole shudders, pulsing in anticipation, and you"
		/ case locoplan b of
			Basic Biped -> c "drop down on your knees and"
			Basic Naga -> c "dip lower and"
			Basic Centaur -> "bow down on your knees" / hasDick ? ", pinning your cock across your underbelly," / "and"
			Basic Quadruped -> mempty
			Basic Slithering -> c "anchor yourself by coiling around one of his meaty legs, then"
			f -> bodyFail "rim" f
		/ "lean in,"
		/ hasArms ? "hands spreading his cheeks wider,"
		/ case mouthType b of
			Mouth -> c "dragging your mouth up the length of his crack, tongue flitting out to press against the puffy bulge of his asshole"
			_ -> "opening your" / muzzle / "to let your tongue loll out and drag a messy stripe up his thigh, to his crack"
		/ "."
		/ Paragraph / "He pushes back, eager for the contact, and you nip at his hole, spreading it with your tongue. The thing with his ass is that his guts glow, a bright yellow-red that matches his lava veins. His dark pucker flexes, spreading, and his skin gives way to internal flesh, in a dappled circle, like a bullseye right between his cheeks. You lap inside -- burning hot, spit sizzling -- and"
		/ hasArms ? "his legs shudder under your fingertips" ?: "his legs tremble"
		/ ", humping back against you"
		/ case locoplan b of
			Basic Slithering -> "pressing your coils against his skin"
			Basic _ -> "nearly enough to bowl you over"
			f -> bodyFail "rim" f
		/ "."
		/ Paragraph / hasArms ? "You slide your fingers in, playing over the bulging rim of his ass, feeling the transition where his skin turns soft and hot." / "You lap against his asshole, up and down, each motion sending a tiny ripple through his legs, clenching across his stomach. His balls churn in their sac, flesh furrowing and relaxing"
		/ case mouthType b of
			Mouth -> c ", draped past your chin"
			_ -> ", shuddering just before your" / muzzle
		/ "; his cock is unsheathed, long and heavy, drooling pre unevenly on the rocky ground below."
		/ Paragraph / "His body rumbles in a deep, lowing" / em "moo" / "as you play with his hole, tongue pushing inside to curl over the inward rim, trying to fight against its clench. You drool across his flesh, heat making it sizzle and spit, and his hole shudders, clenching so tight for a moment that its glow vanishes, before it spreads again, bulging out into a swollen ring. You make out with his hole, pressing your lips against its swell, sucking and biting at his flesh, and the minotaur bellows and groans, his cock flexing up to slap against his chest with a loud" / em "crack" / ", splattering droplets of pre all over the ground beneath him. A messy cord of drool spills"
		/ case mouthType b of
			Mouth -> c "down your chin"
			_ -> "over your" / muzzle
		/ ", winding its way down his hanging sac, gathering at the gnarled points of his balls and dribbling to the ground"
		/ case bodyMat_ Head b of
			Solid (FMat _ Skin) -> ", slick and slippery against your skin"
			Solid (FMat _ Scales) -> ", sheening over your scales"
			Solid (FMat _ Fur) -> ", dampening your fur"
			Solid (FMat _ Coat) -> ", winding through the stiff hairs down your face"
			_ -> mempty
		/ "as you suck on his hole. He clenches with your tongue shoved up inside him, the muscled ring of his hole dragging back and forth across your tongue, and you shove your tongue deeper, face buried between his meaty cheeks, sloppily eating him out even as your spit sizzles and boils away all across your face."
		/ Paragraph / "You"
		/ case locoplan b of
			Basic Slithering -> "peel away from his flesh"
			Basic _ -> "sit back"
			f -> bodyFail "rim" f
		/ ", looking: when you started his hole was a tight mounded circle, dark and pouting out from his cheeks. Now it's spread nearly wide enough to gape, spit-shiny and pulsing, the vivid yellow-red flesh of his guts on display, the black ring raised even further into a glossy, bruised swell. He keeps clenching, bloat sucking back into his body, only to pout out again when he relaxes an instant later."
	, Choices $ case locoplan b of
		Basic Slithering ->
			[ {-("slither up inside his asshole", SlitherFuck)
			,-} ("now fuck him", FuckHim)
			]
		Basic x -> catMaybes
			[ pure (if x `elem` [Quadruped, Centaur] then "now mount him" else "now fuck him", FuckHim)
			, guardC (hasArms b) ("fist him", FistHim)
			]
		f -> bodyFail "rim" f
	]

{-
			~> SLITHERING
			-> slither all up inside his ass
				{you totally bust his ass cramming half yr body inside and he cums all over himself + yr dicks (if present) erupt all across his ass and legs}
			-> fuck him
				{you do the usual "wrap him up in yr coils" thing and then just cram a cock or two inside}


slitherfuck :: Encounter Index () MinotaurMiner
slitherfuck b m =

-> slither all up inside his ass

Your press your {snout} against his puffy hole, {forked tongue flitting out for a moment,} and then squirm in. The minotaur lets out a surprised kind of laugh, hooves shifting as he spreads his legs wider, one arm coming back {to cup the crest of your head}.

The thing about his ass is that his guts glow. Your {snout} pushes in, and the scorching heat of his insides pours into you everywhere you're pressed against him. His ass spreads wider, lips pouting into a gape as you squirm and shove in, closing your eyes as your {snout} slurps inside, the furl of his hole sliding up to press against your face.


-> fuck him


-}

{-
			-> fist him
				{you shove like a fist in his ass}
				-> try to work yr other hand in
					{big ol gaping ass, wetly sucking on yr fists. he cums all over the wall}
				-> shove in bicep deep
					{see above only more w/ yr shoulder pressed against his cheeks as you tug and squeeze on his burning-hot guts}
-}
fistHim :: Encounter Index () MinotaurMiner
fistHim b m =
	[ Narration2 $ "You scissor your fingers inside him, tugging at the inner walls of his ass, and he moos and sags down lower, pushing his ass back against your hand. You shove a third finger in,"
		/ armCountMatching 4 ? "another" ?: "other"
		/ "hand tugging at the rim of his ass, spreading it wide enough that the glow of his guts is on display, becoming a fat target between his cheeks, blocked sometimes by your thrusting fingers."
		/ Paragraph / "His hole is thick and heavy, stretching in rubbery jolts as you spread your fingers, opening up wide enough you can see his inner flesh, all glowing yellow-red, shiny and pulsing as he clenches. It's not hard to push your entire hand inside: you just brace your"
		/ armCountMatching 4 ? "other hands" ?: "other hand"
		/ "against his"
		/ armCountMatching 4 ? "ass and hips" ?: "ass"
		/ "and push inside, thumb catching on the lip of his gaping hole for a second before you push inside, the crest of your hand sinking in easily. The minotaur groans, the round mass of his shoulderblades sharply defined as his head drops to nearly touch the floor."
		/ Paragraph / "He's burning-hot inside, glassily slick, and you push inside and then pull out with the only catch being on his hole, spasming and clenching: gaping when your hand pulls free, remaining as a spread-open crater with thick, ridged lips sloppily kissing your knuckles. He bleats when you push inside, his cock spitting out pre in sharp cracks, splattering all across the rocks beneath him, building up to a continual spill as you start to punch-fuck him, hammering into his hole and then jerking back out. The flesh of his balls furrows, the giant orbs pulling up into an asymmetrical lump, swaying and slapping against his thighs with each push inside."
		/ Paragraph / "You can tell when he gets really close: he starts rutting back against you, magma drool spilling from the grooves across his face, bleating and making crackling panting noises. Internal muscles spasm and clench, struggling to keep your fingers digging down against his prostate, and so you grind down hard, digging into the nearly rock-hard swell of his enflamed prostate. His entire body shudders, and he lets out a bellowing" / em "moo" / ", cock firing off untouched as you wrap your fingers around the rocky mass of his prostate and squeeze. His load boils out of his cock, thick ropes of glowing magma, the weight of it bowing his cock down, his urethra bloated and glowing from his load."
		/ Paragraph / "You keep fistfucking him, back and forth, shoving deeper into his guts as he bleats and moos, forcing out burst after burst of sloppy magma come all over the rocks beneath him, folding over itself in glassy streams as it starts to cool into layers of rippling obsidian."
	] <> fistingCloser b m

fistingCloser :: Encounter Index () MinotaurMiner
fistingCloser b m =
	[ Narration2 $ "You wring him dry, until his cock is dragged down by the weight of his own heavy load, tip wrapped in a thick cocoon of molten come. The mass shudders and pulses, folds of come blurting out and spilling over each other, shuddering as his cock flexes."
		/ Paragraph / "You pull out from his ass with a" / em "slurp" / ", his hole gaping, ring blown wide, clenching against nothing and then spreading back open, displaying the red-hot flesh of his pummeled guts. He sluggishly stands, come spilling from his cock and hitting the ground with a" / em "thwack" / ", bits of coagulated come shattering off at the edges. His chest rumbles in a groan, and he reaches back to touch his ass, fingers digging into the puffy rim."
	, dialog m $ "Yeah, y'did good."
	, Narration2 $ c "He stoops and reaches for his drill, letting it smack against his leg. His cock shudders again, more clots of come spilling off it, too heavy to form strings. He tugs his cock with his other hand, knocking off the rocky mess, leaving him coated in a glassy sheen that shatters apart as it cools"
	, dialog m $ "You know where to find me, if you wanna tear up my ass more."
	, FauxChoice "yea"
	, Narration2 $ c "It takes him a bit, but he eventually turns back to the wall, fiddling with his drill."
	]

fuckHim :: Encounter Index () MinotaurMiner
fuckHim b m =
	[ Narration2 $ case locoplan b of
		Basic x
			| x `elem` [Biped, Naga] -> "You grind against his ass, rutting against the muscled curve of his cheeks, keeping your fingers sliding back and forth along the pouting rim of his hole. Your" / Cock^s / Throbs^s / ", drooling pre across his skin, and you catch a blob on your thumb and smear it to his hole, slowly feeding it inside. He's open enough you can see the glowing flesh of his guts, your pre steaming up the instant it touches his flesh."
				/ Paragraph / case cockCount b of
					1 -> c "You line up your cock and push inside"
					2 -> c "You bring your twin cocks together and tease the tips over his hole, one and then the other, and then push them both inside."
					q -> "You smear your cocks across his cheeks, tips digging into his spread hole, and then you wrap your hands around two of them and shove them in, letting" / case q of
							3 -> "the other"
							_ -> "the rest"
						/ "skew up over his cheeks."
				/ "His hole gapes around your" / Shaft^s / ", and you sink in effortlessly, hips meeting his ass with a soft clap"
				/ hasExternalBalls ? ", balls coming to rest against his cheeks"
				/ ". The minotaur's muscles work around your" / Shaft^s / ", milking and clenching, and he ruts back"
				/ case dickLocation b of
					Just DickExternal -> mempty
					Just _ -> ", grinding against your" / sheath
					f -> bodyFail "fuckHim" f
				/ ", trying to fit more of your" / Cock^s / "into him."
				/ Paragraph / "You pull back and thrust forward, hilting again with a smack, and start to fuck him. His huge arms are braced against the wall, biceps and shoulders flexing into huge muscular swells as he shoves back to meet each of your thrusts, groaning."
			| x `elem` [Centaur, Quadruped] -> (hasLocotype Centaur ? "You shove him down onto all fours, his knees slightly raised as he keeps rutting back into your touches.")
				/ Paragraph / "Your" / Cock^s / Throbs^s / ", jutting straight out across your underbelly, dribbling pre all across the floor in droplets. Then you rear up, hooves dragging across his back before they hook across his shoulders and your" / Cock^s / case cockCount b of
					1 -> c "slaps down all across his ass and lower back."
					2 -> c "slap down across his ass and lower back in a wide V, the twin shafts rolling back and forth over his sides."
					_ -> "crash down across his back with a weighty" / em "smack" / ", shafts sliding against each other and spilling to the sides, smearing cords of pre all over"
				/ "He doesn't even bob from your weight landing on top of him."
				/ Paragraph / "You rut back and forth, hind legs shifting on the rocky ground, before you manage to jerk back far enough for" / case cockCount b of
					1 -> c "your cock to sag out from where it's pinned between you"
					2 -> c "your twin cocks to spill down between his legs"
					q -> "two of your cocks to spill down between his legs," / case q of
							3 -> "one still"
							4 -> "the two others still"
							_ -> "leaving the rest still"
						/ "pinned between his back and your underbelly"
				/ ". You thrust, smearing pre all over his thighs and ass, before your" / partAdjective Cockhead / Cockhead^s / Finds^s / "the target of his ass -- he bellows as you slam in, in time with your" / groan / ". His hole flexes and clenches, sucking on your" / Shaft^s / "as you drive" / "it"^p"them" / "half in"
				/ case firstOf [Medial] dickAttrs b of
					Just Medial -> "; it's your medial" / Ring^s / "smacking against his cheeks with" / case cockCount b of
								1 -> "a sloppy crack"
								_ -> "slightly out-of-sync cracks"
							/ "that finally stops your thrust"
					_ -> mempty
				/ "."
		Basic Slithering -> "You loop between his legs first,"
			/ case bodyMat_ Chest b of
				Solid (FMat _ Scales) -> "scales brushing along the heavy, drooping length of his unsheathed cock,"
				Solid (FMat _ Protoplasm) -> "soft protoplasm smearing ooze along the heavy, drooping length of his unsheathed cock,"
				_ -> "brushing across the heavy, drooping length of his unsheathed cock,"
			/ "coiling up across his waist before your" / Cock^s / "drag up across his thigh and press against his hole. You rut shallowly against him, his skin soft and hairless, supple and dimpling slightly as you grin down harder,"
			/ Cock^s / "smearing pre in messy globs over the muscled cheeks of his ass. You push in," / partAdjective Cockhead / Cockhead^s / "breaching his hole and slurping back and forth over the clenching ring of his ass, and then you pull your coils tight and"
			/ case cockCount b of
				1 -> c "shove inside"
				2 -> c "stuff them both inside in a single thrust"
				q -> "stuff two inside in a single thrust, letting"
					/ case q of
						3 -> "the other"
						_ -> "the rest"
					/ "skew up between his cheeks."
		f -> bodyFail "fuckHim" f
		/ Paragraph / "He's meltingly-hot inside, ripples of heat coursing up through your" / Shaft^s / "; when you pull back minutely to shove the rest inside him, your" / Cock^s / Comes^s / "out smeared with boiling pre, sending up plumes of steam."
		/ case firstOf [Medial] dickAttrs b of
			Just Medial -> "Already-burnt lines of pre snap apart from your medial" / Ring^s / ", forming brittle spikes of crystallized pre that shatter when you shove" / oneCock ? "the entire thing" ?: "your two cocks" / "inside again."
			_ -> mempty
		-- slithering replace here??:
		/ "You" / groan / "," / oneCock ? "the rest of your shaft" ?: "your two shafts" / "ramming into the minotaur with enough force that he jolts forward, horns nearly knocking against the wall."
		/ case (dickLocation b, hasKnot b) of
			(Just DickExternal, True) -> case cockCount b of
				1 -> c "The half-hard swell of your knot digs against the rim of his spread hole, and you"
				_ -> c "With your cocks bottomed out, your half-hard knots dig into his spread hole, tugging it out into a lumpy figure-eight as you"
			(Just _, True) -> "Your" / sheath / "mashes against his ass, the half-hard swell of your" / Knot^s / "digging against the rim of his spread hole,"
				/ manyCocks ? "tugging it out into a lumpy figure-eight"
				/ "and you"
			_ -> c "You"
		/ "fuck him shortly, the final few inches of your" / Shaft^s / "pushing through his asshole"
		/ hasKnot ? ("," / Knot^s / "smacking against his hole each time you bottom out")
		/ "."
		/ case firstOf [Knotting] climaxAttrs b of
			Just Knotting -> Paragraph / "You"
				/ case locoplan b of
					Basic Slithering -> "coil tighter"
					_ -> "ram forwards"
				/ "and shove your" / Knot^s / "inside with a sharp lurch," / manyCocks ? "double-knotting him," / "his muscular inner walls squeezing down tight and only getting tighter as your" / Knot^s / Throbs^s / "and" / Swells^s / "to" / "its"^p"their" / "full size" / manyCocks ? ", fighting for space inside his tight ass" / ". The minotaur bellows, the girth of your" / Knot^s / "crushing his prostate -- a dense, rock-hard nut"
				/ oneCock
					? "against the underside of your growing knot"
					?: "wedged in the gap between your two growing knots"
				/ " -- apparently enough to bring him off. His cock shudders, muscule spasms strong enough to feel from the inside, rippling across your" / Cock^s / ", and he comes with an agonized bellow, hot magma come spraying all across his front and all down the rocks below you."
				/ Paragraph / "The wild spasming of his asshole brings you off, and you" / groan
				/ hasArms ? ", hands digging into his fat ass"
				/ "as you spray" / oneCock ? "thick" ?: "twin" / "blasts of come inside him"
				/ case cockCount b of
					q | q > 2 -> ". Your other" / case q of
							3 -> "cock erupts"
							_ -> "cocks erupt"
						/ "all across his back, slurping as you keep rutting, forming sloppy tassels that dangle down his sides in jiggling ropes, more and more spilling over his skin as you keep shooting"
					_ -> mempty
				/ ". Your" / Cock^s / Shudders^s /", come streaking down your" / Shaft^s / "and piling up against your fat" / Knot^s / ", each pulse adding to the boiling, pressurized pocket of come stopped up inside him."
				/ Paragraph / "It's a while before you stop coming," / Cock^s / "gushing and gushing into him" / case cockCount b of
					q | q > 2 -> " -- and all over him -- "
					_ -> mempty
				/ "until he's visibly swollen, asshole spasming in shocky bursts around the"
				/ manyCocks ? "half-conjoined"
				/ "root of your" / Shaft^s / ", squeezing your" / Knot^s / "tighter inside. Come builds up in a sloppy, boiling reservour," / oneCock ? "all around your shaft" ?: "leaking out in spurts around the uneven seal of your knots" /", and when" / "your knot"^p"they" / "finally starts to ebb you yank" / "it"^p"them" / "out with an explosive gush of come, spurting out of his overfilled ass and pouring in sloppy rivers down his haunches."
			_ -> case locoplan b of
					Basic Slithering -> "Heat builds in a long ropy coil all through your body, curling up into a hard knot of tension under your" / Cock^s
					_ -> c "Heat builds across your stomach and thighs, curling up inside you"
				/ ", and you thrust into him one last time," / groaning / ". Your" / Cock^s / Jerks^s / ", trembling deep in his ass, and then"
				/ case firstOf [Flaring] climaxAttrs b of
					Just Flaring -> "your" / Flare^s / Snaps^s / "wide, forming"
						/ oneCock ? "a fat bulge visible even across" ?: "a lumpy, lopsided bulge across"
						/ "the minotaur's chiseled gut. You erupt in sharp pulses"
					_ -> c "you erupt in sharp pulses"
				/ case cockCount b of
					q | q > 2 -> ", spraying inside him and all across his back, come spilling down your shafts and drooling from his ass as"
						/ case q of
							3 -> "your other cock sprays"
							_ -> "the rest of your cocks spray"
						/ "more come in sloppy ropes all across his back, dangling down from his sides in runny tassels"
					_ -> ", come pouring into his ass and -- as you shallowly rut against him -- spills down your" / Shaft^s
				/ ", splattering onto the ground below in steaming globs, superheated from the heat of the minotaur's guts."
				/ Paragraph / "The minotaur snuffles and groans beneath you, and you can feel from inside the muscular ripples across his stomach and hips that have his cock twitching and smacking up against his chest, splattering glassy pre with enough force that some splatters"
				/ case locoplan b of
					Basic Slithering -> "back across your coils"
					_ -> "back against your calves"
				/ ". He slumps forward, one huge hand reaching down to wrap around his cock, and he strokes himself just once or twice before his entire body shudders; he's coming all across the ground before you've finished unloading inside him."
				/ Paragraph / case locoplan b of
					Basic Slithering -> c "You droop down, coils spilling off his sides as you go slack"
					_ -> "You sluggishly"
						/ case locoplan b of
							Basic Naga -> "slither"
							_ -> "step"
						/ "backwards"
				/ ", and your" / Cock^s / Pulls^s / "out, partway, with a messy slurp, boiling come drooling out of his spread asshole, the thick muscle slowly clenching and spreading in time with his heaving chest. Come spills down across his haunches, winding its way through his crackling obsidian spines"
				/ case locoplan b of
					Basic Slithering -> "and all over the coiled mound of your form"
					_ -> mempty
				/ "."
	] <> fuckHimCloser b m

fuckHimCloser :: Encounter Index () MinotaurMiner
fuckHimCloser b m =
	[ Narration2 $ "You pull all the way out of his disheveled body,"
		/ case locoplan b of
			Basic x | x `elem` [Naga, Slithering] -> "slithering"
			_ -> "stepping"
		/ "away, and he stays"
		/ case locoplan b of
			Basic x | x `elem` [Biped, Naga] -> "sagging against the wall"
				| x `elem` [Centaur, Quadruped, Slithering] -> "on all fours"
			f -> bodyFail "fuckHimCloser" f
		/ "for a long moment, asshole cratered, come freely gushing from his ass, before he sluggishly stands."
		/ Paragraph / "His cock is bloated with his load, tarry ooze collecting in half-molten globs across his cockhead, urethra glowing from the heat of his come. He sags back against the wall, almost idly wrapping a hand around the mess and manually pulling it out, load emerging like an enormous sound, glass and molten rock warping as he peels the entire thing out of his dick and casts it aside. He turns to look at you, cock still sagging down, underside swelling and warping from the weight of his come backed-up inside him."
	, dialog m $ "Yeah, y'did good."
	, Narration2 $ c "He stoops and reaches for his drill, letting it smack against his leg. His gut is still visibly swollen, his giant blocky muscles warped around the mass of come you pumped inside."
	, dialog m $ "You know where to find me, if you wanna tear up my ass more."
	, FauxChoice "yea"
	, Narration2 $ c "It takes him a bit, but he eventually turns back to the wall, fiddling with his drill, all while thick cords of come spill down the backs of his legs, forming a bubbling puddle around his hooves."
	]
