{-# LANGUAGE MultiParamTypeClasses #-}
module Sites.Hell.Events.Hubur.NatureSpirit
	( NatureSpirit(..)
	, Index
	, describe

	, deck
	, scene

	, name
	, bits
	, variants
	) where

import Prelude hiding ((/), (^))

import Sites.Hell.Events.SceneUtils hiding ((/))
-- import Sites.Hell.Events.Construction ((/))

import Sites.Hell.Events.Hubur

name :: String
name = "nature spirit"

data NatureSpirit = NatureSpirit
	deriving (Eq, Ord, Show, Read)

instance Random NatureSpirit where
	randomR _ = random
	random = getRand $ pure NatureSpirit

instance ToJSON NatureSpirit where
	toJSON NatureSpirit = object
		[ pack "name" .= name
		, pack "data" .= ([] :: [Int])
		]

bits :: Value -> Value
bits _ = object
	[ pack "name" .= name
	, pack "data" .= ([] :: [Int])
	]

variants :: [(MapZone, ())]
variants =
	[ (Glade, ())
	]
instance FromJSON NatureSpirit where
	parseJSON (Object vs) = case (parse (.: pack "name") vs, parse (.: pack "data") vs :: Result [Int]) of
			(Success pName, Success [])
				| pName == name -> return NatureSpirit
			_ -> mzero
	parseJSON _ = mzero

deck :: RandomGen g => Rand g (Enumerable NatureSpirit)
deck = return . pure $ NatureSpirit

data Index = Dummy
	deriving (Eq, Ord, Show, Read)

instance Scene Index () NatureSpirit where
	link f = case f of
		_ -> error "bad link"

	display = fmap toLower . show
	vardisplay = fmap toLower . show

scene :: Encounter Index () NatureSpirit
scene b n =
	[ Narration2 $ c "You come across a nature spirit."
	] <> describe n -- <> error "bad scene"

--- actual event start

describe :: NatureSpirit -> [Event NatureSpirit Index ()]
describe n =
	[ Narration2 $ c "He's a centaur, with the lower body of a powerful draft horse. He has a pair of massive tined antlers sprouting from his head, wreathed in flowering ivy. His skin is a dark tan, and his coat and hair are shaggy blond, with darker dapples across his flanks and the back of his head. There are coils of thorny vines wound across his shoulders and arms, biting into his flesh. He smells almost oppressively floral, with a heady aroma of nectar surrounding him."
	]
