{-# LANGUAGE MultiParamTypeClasses #-}
module Sites.Hell.Events.Hubur.Obelisk
	( Obelisk(..)
	, deck
	, scene

	, name
	, bits
	, variants
	) where

import Prelude hiding ((/), (^))

import Sites.Hell.Events.SceneUtils hiding ((/))
-- import Sites.Hell.Events.Construction ((/))

import Sites.Hell.Events.Hubur

name :: String
name = "obelisk"

data Obelisk = Obelisk
	deriving (Eq, Ord, Show, Read)

instance Random Obelisk where
	randomR _ = random
	random = getRand $ pure Obelisk

instance ToJSON Obelisk where
	toJSON Obelisk = object
		[ pack "name" .= name
		, pack "data" .= ([] :: [Int])
		]

bits :: Value -> Value
bits _ = object
	[ pack "name" .= name
	, pack "data" .= ([] :: [Int])
	]

variants :: [(MapZone, ())]
variants =
	[ (Badland, ())
	]

instance FromJSON Obelisk where
	parseJSON (Object vs) = case (parse (.: pack "name") vs, parse (.: pack "data") vs :: Result [Int]) of
			(Success pName, Success [])
				| pName == name -> return Obelisk
			_ -> mzero
	parseJSON _ = mzero

deck :: RandomGen g => Rand g (Enumerable Obelisk)
deck = return . pure $ Obelisk

data Index = Dummy
	deriving (Eq, Ord, Show, Read)

instance Scene Index () Obelisk where
	link f = case f of
		_ -> error "bad link"

	display = fmap toLower . show
	vardisplay = fmap toLower . show

scene :: Encounter Index () Obelisk
scene b z = describe b z -- <> error "bad scene"

--- actual event start

describe :: Encounter Index () Obelisk
describe _ z =
	[ Narration2 $ c "In the middle of the wastes, there's a vast obelisk made of rich purple-black obsidian. As you approach closer, it almost seems to blot out the sky, warping like a fisheye lens to unfurl across the sky without ever changing, shadowing you beneath its twisted shape. Its surface is etched, nearly too finely to be seen, in innumerable glyphs, unknown text in the language of demons. The air around it seems to hum."
	]
