{-# LANGUAGE MultiParamTypeClasses #-}

module Sites.Hell.Events.Hubur.PaperRook
	( PaperRook(..)
	, deck
	, scene

	, name
	, bits
	, variants
	) where

import Prelude hiding ((/))

-- import Sites.Hell.Events.Construction ((/))
import Sites.Hell.Events.SceneUtils

import Sites.Hell.Events.Hubur

name :: String
name = "paperrook"

data PaperRook = PaperRook
	deriving (Eq, Ord, Show, Read)

instance Random PaperRook where
	randomR _ = random
	random = getRand $ pure PaperRook

instance ToJSON PaperRook where
	toJSON PaperRook = object
		[ pack "name" .= name
		, pack "data" .= ([] :: [Int])
		]

bits :: Value -> Value
bits _ = object
	[ pack "name" .= name
	, pack "data" .= ([] :: [Int])
	]

variants :: [(MapZone, ())]
variants =
	[ (FactoryStacks, ())
	]

instance FromJSON PaperRook where
	parseJSON (Object vs) = case (parse (.: pack "name") vs, parse (.: pack "data") vs :: Result [Int]) of
			(Success pName, Success [])
				| pName == name ->
					case pure PaperRook of
							Nothing -> mzero
							Just a -> return a
			_ -> mzero
	parseJSON _ = mzero

deck :: RandomGen g => Rand g (Enumerable PaperRook)
deck = return $ pure $ PaperRook

data Index = Dummy
	deriving (Eq, Ord, Show, Read)

instance Scene Index () PaperRook where
	link f = case f of
		_ -> error "dummy index"

	display = fmap toLower . show
	vardisplay = fmap toLower . show

scene :: Encounter Index () PaperRook
scene _ c =
	[ description c
	-- , error "bad scene"
	]

description :: PaperRook -> Event PaperRook Index ()
description w = Narration2 $
	c "The loose pages are folded into the shapes of birds. They perch on the high shelves and make dry, rustling caws. Sometimes they rise in a chorus, sending sheaves of poorly-balanced paper toppling down the shelves in an avalanche; sometimes when this happens a fresh rook rises up from the torrent to meet the flock."
