{-# LANGUAGE ViewPatterns #-}
{-# LANGUAGE MultiParamTypeClasses #-}

module Sites.Hell.Events.Hubur.Sahagin
	( Sahagin
	, deck
	, scene

	, name
	, bits
	, variants
	) where

import Prelude hiding ((/))

import Server.JSON
import Utility.Rand

import Sites.Hell.Events.SceneUtils
import Sites.Hell.Events.Construction ((/))

import Sites.Hell.Events.Hubur

name :: String
name = "sahagin"

data Sahagin = Sahagin
	deriving (Eq, Show)

instance Random Sahagin where
	randomR _ = random
	random = getRand $ return Sahagin

instance ToJSON Sahagin where
	toJSON Sahagin = object
		[ pack "name" .= name
		, pack "data" .= ([] :: [Int])
		]

bits :: Value -> Value
bits _ = object
	[ pack "name" .= name
	, pack "data" .= ([] :: [Int])
	]

variants :: [(MapZone, ())]
variants =
	[ (Shallows, ())
	]

instance FromJSON Sahagin where
	parseJSON (Object vs) = case (parse (.: pack "name") vs, parse (.: pack "data") vs :: Result [Int]) of
			(Success pName, Success [])
				| pName == name ->
				case pure Sahagin of
						Nothing -> mzero
						Just h -> return h
			_ -> mzero
	parseJSON _ = mzero

deck :: RandomGen g => Rand g (Enumerable Sahagin)
deck = return $ pure $ Sahagin

data SahaginScene = Dummy
	deriving (Eq, Show)

instance Scene SahaginScene () Sahagin where
	link x = case x of
		Dummy -> error "unfinished scene instance"
	display = fmap toLower . show
	vardisplay = fmap toLower . show


description :: Sahagin -> Event Sahagin SahaginScene ()
description Sahagin = Narration2 $
	"The water churns before the sahagin surfaces."
	/ Paragraph / "He's roughly bipedal, with elongated webbed feet that could never walk on land, and hands to match. He has a broad tail with a wide fin at the tip, constantly lashing and churning the water around him. His eyes are twin circles, flat yellow and gleaming. He's covered in greenish scales, a muddier color across his chest and underbelly. His mouth is vast and full of thick triangular teeth, serrated along the edge. Fins sprout from his body: framing his face, sprouting from the outer sides of his forearms and legs, and with one long crest down his back, tapering to lapped scales just below the base of his tail."

scene :: a -> Sahagin -> [Event Sahagin SahaginScene ()]
scene _ s =
	[description s]
