{-# LANGUAGE ViewPatterns #-}
{-# LANGUAGE MultiParamTypeClasses #-}
{-# LANGUAGE FlexibleContexts #-}

module Sites.Hell.Events.Hubur.SobekSheut
	( SobekSheut
	, deck
	, scene

	, name
	, bits
	, variants
	) where

import Prelude hiding ((/), (^))

import Data.Maybe
import Control.Monad

import Server.JSON
import Sites.Hell.Events.SceneUtils hiding ((/), Dick(Dick))
import Sites.Hell.Events.Construction ((/), (^))

import Sites.Hell.Events.Hubur

import Description.TfNode (Animal(..))
import Description.Build hiding (Dick(Dick))
import Description.Body.Sample hiding (feet, (?), Dick(Dick))

{- todo:


* sobek expansion "Some of his common epithets betray this nature succinctly, the most notable of which being: "he who loves robbery", "he who eats while he also mates", and "pointed of teeth"."


	* sobeks that are after your soullllll, a la the soul thief concept. other sobeks that talk about it like, um, we don't approve of just putting souls in sacks and then trying to embody them, but hey look. bodies are great. don't you want a body? we'd be happy to give you a body. some people don't think they want a body, but then they just happen to end up with one and they love it. think about it.
		* that could end up having a 'talk' challenge about something? not sure what it would really be about
	* stilt-hut location, containing a sobek and also an alchemy shop where you can buy [STELLAR] and potentially refine it into sun/moon/void/stars

talk stuff like, yeah but you don't have a _real_ body. everybody knows yr still just a little floating soul, they're just willing to accommodate you.



EXPANDED TREE:

	-> hey what's up w/ the...
		-> lesser hellhounds
			the sheut turns to the side and spits, which is quite an achievement with a crocodile snout.
			> ugh. i guess the dregs coming down off the mountain aren't so bad. built up such a structure of impulse they're practically beasts themselves. but the royals -- i'm glad they stay far away from here.

		-> hellhound knights
			> they're here because of cerberus. it'd be great if they could just take each other out, but everything in hell happens so slowly.

		-> clay men
			mutated/gloaming ->
				> i suppose they're like brothers of mine. birthed by the same forces that gave me this body. but... no soul, no concreteness. you know they're not discrete, right? just the river banks bleeding one mind into another all down its length.

			wet ->


		-> dryads
			> just dryads.


		-> sons of hamar-tabal
			> things birthed from the river horror. we don't know what they want. i mean, what they really want.

		-> flame demons
			the sheut sighs.
			> they're exhausting. smart, but so dedicated to their own theories. not willing to admit they don't know everything.

		-> ganzer workers
			> i heard back in the day they used to be the Authority's enforcers down here in hell. who knows if any of them are still loyal.

		-> gargoyles
			> just constructs. like pet robots.

-}

name :: String
name = "sobek"

data SobekSheut = SobekSheut
	{ bodytype :: Bodytype
	, river :: River
	, dicksize :: DickSize
	}
	deriving (Eq, Show)

data Bodytype = Muscular | Fat
	deriving (Eq, Ord, Enum, Bounded, Show)

data River = Wet | Mutated | Gloaming
	deriving (Eq, Ord, Enum, Bounded, Show)

data DickSize = Big | Huge
	deriving (Eq, Ord, Enum, Bounded, Show)

deck :: RandomGen g => Rand g (Enumerable SobekSheut)
deck = do
	muscles <- liftRand $ shuffle [Muscular, Fat]
	river <- liftRand $ shuffle [Wet, Mutated, Gloaming]
	dicksize <- liftRand $ shuffle [Big, Huge]
	return $ SobekSheut
		<$> from muscles
		<*> from river
		<*> from dicksize

data SobekMind = SobekMindDummy
	deriving (Eq, Ord, Enum, Bounded, Show)

mind :: Enumerable SobekMind
mind = pure SobekMindDummy

instance Random SobekSheut where
	randomR _ = random
	random = getRand $ SobekSheut
		<$> genRandom
		<*> genRandom
		<*> genRandom

instance ToJSON SobekSheut where
	toJSON (SobekSheut b r d) = object
		[ pack "name" .= name
		, pack "data" .= [fromEnum b, fromEnum r, fromEnum d]
		]

bits :: Value -> Value
bits _ = object
	[ pack "name" .= name
	, pack "data" .= [Null, Null, Null]
	]

variants :: [(MapZone, ())]
variants =
	[ (SwampSobek, ())
	, (Shallows, ())
	]

instance FromJSON SobekSheut where
	parseJSON (Object vs) = case (parse (.: pack "name") vs, parse (.: pack "data") vs) of
			(Success pName, Success [b, r, d])
				| pName == name ->
				case SobekSheut
					<$> safeToEnum b
					<*> safeToEnum r
					<*> safeToEnum d of
						Nothing -> mzero
						Just h -> return h
			_ -> mzero
	parseJSON _ = mzero

data Index
	= FuckDialog | FauxTalk | Leave
	| Fuck
	| TalkOptions FuckState | Talk Topic FuckState | LeaveAfter
	deriving (Eq, Ord, Show)

data FuckState = NoFuck | Fucked
	deriving (Eq, Ord, Show)

data Topic = Fucklust | LikeFucking | Mutations | ProperBody | Think | Nah | LikeThis | Others | About OtherEncounter
	deriving (Eq, Ord, Show)

data OtherEncounter = LesserHellhounds | HellhoundKnights | ClayMen | Dryads | SonsOfHamarTabal | FlameDemons | GanzerWorkers | Gargoyles
	deriving (Eq, Ord, Enum, Bounded, Show)


instance Scene Index () SobekSheut where
	link x = case x of
		FuckDialog -> fuckDialog
		FauxTalk -> fauxTalk
		Leave -> leave
		Fuck -> fuck
		TalkOptions fucked -> talkOptions fucked
		Talk topic fucked -> talk topic fucked
		LeaveAfter -> leaveAfter
	display = fmap toLower . show
	vardisplay = fmap toLower . show

dialog :: Convertible a EventReel => SobekSheut -> a -> Event SobekSheut Index ()
dialog _ = Dialog2 "/static/img/icon.png" "Sobek Sheut" . convert

-- maybe the description itself should vary if yr on an unfuckable form. since then he's not TURNED ON. & the scene collapses down into one w/ no sex option but the same talk options that would normally be post-sex
description :: SobekSheut -> Event SobekSheut Index ()
description s = Narration2 $ "The river surface ripples before a form rises from the murky water."
	/ Paragraph / "It's a"
	/ case river s of
		Wet -> mempty
		_ -> "mutated monster: a"
	/ case bodytype s of
		Muscular -> "strongly-muscled"
		Fat -> "corpulent"
	/ "humanoid, with the head of a river crocodile"
	/ case river s of
		Mutated -> ". His body is warped and deformed, lopsided"
			/ case bodytype s of
				Muscular -> ", muscles grown to grotesque, inhuman size, with old scars where they've torn through his skin across his shoulders and chest"
				Fat -> mempty
			/ ". There are thick clusters of asymmetrical pustules growing under his scales, filled with a brilliant glowing substance."
			/ case bodytype s of
				Fat -> "His limbs are swollen enormously and erratically, hide grown dense and spongy where glowing ooze drips down his forearms and calves."
				Muscular -> mempty
			/ "His face is distorted: the right side looks as if his eyeball burst and everywhere its fluid spilled a fresh eye grew, forming clusters, large and small, of glowing red eyes streaked in a burn pattern across his face."
		Gloaming -> c "in stark black-and-white: his long muzzle in a permanent toothy grin, teeth a flat black; inner flesh of his mouth dimly glowing; his eyes flat black pits with a gleaming reflection when they catch the light."
		Wet -> ": his long muzzle in a permanent toothy grin; his eyes reflecting red. Dark water streams down his frame"
			/ case bodytype s of
				Muscular -> ", outlining every thick muscle."
				Fat -> ", spilling over his round curves."
	/ Paragraph / "He strides closer" / case bodytype s of
		Muscular -> ", hide audibly creaking, drawn taut over his"
			/ case river s of
				Mutated -> "mutated"
				_ -> "bulging"
			/ "muscles."
		Fat -> c ", lumbering through the shallow water."
	/ case river s of
		Mutated -> case bodytype s of
			Muscular -> c "His forearms and calves are thickly muscled, but even the muscles seem small compared to the mass of glowing pustules bubbling up from his flesh, with a thick froth bubbling up across the backs of his forearms, turning into sparse clusters up the back of his arms."
			Fat -> c "His bloated gut is warped again by massive blisters, clusters squashed together in folded layers over his sides and down his stomach, looking nearly ready to burst simply from his swaying steps."
		Wet -> "His scales are a rich golden-green, thicker and duller at his elbows and shoulders,"
			/ case bodytype s of
				Muscular -> "almost gleaming down the center of his muscular chest."
				Fat -> "shining brightly all across the span of his swaying gut."
		Gloaming -> "It looks for a moment like he's steaming from stepping from the water, but the stuff rising from him is like black smoke, constantly limning his body; nothing to do with the water. His scales are a light-eating black, and the edge of each scale is painted a brilliant white, forming an organic, geometrical pattern all across his body, thinning across his hands, down the center of his back, and spreading across his"
			/ case bodytype s of
				Muscular -> "swollen muscles."
				Fat -> "hanging gut."
	/ case bodytype s of
		Muscular -> "His thick thighs vanish into the water, like the trunks of trees, and just above that his skin swells into a fat slit, flesh distended from the inside: slit parted to reveal"
		Fat -> "He has a flushed, gaping slit between his legs, nearly entirely covered by his hanging gut; it's parted to reveal"
	/ case river s of
		Wet -> c "rich purple-red flesh"
		Gloaming -> c "gnarled grey-black flesh"
		Mutated -> "the misshapen flesh of his cock"
			/ case dicksize s of
				Big -> ", too big to fit fully inside him; the tip juts out perpetually, flesh studded with glowing pustules like pearls"
				Huge -> ", far too big to fit fully inside him; a heavy, swollen arch juts out from his body, its flesh gone leathery and hard from its exposure. His length is dotted with fat pustules like glowing pearls, drenched with glowing slime constantly drooling out from his prolapsed vent."
	/ case river s of
		Mutated -> mempty
		_ -> case dicksize s of
			Big -> ", the very tip of his crocodile cock peeking out, too big to fit fully inside."
			Huge -> ", his cock far too big to fit in his vent: even soft a heavy, swollen arch of flesh spills out from him, covered in the sloppy folds of his perpetually-prolapsed slit, all the flesh gone rough and leathery from its unending exposure."

scene :: MarkedScene Index () SobekSheut
scene _ s =
	[ SetFlag (Global MetSobekSheut) 1
	, description s
	] <>
	[ Choices
		[ ("uh i guess you wanna fuck huh", FuckDialog)
		, ("do you uh wanna talk", FauxTalk)
		, ("yeah i think i'm just gonna go", Leave)
		]
	]

fauxTalk :: MarkedScene Index () SobekSheut
fauxTalk b s = case locoplan b of
	x
		| x `elem` [Basic Formless, Spec Orb, Spec FloatingHead, Spec FloatingDick] -> actualTalk NoFuck b s
	_ ->
		[ Narration2 $ "He snaps his teeth and leers at you with" / case river s of
				Mutated -> "all his"
				_ -> mempty
			/ "glowing eyes."
		, Dialog "/static/img/icon.png" "Sobek Sheut"
			[ "Nah we can talk later; let's fuck now."
			]
		] <> sexOptions b s

talkOptions :: FuckState -> MarkedScene Index () SobekSheut
talkOptions fucked _ s =
	[ Choices $ catMaybes
		[ Just ("so what's with the haze of fuck lust thing you got going on", Talk Fucklust fucked)
		, case river s of
			Wet -> Nothing
			Gloaming -> Just ("uh what's with the weird glow", Talk Mutations fucked)
			Mutated -> Just ("uh what's with the gross mutations", Talk Mutations fucked)
		--, Just ("hey what's up with the...", Talk Others fucked)
		, Just ("okay bye", case fucked of
			NoFuck -> LeaveAfter
			Fucked -> LeaveAfter)
		]
	]

{-
	-> hey what's up w/ the...
		-> lesser hellhounds
			the sheut turns to the side and spits, which is quite and achievement with a crocodile snout.
			> ugh. i guess the dregs coming down off the mountain aren't so bad. built up such a structure of impulse they're practically beasts themselves. but the royals -- i'm glad they stay far away from here.
		-> hellhound knights

		-> clay men
			mutated/gloaming ->
				> i suppose they're like brothers of mine. birthed by the same forces that gave me this body. but... no soul, no concreteness. you know they're not discrete, right? just the river banks bleeding one mind into another all down its length.
		-> dryads

		-> sons of hamar-tabal
		-> flame demons
		-> ganzer workers
		-> gargoyles
-}

talk :: Topic -> FuckState -> MarkedScene Index () SobekSheut
talk topic fucked _ s = case topic of
	Fucklust ->
		[ dialog s $ "Listen. It's about having a body. Hell isn't real, not the way you're used to. It's all thoughts and constructions and symbols. Smoke and mirrors. Having a body -- a real body -- can be grounding. Heartbeat and flesh and muscle and hormones. Reflexes. Hungers."
			/ Paragraph / "It's also about... reproduction. Fucking. Souls are spun out of the void, opened through divine gates in the mortal world and immured into bodies there. They only slowly make their way to hell. A life among the living leaves imprints. Expectations. A soul born in hell -- that would be a triumph. A soul without the limitations of the mortal world."
		, Choices
			[ ("so do you even really... like fucking? like aside from a physical drive?", Talk LikeFucking fucked)
			, ("<==", TalkOptions fucked)
			]
		]
	LikeFucking ->
		[ dialog s $ "Well, that's the high-minded reason. But it's also because fucking feels good. We spend most of our time in a manufactured rut, but it's not" / em "really" / "because we have any hopes of knocking anybody up. Part of having a body is letting its impulses drive you."
			/ Paragraph / "If I didn't like fucking, I wouldn't have made it so I like fucking."
		, Choices
			[ ("<==", TalkOptions fucked)
			]
		]
	Mutations ->
		[ dialog s $ "Anybody ever tell you not to swim in the Hubur?"
		, Narration2 $ c "He spreads his arms, showing off his body."
		, dialog s $ "This is what happens. The water flows here from the lands of the living, and it's practically radioactive with life. Soak in it long enough and there're some changes."
			/ Paragraph / "Well, not for you, really, since you don't got a proper body."
		, Choices
			[ ("proper body?", Talk ProperBody fucked)
			, ("and... you like this?", Talk LikeThis fucked)
			, ("<==", TalkOptions fucked)
			]
		]
	ProperBody ->
		[ dialog s $ "You're a soul and you'll always be a soul. It's a thoughtform. Even when you build yourself into some big monster, it's not hard for demons to tell the difference between the actual thing and a soul dreaming big. People are just polite enough to not bring it up."
			/ Paragraph / "You know, I was once a soul like you, fresh from the river. We're kinda in the body business. We could get you a real body, if you want."
		, Choices
			[ ("uh i'll think about it", Talk Think fucked)
			, ("uh no thanks i think i'm good", Talk Nah fucked)
			]
		]
	Think ->
		[ dialog s $ "You do that."
		, Choices
			[ ("<==", TalkOptions fucked)
			]
		]
	Nah ->
		[ dialog s $ "Hey look. Bodies are great. We'd be happy to give you a body. Some people don't think they want a body, but then they just happen to end up with one and they love it. Think about it."
		, Choices
			[ ("<==", TalkOptions fucked)
			]
		]
	LikeThis ->
		[ dialog s $ "Uh, yeah."
		] <> case fucked of
			NoFuck -> []
			Fucked ->
				[ Narration2 $ "He gropes his cock, still leaking"
					/ case river s of
							Gloaming -> "gloaming grey come, flesh all gnarled up into immense gristly lumps"
							Mutated -> "chunks of glowing yellow come, some of the bulging pustules along the head having burst inside you"
							f -> bodyFail (Talk LikeThis Fucked) f
					/ ". He leers:"
				, dialog s "You seemed to like it pretty well when I was fucking you."
				]
		<> [ Choices
			[ ("<==", TalkOptions fucked)
			]
		]
	Others ->
		[ Choices2
			[ ("...the hellhounds", Talk (About LesserHellhounds) fucked, Just $ C (Global MetLesserHellhound) IsSet)
			, ("...the hellhound knights", Talk (About HellhoundKnights) fucked, Just $ C (Global MetHoundKnight) IsSet)
			, ("...the clay men", Talk (About ClayMen) fucked, Just $ C (Global MetClayMan) IsSet)
			, ("...the dryads", Talk (About Dryads) fucked, Just $ C (Global MetDryad) IsSet)
			, ("...the sons of hamar-tabal", Talk (About SonsOfHamarTabal) fucked, Just $ C (Global MetSonOfHamarTabal) IsSet)
			, ("...the flame demons", Talk (About FlameDemons) fucked, Just $ C (Global MetFlameDemon) IsSet)
			, ("...the ganzer workers", Talk (About GanzerWorkers) fucked, Just $ C (Global MetGanzerWorker) IsSet)
			, ("...the gargoyles", Talk (About Gargoyles) fucked, Just $ C (Global MetGargoyle) IsSet)
			, ("<==", TalkOptions fucked, Nothing)
			]
		]
	About _ -> []

fucklust :: FuckState -> MarkedScene Index () SobekSheut
fucklust fucked b s =
	[ Narration ["He snaps his head to the side, teeth chewing on nothing."]
	, Dialog "/static/img/icon.png" "Sobek Sheut"
		[ "Listen. It's about having a body. Hell can be... worryingly abstract, at times. Having a body, with all its hormones and impulses and flesh can be grounding. So we spend most of our time in a manufactured rut."
		, "It's also about... reproduction. fucking. Souls are spun out of the void and immured into bodies, in the mortal world, and only slowly make their way to hell. It leaves imprints. a soul born in hell -- that would be a triumph. A soul without the limitations of the mortal world."
		, "Well, that's the very high-minded reason. But it's also because fucking feels good."
		]
	] <> case fucked of
		NoFuck -> []
		Fucked ->
			[ Narration2 $ "He snaps his teeth at you, clawed hands creeping up to smear his load across your"
				/ hasNagaCloaca ? "cloaca" ?: "ass"
				/ ". His cock throbs, drooling fresh pre."
			, Dialog "/static/img/icon.png" "Sobek Sheut"
				["Doesn't it?"]
			]

-- TODO: actually an oral scene where he fucks yr face for floatinghead (and i guess optionally for other bodytypes too) would be nice
fuckDialog :: MarkedScene Index () SobekSheut
fuckDialog b s = case locoplan b of
	x
		| x `elem` [Basic Formless, Spec Orb, Spec FloatingHead, Spec FloatingDick] ->
			let orbs = case x of
				Spec FloatingHead -> "floating heads "
				Spec FloatingDick -> "flying dicks "
				_ -> "orbs "
			in
				[ Narration
					[ "He looks at you and gives himself a shake, blinking a few times. When he talks, it's in a slightly more normal voice; less rasping."
					]
				, Dialog "/static/img/icon.png" "Sobek Sheut"
					[ "Oh uh. Sorry, it's-- " <> orbs <> "aren't really what we're going after?"
					]
				, Narration
					[ "There's an awkward silence only punctuated by the creak of his hide when he shifts his weight."
					]
				, Dialog "/static/img/icon.png" "Sobek Sheut"
					[ "Uh it's a divine calling, okay, we're not just into fucking for the sheer joy of it."
					, "Plus I mean-- orbs aren't my type, honestly. No offense."
					, "Anyway uh you wanna talk or anything?"
					]
				] <> actualTalk NoFuck b s
	_ ->
		[ Dialog "/static/img/icon.png" "Sobek Sheut"
			[ "Yeah you're real observant."
			, "So let's fuck huh, how about it."
			]
		] <> sexOptions b s

leave :: MarkedScene Index () SobekSheut
leave _ _ =
	[ Narration
		[ "The sheut pouts, which is real hard to do on a crocodile face. You leave."
		]
	]

leaveAfter :: MarkedScene Index () SobekSheut
leaveAfter _ _ =
	[ Dialog "/static/img/icon.png" "Sobek Sheut"
		[ "Oh uh, bye."
		]
	]

sexOptions :: MarkedScene Index () SobekSheut
sexOptions b s =
	[ Choices
		[ ("yeah sure", Fuck)
		, ("uh i think i'm just gonna... go", Leave)
		]
	]

fuck :: MarkedScene Index () SobekSheut
fuck b sobek =
	[ Narration2 $ "He sloshes up out of the water, black water streaming down his dark scales. He leers at you, drool spilling out the sides of his mouth, over his giant crocodile teeth." / case bodytype sobek of
				Muscular -> "His cock throbs between his thighs, vent bulging up from inside as his half-hard length spills out."
				Fat -> "His vent shudders and swells beneath his gut, his cock slowly drooling out in a heavy mass."
		/ "The head is thin and nearly flat, closer to the head of a nail than anything else: a bulge outwards, like a cap atop his shaft, with its edge convolved and crumpled over itself"
		/ case river sobek of
			Mutated -> ", big warted bulges along the rim, glowing pearls of slime embedded across his" / case dicksize sobek of
					Big -> mempty
					Huge -> "leathery"
				/ "cockhead"
			_ -> mempty
		/ ". His urethra bulges out from the tip, two lips stretched out into sharp spikes jutting out from the center of his cockhead, spreading and pressing together as he slowly pulses out beads of" / case river sobek of
				Wet -> "slimy"
				Gloaming -> "gloaming"
				Mutated -> "glowing fluorescent yellow"
		/ "pre."
		/ case dicksize sobek of
			Big -> "His shaft is thick and fat, growing slowly thicker as more of it emerges,"
			Huge -> "His shaft is enormously fat, thick and only getting thicker as more of it emerges,"
		/ "until finally the bunched muscles there to evert his shaft, push it inside-out into the open, prolapse from his gaping vent, bracketing his shaft with two huge half-spheres of" / case river sobek of
				Wet -> "visibly striated raw purple muscle"
				Gloaming -> "gnarled grey-black muscle"
				Mutated -> "lumpy, pustule-ridden muscle"
		/ "."
		/ Paragraph / "The sheut reaches down to stroke himself, one hand with its fingers splayed across his vent, tugging the gaping lips wider,"
		/ case dicksize sobek of
			Big -> "the other grabbing his shaft"
			Huge -> "the other cupping partway around his brutally-fat shaft"
		/ "and" / case bodytype sobek of
			Muscular -> "stroking it roughly"
			Fat -> "pinning it up across his hanging gut, squeezing it hard"
		/ ". His entire body shudders as he twists and tugs his cock, the drool of pre turning into a sharp squirt, splattering lewdly across his hand."
	, Dialog "/static/img/icon.png" "Sobek Sheut" ["Fuck."]
	, Narration ["He rasps, hot breath steaming up into the air."]
	] <>
	(case locoplan b of
	Basic x
		| x `elem` [Biped, Naga] -> bipedNagaFuck b sobek
		| x `elem` [Centaur, Quadruped] -> centaurQuadFuck b sobek
	Basic Slithering ->
		[ Dialog "/static/img/icon.png" "Sobek Sheut" ["Twine yourself around me. Let me sheath myself inside you!"]
		, Narration2 $ "He says it with one hand rubbing his cock, hips fucking the air in lewd thrusts. You oblige. He reaches out, his pre-slimy hands wrapping around the heavy swell of your body and pulling you atop him,"
			/ case bodytype sobek of
				Muscular -> "body only struggling a little with the heavy load. You loop over his arms and shoulders, body dangling down across his front, and"
				Fat -> "letting you drape across his thick curves, looping along his arms and then down across the huge bulk of his gut; you dangle down across his front, and"
			/ "he grabs your hanging coil and ruts his cock against it, cock sliding across your underbelly, fingers"
			/ hasCloaca
				? ("sliding up your underbelly to dig into your flushed cloaca" / hasDick
					? (", your"
						/ case cockCount b of
							2 -> c "twin cocks"
							_ -> c (Cock^s)
						/ "dragging against his hide")
					?: c "fingers spreading your lips wide")
				?: (c "prodding up and down until he finds the thin vent of your asshole")
			/ ". His fingers shove inside, dragging you bodily down to his cock,"
			/ case river sobek of
				Mutated -> "pustule-pearled"
				_ -> mempty
			/ "cockhead dribbling against the lips of your vent"
			/ case river sobek of
				Mutated -> "oozing foul pre into you in spurts, burning as it slowly drools out in chunky globs"
				_ -> mempty
			/ "."
		]
	f -> bodyFail Fuck f)
	<> [ Narration2 $ "He snarls, snapping his teeth on nothing, and rolls his hips back, "
		/ case planLocomotion $ bodyplan b of
			Basic x
				| x `elem` [Biped, Naga, Slithering] -> case river sobek of
						Mutated -> "grotesque"
						_ -> mempty
					/ "cockhead dragging"
					/ case x of
						Biped -> "between your" / partAdjective Ass / "ass cheeks, "
						Naga -> "up your" / partAdjective Underbelly / "underbelly, "
						Slithering -> case dickLocation b of
							Just DickExternal -> c "across your dick,"
							Just DickSheathed -> c "over your sheath,"
							Just _ -> "over your flushed" / sheath / ","
							_ -> c "over your flushed cloaca,"
						f -> bodyFail Fuck f
					/ "pressing against his fingers for a moment."
					/ hasLocotype Slithering
						? ("His palm"
							/ hasDick
								? ("pins your" / Cock^s / "to your underbelly, grinding up and down")
								?: "grinds against your flushed lips "
							/ "as he pulls you bodily down onto his cock")
						?: (c "before he pulls his hand free and shoves in, cockhead ramming against your still-tight hole for a moment before he breaches inside.")
				| x `elem` [Quadruped, Centaur] -> case bodytype sobek of
						Muscular -> "muscular"
						Fat -> "thick"
					/ "thighs shifting against your"
					/ (if legCount b > 4
						then "hindmost legs"
						else "hind legs")
					/ "as he arches forward, cockhead sliding up your cheeks to dig into your hole. His fingers slide against his" / case river sobek of
						Mutated -> "lumpy"
						_ -> mempty
					/ "shaft for a moment, snarl building into a hissing roar as he lurches forward."
			f -> bodyFail Fuck f
		/ "He slams most of his cock into you in a single thrust"
		/ case locoplan b of
			Basic x | x `elem` [Quadruped, Centaur] -> "that sends you a half-step forward, front" / feet / "braced into the silty mud, hole flexing and clenching around his shaft"
			_ -> mempty
		/ "."
		/ "He roars, hissing and clacking, and drags himself back, drawing half his cock out before he shoves forward again, slamming to the hilt in your"
		/ hasNagaCloaca ? "cloaca" ?: "ass"
		/ case bodytype sobek of
			Muscular -> ", his swollen eversion muscles pulsing against your hole"
			Fat -> case locoplan b of
				Basic Slithering -> ", pulling your body down further across the span of his huge gut"
				Basic Biped -> ", huge gut mashing against your ass"
				Basic Naga -> ", huge gut coming down hard against your stomach and chest"
				Basic x | x `elem` [Centaur, Quadruped] -> ", huge gut mashing against your ass, weighing down across your back"
				f -> bodyFail Fuck f
		/ ". His cock throbs, a gush of hot pre washing inside"
		/ case river sobek of
			Mutated -> "and burning"
			_ -> mempty
		/ ", streaming down the walls of your"
		/ hasNagaCloaca ? "cloaca" ?: "ass"
		/ hasCloacaDick ? (", and spilling over" / "your length"^p "the lengths of your dicks")
		/ ", sloppily tugging at your insides when the sheut drags back and rams forward again, instantly hammering your cramping guts, spread wide around the girth of his fat cock."
		/ Paragraph / case locoplan b of
			Basic Slithering -> c "He gets right to it, thrusting hard, huge clawed hands clasped around your body; pulling you down onto his cock just as much as he's thrusting up."
			Basic x | x `elem` [Biped, Naga, Quadruped, Centaur] -> "He gets right to it, thrusting hard, driving"
				/ (if x `elem` [Quadruped, Centaur]
					then "your" / feet
					else c "you")
				/ "into the silty mud at the river's edge, "
				/ case x of
					x
						| x `elem` [Biped, Naga] -> hasLocotype Biped
								? ("your legs" / case bodytype sobek of
										Muscular -> "thrown over his shoulders"
										Fat -> "pinned to your chest from the bulk of his gut"
									/ ",")
								?: ("your lower body between his legs, tail curled in chunky folds around one of his legs," / case bodytype sobek of
										Fat -> "his gut like a boulder pressed down across your stomach and chest,"
										Muscular -> mempty)
							/ "his huge claws gripping your" / hasLocotype Biped ? "thighs" ?: "sides"
							/ case bodytype sobek of
								Muscular -> "or drifting across your stomach and chest"
									/ hasDick ? (", sometimes tugging on your own drooling" / Dick^s)
								Fat -> mempty
						| x `elem` [Quadruped, Centaur] -> c "his huge claws gripping your flanks and pulling your body back to meet his thrusts"
							/ case bodytype sobek of
								Fat -> ", gut a churning weight jerking forward across your back with each thrust"
								Muscular -> mempty
					f -> bodyFail Fuck f
				/ "."
			f -> bodyFail Fuck f
		/ "His scaly vent grinds against "
		/ (hasNagaCloaca ? "your own" ?: "your asshole")
		/ ", his cock gushing huge stringy bursts of pre into "
		/ (hasNagaCloaca ? "your cloaca" ?: "your ass")
		/ ", slime webbing across the inner flesh of your hole and slurping back and forth, moving with each of his thrusts."
		/ Paragraph / "Given his general attitude, it's no surprise he doesn't last long. He goes hard, rocking your entire body with his thrusts, but it's only minutes before he comes. His body shudders, cock arching up, grinding against "
		/ (hasNagaCloaca
			? "the flushed and swollen inner walls of your cloaca"
			?: "the wall of your ass")
		/ ", and he thrusts faster, only drawing a scant inch of his cock out, working it back and forth. He hisses, breath catching in his throat, and then he's coming, huge wet glugs of sludgy come spurting into you with each thrust, smearing across his webs of pre and slowly dragging the gummy mess down, coating his shaft in a gloppy wave that eventually bursts from your"
		/ (hasNagaCloaca ? "hole" ?: "ass")
		/ "," / case river sobek of
			Wet -> "sludgy grey-white come"
			Gloaming -> "gloaming grey-white come"
			Mutated -> "chunky glowing-yellow ooze"
		/ (case locoplan b of
			Basic x
				| x `elem` [Slithering, Naga] -> case bodyMat_ Tail b of
					Solid (FMat _ Scales) -> "splattering down your scales"
					Solid (FMat _ Protoplasm) -> "oozing over your slimy protoplasm"
					_ -> "splattering down your body"
				| x `elem` [Centaur, Biped, Quadruped] -> case bodyMat_ Legs b of
					Solid (FMat _ Skin) -> "splattering across your cheeks"
					Solid (FMat _ Fur) -> "clinging to your fur in thick globs"
					Solid (FMat _ Scales) -> "smearing across your scales"
					Solid (FMat _ Coat) -> "smearing into your stiff coat in grubby streaks"
					Solid (FMat _ Protoplasm) -> "oozing across your slimy protoplasm"
					_ -> "splattering down your body"
			f -> bodyFail Fuck f)
		/ case river sobek of
			Gloaming -> c ", leaving behind a weird fuming layer of smoke everywhere it touches, like the black fog constantly rippling of the sheut's form."
			_ -> ", shining the sheut's scales, pouring in rippling waves down"
				/ case planLocomotion $ bodyplan b of
					Basic Biped -> "your upturned cheeks"
					Basic x
						| x `elem` [Centaur, Quadruped] -> "your hind legs"
						| x `elem` [Naga, Slithering] -> "your underbelly"
					_ -> bodyFail Fuck $ planLocomotion $ bodyplan b
		/ ". He keeps thrusting, letting out a continual low groan, jaw hanging open. His cock squelches through the mess of his come, sharp squirts a diffuse wet impact"
		/ (hasNagaCloaca ? "in your flooded guts" ?: "in your ass")
		/ ", weight and slickness filling you with each heavy spurt. The smear of come drooling from your"
		/ (hasNagaCloaca ? "hole" ?: "ass")
		/ "increases to a sloppy flood by the time he finishes, each thrust -- slower now -- sending out a wash of come, burbling up around his shaft"
		/ case locoplan b of
				Basic x
					| x `elem` [Slithering, Naga] -> case bodyMat_ Tail b of
					Solid (FMat _ Scales) -> "and spilling in a thick, slimy river down your underbelly, spilling over your sides"
					Solid (FMat _ Protoplasm) -> "and spilling in a thick, slimy river down your underbelly, spilling over your sides"
					_ -> "and spilling in a thick, slimy river down your underbelly, spilling over your sides"
					| x `elem` [Centaur, Quadruped] -> case bodyMat_ Legs b of
						Solid (FMat _ Fur) -> "and spilling down your legs, soaking your fur to your skin"
						Solid (FMat _ Coat) -> "and spilling down your legs, submerging your short coat under its sloppy flow"
						_ -> "and spilling down your legs"
				Basic Biped -> case bodyMat_ Legs b of
					Solid (FMat _ Skin) -> "and spilling down the curve of your ass, forming a puddle around your hips"
					Solid (FMat _ Fur) -> "and clinging to your fur in thick globs, matting it to your skin"
					Solid (FMat _ Scales) -> "sliding down the curve of your ass, forming a sloshing puddle around your hips"
					Solid (FMat _ Coat) -> "a further soaking your sodden, matted coat"
					Solid (FMat _ Protoplasm) -> "and spilling down your ass"
					_ -> "and spilling down your ass"
				f -> bodyFail Fuck f
			/ ". He twitches, cock stirring inside you."
	, Dialog "/static/img/icon.png" "Sobek Sheut" ["Good."]
	, Narration2 $ "His voice rasps, and he looks down," / case river sobek of
				Mutated -> "all his"
				_ -> mempty
			/ "eyes half-lidded, mouth spread in a perpetual crocodile smile."
	, Dialog "/static/img/icon.png" "Sobek Sheut" ["The rut is overwhelming. But it's a joy to spend it as one such as you."]
	, Narration2 $ "His cock trembles again, half-hard, and he drags a few more times back and forth, cock a heavy, pulpy weight scraping up and down"
			/ (hasNagaCloaca ? "the walls of your cloaca" ?: "the walls of your ass")
			/ ", dragging out more of the mess of his load. He pulls back, wide cockhead digging against"
			/ (hasNagaCloaca ? "your flushed and swollen cloacal lips" ?: "the ring of your asshole")
			/ "for a moment before it peels out with a soft splat, leaving your "
			/ (hasNagaCloaca ? "opening" ?: "hole")
			/ "spread wide, steadily leaking the sheut's load."
			/ Paragraph / "He stands there for a moment"
			/ case locoplan b of
				Basic Slithering -> ", weighed down by your heavy coils, shifting as you slowly spill down -- a loop of your body across his shoulder falling down to his forearm, where he holds you for a moment before you slither further off him and eventually topple onto the ground with a soft" / em "smack" / "."
				Basic x
					| x `elem` [Centaur, Quadruped] -> c "before taking a staggering step back."
					| x `elem` [Biped, Naga] -> "before leaning down to grasp your arm and help pull you up from the riverbank,"
						/ case bodyMat_ Chest b of
							Solid (FMat _ Skin) -> c "your back slick with mud"
							Solid (FMat _ Scales) -> c "your back slick with mud"
							Solid (FMat _ Fur) -> c "your back grimy and sodden with huge clumps of mud stuck in your fur"
							Solid (FMat _ Coat) -> c "your back grimy, with clumps of mud stuck in your ruined coat"
							Solid (FMat _ Feathers) -> c "your back grimy, your feathers matted and tangled with clumps of mud"
							Solid (FMat _ Protoplasm) -> mempty
							_ -> mempty
						/ "."
				f -> bodyFail Fuck f
	]
	<> afterDialog b sobek

bipedNagaFuck :: MarkedScene Index () SobekSheut
bipedNagaFuck b sobek =
	[ Dialog "/static/img/icon.png" "Sobek Sheut" ["Give me your ass!"]
	, Narration2 $ "You're already reaching for his cock, and he closes the distance,"
		/ case bodytype sobek of
			Muscular -> "pressing his chest against yours"
			Fat -> "gut pressing against your stomach"
		/ case bodyMat_ Chest b of
			Solid (FMat _ Scales) -> ", his scales sliding smoothly against yours"
			Solid (FMat _ Skin) -> ", his scales scraping against your bare skin"
			Solid (FMat _ Fur) -> ", his scales combing through your shaggy fur"
			Solid (FMat _ Coat) -> ", his scales combing through your stiff coat"
			Solid (FMat _ Protoplasm) -> ", his scales biting into the wobbling protoplasm of your body"
			_ -> mempty
		/ ", and all but tosses you to the ground"
		/ hasLocotype Biped
			? (case footType b of
					x | x `elem` [Hooves, ClovenHooves] -> ". He wraps his hands around your narrow fetlocks and lifts your legs up" / case bodytype sobek of
							Muscular -> ", your hooves digging against his hard-muscled chest"
							Fat -> ", your ankles spanning across his weighty gut"
						/ "."
					Paws -> c ", wrapping his hands around your furry ankles and lifting your legs up to shove his fingers against the crack of your ass."
					Pseudopods -> "and grabs your legs, his grip making your rubbery protoplasm bulge out around his hands. He tugs your legs up" / case bodytype sobek of
							Muscular -> mempty
							Fat -> "over the weighty span of his gut"
						/ ", their nubby points resting noodle-like over his shoulders as he reaches down to dig into your asshole."
					-- Feet, Talons
					_ -> c ", lifting your legs up to shove his fingers against the crack of your ass.")
			?: (", hands dragging "
				/ case bodyMat_ (Waist Fore) b of
					Solid (FMat _ Scales) -> c "down your scaled sides"
					-- p. sure this is unreachable given that there's no animal w/ fur and a bodytail flag :V
					Solid (FMat _ Fur) -> c "down through shaggy cords of your fur"
					Trans (FMat _ t) (FMat _ b) -> "down your sides to where your" / matword t / "becomes" / matword b / ","
					_ -> c "down your sides"
				/ hasTail
					? "bodily dragging your tail into position as he grinds"
					?: "and grinding"
				/ "his thumb down"
				/ hasNagaCloaca
					? ("to your flushed" / sheath / case dickLocation b of
							Just _ -> ", the" / Tip^s / "of your" / Dick^s / "already peeking out"
							Nothing -> mempty
						/ ", bearing down to spread it open wider.")
					?: ("past your"
						/ case dickLocation b of
							Just DickExternal -> "half-hard" / Length^s
							Just DickSheathed -> "fat sheath, bloating as your" / Cock^s / " emerge"
							f -> bodyFail "fuck" f -- if you're a naga and you don't have a cloaca then you have to have one of the two dicktypes, so this should be unreachable
						/ "to bear down against the nearly-invisible divot of your asshole, between two slats of scale."))
		/ "He runs his claws up and down, digging minutely against your" / hasNagaCloaca ? "cloaca" ?: "asshole" / ". He jerks himself again, lubing his hand with" / case river sobek of
			Wet -> "stringy"
			Gloaming -> "dimly-glowing"
			Mutated -> "foul, fuming"
		/ "pre, and then shoves a finger"
		/ hasNagaCloaca ? "into your hole" ?: "up your ass"
		/ ", working another slimy finger in besides. His cock dribbles pre across your"
		/ hasNagaCloaca
			? ("underbelly"
					-- q: given that this scene is only for nagas/slithering, is there any possible way for this material to be anything other than scales or protoplasm, ever?
					-- a: uh yeah b/c anything can be fire/ice/bone/etc. but yes for now it can't be any of the "base" materials beyond those two
				/ case bodyMat_ Tail b of
					Solid (FMat _ Scales) -> ", streaming down your scales"
					Solid (FMat _ Protoplasm) -> ", soaking into your spongy protoplasm"
					_ -> mempty
				/ "; he catches the stream and feeds it back into your hole")
			?: ("taint, "
				/ hasExternalBalls
					? "streaming down across your balls and your crack alike"
					?: "streaming down along your crack")
		/ ", slicking his motions as he finger-fucks you"
		/ case river sobek of
			Mutated -> "; the chunky pre he's oozing burns as it soaks into your inner flesh"
			_ -> mempty
		/ "."
		/ hasDick ? ("His other hand"
			/ case bodyMat_ Legs b of
				Solid (FMat _ Fur) -> "smears through your pre-drenched fur up to your"
				Solid (FMat _ Coat) -> "smears through your pre-matted coat up to your"
				Solid (FMat _ Feathers) -> "cards through your sodden feathers up to your"
				Solid (FMat _ Skin) -> "smears through the slime up to your"
				Solid (FMat _ Scales) -> "smears through the slime up to your"
				Solid (FMat _ Protoplasm) -> "smears through the slime up to your"
				_ -> "smears through the slime up to your"
			/ hasExternalBalls ? "balls, cupping them for a moment and then moving up to your"
			/ case dickLocation b of
				Just DickExternal -> "shaft,"
				Just DickSheathed -> "unsheathed shaft,"
				Just _ -> "unsheathed shaft, toying with the flushed lips of your vent before"
				f -> bodyFail "fuck" f
			/ "wrapping his hand around your" / Cock^s / "and stroking.")
	]

centaurQuadFuck :: MarkedScene Index () SobekSheut
centaurQuadFuck b sobek =
	[ Dialog "/static/img/icon.png" "Sobek Sheut" ["Let me mount you!"]
	, Narration2 $ "You twist, flanks dragging against his belly and thighs, his hard cock a hot poker"
		/ case bodyMat_ Legs b of
			Solid (FMat _ Coat) -> "dragging down your body, leaving a wet smear across your coat"
			Solid (FMat _ Fur) -> "dragging through your thick fur, soaking it into clumps as he grinds his pre into your coat"
			Solid (FMat _ Skin) -> "dragging down your body, leaving shining smears of pre over your skin"
			Solid (FMat _ Scales) -> "sliding down your body, sheening your scales with his sloppy pre"
			Solid (FMat _ Protoplasm) -> "sliding down your body, distending your soft protoplasm from the pressure"
			_ -> "dragging down your body"
		/ ". He lines up, grinding his" / case river sobek of
			Mutated -> "pustulent"
			_ -> mempty
		/ "cock"
		/ case bodySpecies Legs b of
			--Just Horse -> "up between your fat horse cheeks,"
			Just Unicorn -> "up between your fat horse cheeks,"
			Just Wolf -> "against your hairy wolf cheeks,"
			Just Goat -> "against your hairy goat cheeks,"
			Just Bull -> "through the stiff, sparse coat covering your thick bull ass,"
			_ -> "up between your cheeks,"
		/ hasTail ? "using one hand to drag your tail out of the way as"
		/ "he ruts his cockhead against your clenching asshole. He jerks his cock, spreading a wet smear of pre"
		/ case bodySpecies Legs b of
			Just Human -> "over your asshole"
			Just _ -> "across your thick, puckering asshole"
			Nothing -> "over your asshole"
		/ ", and then his fingers dig inside, smearing pre along your inner flesh. One finger and then two shove into you, feeding his" / case river sobek of
			Wet -> "slimy"
			Gloaming -> "sloppy"
			Mutated -> "glowing and burning"
		/ "pre into you in"
		/ case river sobek of
			Mutated -> "chunky"
			Gloaming -> "thick"
			Wet -> "sloppy"
		/ "globs. He rasps, throat letting out a continual buzzing growl,"
		/ case bodyMat_ Back b of
			Solid (FMat _ Skin) -> "drool pattering across your back"
			Solid (FMat _ Scales) -> "drool pattering across your back"
			Solid (FMat _ Fur) -> "drool dribbling from his maw and slowly soaking your fur"
			Solid (FMat _ Coat) -> "drool dribbling from his maw and dripping through your stiff coat to wind down your back"
			_ -> "drool pattering across your back"
		/ "."
	]

afterDialog :: MarkedScene Index () SobekSheut
afterDialog b s =
	[ Narration ["He pants, catching his breath."]
	, Dialog "/static/img/icon.png" "Sobek Sheut"
		[ "Okay now we can talk, if you want to."
		]
	] <> actualTalk Fucked b s

actualTalk :: FuckState -> MarkedScene Index () SobekSheut
actualTalk fucked b s =
	[ Choices
		[ ("sure", TalkOptions fucked)
		, ("nah i think i'm good; bye", LeaveAfter)
		]
	]
