{-# LANGUAGE MultiParamTypeClasses #-}
module Sites.Hell.Events.Hubur.StandingStones
	( StandingStones(..)
	, deck
	, scene

	, name
	, bits
	, variants
	) where

import Prelude hiding ((/), (^))

import Sites.Hell.Events.SceneUtils hiding ((/))
-- import Sites.Hell.Events.Construction ((/))

import Sites.Hell.Events.Hubur

name :: String
name = "standing stones"

data StandingStones = StandingStones
	deriving (Eq, Ord, Show, Read)

instance Random StandingStones where
	randomR _ = random
	random = getRand $ pure StandingStones

instance ToJSON StandingStones where
	toJSON StandingStones = object
		[ pack "name" .= name
		, pack "data" .= ([] :: [Int])
		]

bits :: Value -> Value
bits _ = object
	[ pack "name" .= name
	, pack "data" .= ([] :: [Int])
	]

variants :: [(MapZone, ())]
variants =
	[ (Field, ())
	, (Glade, ())
	]

instance FromJSON StandingStones where
	parseJSON (Object vs) = case (parse (.: pack "name") vs, parse (.: pack "data") vs :: Result [Int]) of
			(Success pName, Success [])
				| pName == name -> return StandingStones
			_ -> mzero
	parseJSON _ = mzero

deck :: RandomGen g => Rand g (Enumerable StandingStones)
deck = return . pure $ StandingStones

data Index = Dummy
	deriving (Eq, Ord, Show, Read)

instance Scene Index () StandingStones where
	link f = case f of
		_ -> error "bad link"

	display = fmap toLower . show
	vardisplay = fmap toLower . show

scene :: Encounter Index () StandingStones
scene b z = describe b z -- <> error "bad scene"

--- actual event start

describe :: Encounter Index () StandingStones
describe _ z =
	[ Narration2 $ c "There's a cluster of ancient structures, made from demon iron and old plating. They're all different sizes, reaching up from the ground like the claws of a metal hand. They're arranged in a haphazard ring."
	]
