{-# LANGUAGE MultiParamTypeClasses #-}

module Sites.Hell.Events.Hubur.TarpitDemon
	( TarpitDemon(..)
	, TarAnimal (..)
	, deck
	, scene

	, name
	, bits
	, variants
	) where

import Prelude hiding ((/))

import Control.Applicative
import Control.Monad

import Server.JSON
import Sites.Hell.Events.Construction ((/))
import Sites.Hell.Events.SceneUtils

import Sites.Hell.Events.Hubur

{-
A path zig-zags up to the top of the quarry, and spills out into the mire beyond.

The throne of the factory chief '{}' is in the chemical mire of the tailings pit. The remnants of the mining process are dumped here and left to dissolve and comingle. It's a vast pit, filled with gritty, chunky tar, and the surface churns and ripples -- there's a horde of demons in the mire, coated in the filth, and their motions approximate waves, keeping the sludge rippling and sloshing in thick, heavy waves.





The factory chief is an immense four-armed boar-man, slathered in the same tailing slime as the rest of the tarpit demons. He's as big as a house. He's squat, body dominated by his massive massive taut gut, bulging out over his fat pecs. His fur, if he has any, is stuck to his skin, matted down by the layers of sludge coating him.

His crest of office hangs over his head: a wide circlet of burnt, chemical-etched metal, constantly drooling brilliant green-orange acid in slick rivulets down his body, reacting with the sludge coating his body, forming dense mats of orange-white foam clinging to his sides and wreathing him in fuming, acrid clouds.

His grimy, pusulent cock spills from a leathery sheath, and his hard shaft arcs up, digging into the underside of his gut. It's brutally fat, even compared to his general size, and its flesh is studded with boils, cockflesh lumpy and leathery. It's constantly drooling from the misshapen tip: pre thinning the tar coating his shaft into a murky, cloudy mess that slowly winds down his gnarled shaft, spilling back into his gaping sheath and squirting out when he walks: his massive thighs squeezing his sheath tighter, enough to make sloppy squirts of backed-up pre spew out into the mire before him. His sac fills the space between his legs, hanging down so far that his titanic balls come to rest on the ground, dragging behind him. His balls are lumpy, sac-flesh draped over their curving, oblong bulk, drawing taut when he steps, revealing every swollen, bloated lump of his oversized balls.

-}

name :: String
name = "tarpitdemon"

-- todo: randomize build too? mangy, bulky, fat, lean, meaty, etc
data TarpitDemon = TarpitDemon
	{ s1 :: TarAnimal
	, s2 :: TarAnimal
	}
	deriving (Eq, Ord, Show, Read)

data TarAnimal = TarBoar | TarRat | TarShark
	deriving (Eq, Ord, Enum, Bounded, Show, Read)

-- this would give you bad distributions
instance Random TarpitDemon where
	randomR _ = random
	random = getRand $ TarpitDemon
		<$> genRandom
		<*> genRandom

instance ToJSON TarpitDemon where
	toJSON (TarpitDemon s1 s2) = object
		[ pack "name" .= name
		, pack "data" .= [fromEnum s1, fromEnum s2]
		]

bits :: Value -> Value
bits _ = object
	[ pack "name" .= name
	, pack "data" .= [Null, Null]
	]

variants :: [(MapZone, ())]
variants =
	[ (FactoryTarpit, ())
	]

instance FromJSON TarpitDemon where
	parseJSON (Object vs) = case (parse (.: pack "name") vs, parse (.: pack "data") vs) of
			(Success pName, Success [s1, s2])
				| pName == name ->
					case TarpitDemon
						<$> safeToEnum s1
						<*> safeToEnum s2 of
							Nothing -> mzero
							Just a -> return a
			_ -> mzero
	parseJSON _ = mzero

-- this is considerably more complex than the usual, since we have interdependent parts
deck :: RandomGen g => Rand g (Enumerable TarpitDemon)
deck = do
	cs <- liftRand $ shuffle
		[ (TarpitDemon TarBoar, [TarRat, TarShark])
		, (TarpitDemon TarRat, [TarBoar, TarShark])
		, (TarpitDemon TarShark, [TarRat, TarBoar])
		]
	foldM (\enum (c, ls) -> liftA2 (<|>) (pickOpts c ls) (pure enum)) empty cs
	where
		pickOpts :: RandomGen g => (TarAnimal -> TarpitDemon) -> [TarAnimal] -> Rand g (Enumerable TarpitDemon)
		pickOpts c ls = do
			specOpts <- liftRand $ shuffle ls
			return $ c <$> from specOpts

data Index = Dummy
	deriving (Eq, Ord, Show, Read)

instance Scene Index () TarpitDemon where
	link f = case f of
		_ -> error "dummy index"

	display = fmap toLower . show
	vardisplay = fmap toLower . show

scene :: Encounter Index () TarpitDemon
scene _ c =
	[ description c
	-- , error "bad scene"
	]

description :: TarpitDemon -> Event TarpitDemon Index ()
description c =
	Narration2 $
		"Demons crawl up from the tailing sludge. They're so slathered with tar and grit it's hard to make out their shape, or if they're not just formed entirely from sludge."
		/ Paragraph / "They have a shape beneath, though: this one is a"
		/ case s1 c of
			TarRat -> "mangy rat"
			TarBoar -> "burly boar"
			TarShark -> "lean shark"
		/ "-"
		/ case s2 c of
			TarRat -> "rat"
			TarBoar -> "boar"
			TarShark -> "shark"
		/ "demon, with"
		/ case s2 c of
			TarRat -> "his fur matted with filth"
			TarBoar -> "his coat matted with filth"
			TarShark -> "his rasping hide slathered in filth"
		/ "and"
		/ case s1 c of
			TarRat -> "his wormlike, curling rat-tail cutting lines through the inky murk"
			TarBoar -> "his tufted boar-tail sunk into the inky murk"
			TarShark -> "his broad finned tail weighed down with inky murk"
		/ "."
		/ case s1 c of
			TarShark -> "He has the fins of a shark, crested down the back of his head, and another in the middle of his back;"
			TarRat -> "He has the head of a feral, diseased rat, with bloodshot, frenzied eyes and yellow teeth;"
			TarBoar -> "He has a stubby boar's head, with two oversized, broken tusks jutting out the sides of a squat muzzle;"
		/ "and" / case s2 c of
			TarShark -> "heaving gills down his sides, thickly-rumpled frills that flutter and thump as they strain to filter out the ooze he's immersed in;"
			TarRat -> "the squat, heavy haunches of a rat;"
			TarBoar -> "thick, powerful haunches that end in squat, splintered hooves;"
		/ "with" / case s1 c of
			TarShark -> "a long, swept-back shark tail dragging through the murk behind him"
			TarRat -> "a wormy rat-tail, knotted over itself in kinked snarls"
			TarBoar -> "a lashing boar-tail, with a sodden tuft of fur at the tip"
		/ "."

