{-# LANGUAGE MultiParamTypeClasses #-}

module Sites.Hell.Events.Hubur.Unicorn
	( Unicorn(..)
	, Index
	, describe

	, deck
	, scene

	, name
	, bits
	, variants
	) where

import Prelude hiding ((/))

-- import Sites.Hell.Events.Construction ((/))
import Sites.Hell.Events.SceneUtils

import Sites.Hell.Events.Hubur

name :: String
name = "unicorn"

data Unicorn = Unicorn
	deriving (Eq, Ord, Show, Read)

instance Random Unicorn where
	randomR _ = random
	random = getRand $ pure Unicorn

instance ToJSON Unicorn where
	toJSON Unicorn = object
		[ pack "name" .= name
		, pack "data" .= ([] :: [Int])
		]

bits :: Value -> Value
bits _ = object
	[ pack "name" .= name
	, pack "data" .= ([] :: [Int])
	]

variants :: [(MapZone, ())]
variants =
	[ (Glade, ())
	]

instance FromJSON Unicorn where
	parseJSON (Object vs) = case (parse (.: pack "name") vs, parse (.: pack "data") vs :: Result [Int]) of
			(Success pName, Success [])
				| pName == name ->
					case pure Unicorn of
							Nothing -> mzero
							Just a -> return a
			_ -> mzero
	parseJSON _ = mzero

deck :: RandomGen g => Rand g (Enumerable Unicorn)
deck = return $ pure $ Unicorn

data Index = Dummy
	deriving (Eq, Ord, Show, Read)

instance Scene Index () Unicorn where
	link f = case f of
		_ -> error "dummy index"

	display = fmap toLower . show
	vardisplay = fmap toLower . show

scene :: Encounter Index () Unicorn
scene _ u =
	[ Narration2 $ c "A unicorn is grazing in the glade."
	] <> description u

describe :: Unicorn -> [Event Unicorn Index ()]
describe = description

description :: Unicorn -> [Event Unicorn Index ()]
description u =
	[ Narration2 $ c "Its coat is a shining white, with silvery dapples across its haunches. Its hooves and teeth are both silvery as well. Its horn is made from translucent crystal, twisted like a conch shell, and glows faintly. There's a rippling hum that follows it wherever it goes."
	]
