{-# LANGUAGE MultiParamTypeClasses #-}

module Sites.Hell.Events.Hubur.WillOWisp
	( WillOWisp(..)
	, deck
	, scene

	, name
	, bits
	, variants
	) where

import Prelude hiding ((/))

import Sites.Hell.Events.Construction ((/))
import Sites.Hell.Events.SceneUtils

import Sites.Hell.Events.Hubur

name :: String
name = "willowisp"

data WillOWisp = WillOWisp
	deriving (Eq, Ord, Show, Read)

instance Random WillOWisp where
	randomR _ = random
	random = getRand $ pure WillOWisp

instance ToJSON WillOWisp where
	toJSON WillOWisp = object
		[ pack "name" .= name
		, pack "data" .= ([] :: [Int])
		]

bits :: Value -> Value
bits _ = object
	[ pack "name" .= name
	, pack "data" .= ([] :: [Int])
	]

variants :: [(MapZone, ())]
variants =
	[ (SwampZombie, ())
	, (SwampSobek, ())
	]

instance FromJSON WillOWisp where
	parseJSON (Object vs) = case (parse (.: pack "name") vs, parse (.: pack "data") vs :: Result [Int]) of
			(Success pName, Success [])
				| pName == name ->
					case pure WillOWisp of
							Nothing -> mzero
							Just a -> return a
			_ -> mzero
	parseJSON _ = mzero

deck :: RandomGen g => Rand g (Enumerable WillOWisp)
deck = return $ pure $ WillOWisp

data Index = Dummy
	deriving (Eq, Ord, Show, Read)

instance Scene Index () WillOWisp where
	link f = case f of
		_ -> error "dummy index"

	display = fmap toLower . show
	vardisplay = fmap toLower . show

scene :: Encounter Index () WillOWisp
scene _ c =
	[ description c
	-- , error "bad scene"
	]

description :: WillOWisp -> Event WillOWisp Index ()
description w = Narration2 $
	"An ethereal demon. Its body is hazy, shrouded in a constant layer of scintillating gas -- rainbow colored as it spills up its form, drawing out into flamelike points at its shoulders, or on the tips of its horns."
	/ Paragraph / "It's got a humanoid upper body; at the waist it fans apart into dozens of fat, churning tentacles. Its entire body is covered in thick, rubbery skin, with a gasoline-like sheen to the flesh."
	/ Paragraph / "Its upper body, though humanoid, is very inhuman: it has three eyes in its face, no nose, and no mouth. It has two horns, sweeping upward in dramatic points, but they're shaped like octopus tentacles, complete with fat pulsating suckers. Its arms are more like tentacles: too-long for its body, branching at erratic, asymmetrical intervals down their length, each split braided into the main mass until its 'hands' are simply the disparate tentacle-tips all fanning out."
	/ Paragraph / "The haze seems to seep out of its rubbery skin, billowing up its body in ripples and folds. Until you get close, it has the overall appearance of being a colorless, rippling flame."
