{-# LANGUAGE FlexibleContexts #-}
{-# LANGUAGE MultiParamTypeClasses #-}

module Sites.Hell.Events.SceneUtils
	( module Scene
	, module Instances
	, module Utility
	, module Body
	, module Construction
	, Encounter(..)
	, Deck(..)
	, em
	, open
	, (//)

	, s
	, sOn
	, Word(..)
	, Verb(..)
	, p
	, (?)
	, (?:)

	, (&*&)
	, (|*|)
	) where

import Prelude hiding ((/), Word(..))

-- stuff needed to make Random/ToJSON/FromJSON type instances
import Sites.Hell.Events.GameEvent as Instances (Random(..), getRand, runRand, liftRand, genRandom, safeToEnum)
import Server.JSON as Instances (ToJSON(..), FromJSON(..), (.:), (.=), parse, object, Value(Object), Result(..))

import Control.Applicative
import Control.Monad as Instances (mzero)
import Data.Text as Instances (pack)
import Data.Char as Instances (toLower)
import Utility.Rand as Instances (Rand, RandomGen)
import Utility.Rotate as Instances (shuffle)

-- misc functions i end up using a lot
import Data.Monoid as Utility ((<>))
import Utility.Monoid as Utility (guardC)

-- the actual event guts
import Data.Convertible as Scene
import Data.Enumerable as Scene
import Sites.Hell.Events.GameEvent as Scene (Scene(..), EventReel, c, MarkedScene, nBranch, GlobalFlag(..), bodyFail, EncGlob(..), Mental(..), body, mind, mental, EncounterEncoding(..), withData, withSubdata, extractRaws, triMap)
import Sites.Hell.Events.GameEvent as Scene
	( Event(..), Revise(..), Cond(..), Op(..), Val(..), include, Scope(..), SetMod(..), Modify(..)
	, Alchemy(..), Item(..), IIndex(..), Opponent(..), Stats(..), AI(..), ChallengeAction(..), NodeAction(..))
import Description.Construction as Scene (Punctuation(..))

import qualified Sites.Hell.Events.GameEvent as GE (em)
import Data.String (IsString(..))

-- event helper functions
import Sites.Hell.Events.GameEvent as Construction (side, sides, hind, foot, feet, muzzle, teeth, ankles, cloaca, unsheathed, unsheathing, partAdjective, hands, hand, fingers, finger, thumb, fingertips, fingernail, groan, groans, groaning, growl, bellow, sheath, hips, forelegs, number)

-- body data
import Description.Body.Types as Body (LocomotionPlan(..), LocomotionStrange(..), Locomotion(..), DickAttr(..), ClimaxAttr(..))
import Description.Body.Types.Material as Body (BodyLocation(..), BodyTransLocation(..), Hind(..), BodyCovering(..), FullMat(..), Material(..), matword)
import Description.Body.Sample as Body (locoplan, dickLocation, DickLocation(..), hasAsshole, hasArms, hasMouth, hasDick, hasNagaCloaca, hasCloaca, cockCount, firstOf, dickAttrs, climaxAttrs, HeightVal(..), bodyHeight, armCountMatching, armCount, MiscPart(..), hasExternalBalls, hasTail, hasFlare, FrontGenitalia(..), frontGenitalia, dickPlacement, mouthType, MouthType(..), hasKnot, manyCocks, bodySpecies, animalName, bodyMat_, hasLocotype, hasMedial, hasBarbs, hasBaculum, hasBalls, ridgedCockhead, HandType(..), handType, bodyCount, hasHead, hasProstate, oneCock, animalFootType, footType, FootType(..), hasHorns, BallLocation(..), getBalls, hasTopEars, Gender(..), gender, hasLegs, hasDickType, bodyCovering, bodyMat__, cocksizeR, cocksizeO, DickSizeR(..), DickSizeO(..), cumtype)

-- stuff used to make functions this file provides work
import Data.Accum (getAccum)
-- import Description.Body.Sample (cockCount)
-- import Description.Dictionary (inflect, Inflection(Plural))
import Description.Build as Scene (BodyGlob)
import Description.TfNode (Sex(..))
import Description.TfNode as Body (Sex (Cock, Knot))
import Sites.Hell.Events.GameEvent (ProseItem(Raw), Markup)

type Encounter i vars mob = BodyGlob -> mob -> [Event mob i vars]

type Deck g a = Rand g (Enumerable a)

em :: String -> Markup ProseItem
em = GE.em . fromString

open :: Convertible a EventReel => a -> EventReel
open v = mempty // v

infixl 1 //
(//) :: Convertible a EventReel => EventReel -> a -> EventReel
ev // n = ev >> c n

{-
class BodyQuality a where
	bodyTest :: BodyGlob -> a -> Bool

(~>) :: BodyQuality a => [a] -> EventReel -> EventReel
qs ~> a = \b -> if or $ bodyTest <$> qs
	then a
	else mempty

instance BodyQuality Locomotion where
	bodyTest b l = locoplan b == Basic l

instance BodyQuality LocomotionPlan where
	bodyTest b l = locoplan b == l

-- actually this is bad and annoying to use, w/ no real benefit over cases and several drawbacks
(~>) :: [LocomotionPlan] -> EventReel -> EventReel
ls ~> a = (c :: (BodyGlob -> EventReel) -> EventReel) $ \b -> if locoplan b `elem` ls
	then a
	else mempty

-}

infixl 6 /
(/) :: a -> (a -> b -> String) -> b -> [ProseItem] -- a -> (a -> b -> String) -> b -> [ProseItem]
(/) a f b = [Raw $ pack $ f a b]

{-
"cock"/s == s "cock" {body}
"arcs"/p "arc" == p "arc" "arcs" {body}
-}

s :: (Inflected Plural a, Show a) => a -> BodyGlob -> String -- String -> BodyGlob -> String
s t b = if cockCount b == 1 then base t else pluralize t

-- we don't actually need to use the `BodyGlob` at all here, but the type of ^ expects it so it's easier to just have a pointless dangling arg
sOn :: (Inflected Plural a, Show a, Num b, Eq b) => b -> a -> BodyGlob -> String
sOn n t _ = if n == 1 then base t else pluralize t

pluralize :: Inflected Plural a => a -> String
pluralize t = case inflect t Plural of
	Right ts -> ts
	Left e -> error $ e

data Plural = Plural

class Inflected p a where
	inflect :: a -> p -> Either String String

base :: Show a => a -> String
base a = toLower <$> show a

data Word = {-Cock |-} Dick | Tip | Length {-| Shaft | Knot | Cockhead-} | Cocktip | Streamer | Ring | Flare | Underside
	deriving (Eq, Show, Read)

data Verb = Burns | Starts | Slaps | Smears | Slides | Unsheathes | Pushes
	| Drags | Scrapes | Grows | Spills | Shoves | Thrums | Softens | Pulls
	| Shudders | Stirs | Arcs | Grinds | Cannonades | Throbs | Finds | Swells
	| Jerks | Snaps | Comes | Flares | Twitches | Hangs | Pierces | Leaks
	| Spits | Bears | Crests | Lolls | Bulges | Fattens | Pulses | Digs
	| Jars | Presses | Does
	deriving (Eq, Show, Read)

instance Inflected Plural Word where
	inflect w _ = Right $ case w of
		-- Cock -> "cocks"
		Dick -> "dicks"
		Tip -> "tips"
		Length -> "lengths"
		-- Shaft -> "shafts"
		-- Knot -> "knots"
		-- Cockhead -> "cockheads"
		Cocktip -> "cocktips"
		Streamer -> "streamers"
		Ring -> "rings"
		Flare -> "flares"
		Underside -> "undersides"

instance Inflected Plural Verb where
	inflect w _ = Right $ case w of
		Burns -> "burn"
		Starts -> "start"
		Slaps -> "slap"
		Smears -> "smear"
		Slides -> "slide"
		Unsheathes -> "unsheath"
		Pushes -> "push"
		Drags -> "drag"
		Scrapes -> "scrape"
		Grows -> "grow"
		Spills -> "spill"
		Shoves -> "shove"
		Thrums -> "thrum"
		Softens -> "soften"
		Pulls -> "pull"
		Shudders -> "shudder"
		Stirs -> "stir"
		Arcs -> "arc"
		Grinds -> "grind"
		Cannonades -> "cannonade"
		Throbs -> "throb"
		Finds -> "find"
		Swells -> "swell"
		Jerks -> "jerk"
		Snaps -> "snap"
		Comes -> "come"
		Flares -> "flare"
		Twitches -> "twitch"
		Hangs -> "hang"
		Pierces -> "pierce"
		Leaks -> "leak"
		Spits -> "spit"
		Bears -> "bear"
		Crests -> "crest"
		Lolls -> "loll"
		Bulges -> "bulge"
		Fattens -> "fatten"
		Pulses -> "pulse"
		Digs -> "dig"
		Jars -> "jar"
		Presses -> "press"
		Does -> "do"

instance Inflected Plural MiscPart where
	inflect w _ = case w of
		Shaft -> Right "shafts"
		Cockhead -> Right "cockheads"
		x -> Left $ unwords $ [base x, "not a good plural MiscPart"]
		{- data MiscPart = Underbelly | Belly | Shaft | Cockhead | Thighs | Sheath | Ass | Teeth -}

instance Inflected Plural Sex where
	inflect w _ = Right $ case w of
		Description.TfNode.Mouth -> "mouths"
		Tongue -> "tongues"
		Breasts -> "breasts"
		Cock -> "cocks"
		Knot -> "knots"
		Balls -> "balls"
		Flower -> "flowers"

p :: String -> String -> BodyGlob -> String
p plur_ sing b = if cockCount b == 1 then sing else plur_

(?) :: Convertible a EventReel => (BodyGlob -> Bool) -> a -> BodyGlob -> [ProseItem]
(?) f t b = if f b then getAccum (c t) else []

(?:) :: Convertible a EventReel => (BodyGlob -> [ProseItem]) -> a -> BodyGlob -> [ProseItem]
(?:) prev other b = case prev b of
	[] -> getAccum (c other)
	x -> x

-- for combining (BodyGlob -> Bool) functions, mostly
(&*&) :: Applicative f => f Bool -> f Bool -> f Bool
(&*&) = liftA2 (&&)

(|*|) :: Applicative f => f Bool -> f Bool -> f Bool
(|*|) = liftA2 (||)
