{-# LANGUAGE OverloadedStrings #-}

module Sites.Hell.Site
	( site
	) where

-- happstack!
import Happstack.Server
import Server.Error

-- web-routes, web-routes-happstack, & web-routes-boomerang
import Web.Routes (runRouteT, setDefault)
import Web.Routes.Happstack (implSite)
import Web.Routes.Boomerang (boomerangSite)

-- misc
import Control.Monad (msum)
import Data.String (IsString(fromString))

import qualified Sites.Hell.Sitemap as Hell (sitemap, SiteRoute(..))
import qualified Sites.Hell.Routes as Hell (route)

site :: String -> String -> Int -> String -> HellServer Response
site base host port basePath = msum
	[ implSite (fromString siteString) (fromString basePath)
		$ setDefault (Hell.Splash Nothing) $ boomerangSite (runRouteT $ Hell.route base) Hell.sitemap
	]
	where
		siteString = if port == 80
			then concat ["http://", host]
			else concat ["http://", host, ":", show port]
