{-# LANGUAGE DeriveDataTypeable, TypeOperators, TemplateHaskell, OverloadedStrings #-}

module Sites.Hell.Sitemap
	( SiteRoute(..)
	, sitemap
	) where

import Prelude hiding ((.))

import Control.Category ((.))
import Data.Data (Typeable)

-- web-routes-boomerang & boomerang
import Web.Routes.Boomerang (Router, (</>), lit, (:-))
import Text.Boomerang.TH (makeBoomerangs)
import Text.Boomerang.Combinators (rMaybe)
import Text.Boomerang.Texts (int)

data SiteRoute
	= Splash (Maybe Int) | NewsFeed | Info | Todo | Goal
	| NewsPost Int
	{- | DBCheck -} | AdminNewsPost
	| Game
	| PopulationGenerator
	| EventParser
	| Description | DescriptionTest
	deriving (Eq, Ord, Typeable)

$(makeBoomerangs ''SiteRoute)

sitemap :: Router () (SiteRoute :- ())
sitemap = mconcat
	[ rSplash . rMaybe int
	, rNewsPost . lit "post" </> int
	-- , rDBCheck . lit "admin" </> lit "db-check"
	, rAdminNewsPost . lit "admin" </> lit "newspost"
	, rNewsFeed . lit "rss"
	, rGame . lit "game"
	, rInfo . lit "info"
	, rTodo . lit "todo"
	, rGoal . lit "goal"
	, rPopulationGenerator . lit "pop"
	, rEventParser . lit "event"
	, lit "description" . (rDescription
		<> rDescriptionTest </> lit "edit")
	]
