module Utility.Tree
	( hitAny
	, hitNext
	, hitThis
	) where

import Data.Maybe (listToMaybe, mapMaybe)
import Data.Tree

hitAny, hitNext, hitThis :: (a -> Bool) -> Tree a -> Maybe (Tree a)
hitAny f t@(Node v chs) = if f v then Just t else listToMaybe $ mapMaybe (hitAny f) $ chs

hitNext f (Node _ chs) = listToMaybe $ mapMaybe (hitThis f) $ chs

hitThis f t@(Node v _) = if f v then Just t else Nothing
