"use strict";

function setMeter (id, to) {
	var
		meter = document.querySelector ('#' + id + ' meter'),
		label = document.querySelector ('#' + id + ' .cur'),
		realAmount, visibleChange;
	realAmount =
		to < meter.min ? meter.min :
		to > meter.max ? meter.max :
			to;
	visibleChange = Math.abs ((realAmount - meter.value) / meter.max);
	$(meter).animate ({value: realAmount}, 1600 * visibleChange);
	$(label).text (realAmount|0);
}
function alterMeter (id, amount) {
	var
		meter = document.querySelector ('#' + id + ' meter');
	setMeter (id, meter.value + amount);
}
function setMaxMeter (id, to) {
	var
		meter = document.querySelector ('#' + id + ' meter'),
		label = document.querySelector ('#' + id + ' .max'),
		visibleChange;
	visibleChange = Math.abs ((to - meter.max) / meter.max);
	$(meter).animate ({max: to}, 3200 * visibleChange);
	$(label).text (to|0);
}
function alterMax (id, amount) {
	var
		meter = document.querySelector ('#' + id + ' meter'),
		realAmount;
	realAmount = meter.max + amount;
	setMaxMeter (id, realAmount);
}
function meter (id, min, max, amount) {
	var
		container = document.createElement ("div"),
		legend = document.createElement ("div"),
		meterelement = document.createElement ("meter"),
		infocur = document.createElement ("span"),
		infomax = document.createElement ("span");
	container.id = id;
	container.classList.add ("meter");
	legend.classList.add ("legend");
	legend.appendChild (document.createTextNode (id));
	meterelement.min = min;
	meterelement.max = max;
	meterelement.value = amount;
	infocur.classList.add ("cur");
	infocur.appendChild (document.createTextNode (amount));
	infomax.classList.add ("max");
	infomax.appendChild (document.createTextNode (max));
	container.appendChild (legend);
	container.appendChild (document.createTextNode (" "));
	container.appendChild (meterelement);
	container.appendChild (document.createTextNode (" "));
	container.appendChild (infocur);
	container.appendChild (infomax);
	return container;
}

function forecast (id, amount) {
	var
		meter = document.querySelector ('#' + id + ' meter'),
		realAmount,
		visibleChange;
	realAmount = meter.value + amount;
	realAmount =
		realAmount < meter.min ? meter.min :
		realAmount > meter.max ? meter.max :
			realAmount;
	console.log (meter.style.width);
	visibleChange = (realAmount - meter.value) / meter.max * meter.style.width;
	// set a data-realValue attribute; change the value; change the background so it's a gradient from the right, with the first `visibleChange` pixels being the highlight color. then reverse all that on unhover.
}
