
	function weighedPainter (weights) {
		var total = weights
			.map (function (w) { return w.w; })
			.reduce (function (a, b) { return a + b});
		return function (pt) {
			var r = randomInRange (0, total);
			var i = 0;
			var acc = 0;
			while (i < weights.length) {
				if (acc > r) {
					return weights[i-1].v;
				}
				acc += weights[i].w;
				i++;
			}
			return weights[weights.length-1].v;
		}
	}
	function randomPainter (tiles) {
		return function (pt) {
				return randomFrom (tiles);
			};
	};
	function onSidePainter (side, sides, flats) {
		function onEdge (side, pt, rect) {
			var sides = rect.edgeLabels (pt);
			return (sides.find (v => v == side));
		}
		return function (pt, rect) {
				if (onEdge (side, pt, rect)) {
					return Array.isArray (sides) ? randomFrom (sides) : sides;
				} else {
					return Array.isArray (flats) ? randomFrom (flats) : flats;
				}
			};
	}
	function staticPainter (tile) {
		return function (pt) {
				return tile;
			};
	};

	function borderPainter (border, in_) {
		return function (pt, rect) {
			return rect.onEdge (pt) ? border : in_;
		}
	}

	function tilePainter (tilePaint, heightPaint, decorPaint) {
		function nullPainter (_a, _b) { return null; }
		function realHeightPaint (pt, rect) {
			var h = heightPaint (pt, rect);
			if (h instanceof Height) {
				return h;
			} else {
				return new Height ("flat", h);
			}
		}
		if (decorPaint === undefined) {
			decorPaint = nullPainter;
		}
		return function (pt, rect) {
			return new Tile (realHeightPaint (pt, rect), tilePaint (pt, rect), null, decorPaint (pt, rect));
		}
	}
