
var random = null;

function initRandom () {
	console.error ("random func called without seeding! (using Math.random fallback)");
	random = { next: function () {
			return Math.random();
		}
	};
}
function setRandom (r) {
	random = r;
}

function randomFrom (vs) {
	if (!random) {
		initRandom();
	}
	return vs[Math.floor(random.next() * vs.length)];
}

function randomShuffle (array) {
	var i;
	var j;
	var temp;
	for (i = array.length - 1; i > 0; i--) {
		j = randomIntInRange (0, i + 1);
		temp = array[i];
		array[i] = array[j];
		array[j] = temp;
	}
	return array;
}

function randomIntInRange (lo, hi) {
	var r = hi - lo;
	if (r < 0) {
		throw new Error ("randomIntInRange: bad range (" + lo + "," + hi + ")");
	}
	if (!random) {
		initRandom();
	}
	return Math.floor (random.next() * r) + lo;
}
function randomInRange (lo, hi) {
	var r = hi - lo;
	if (r < 0) {
		throw new Error ("randomInRange: bad range (" + lo + "," + hi + ")");
	}
	if (!random) {
		initRandom();
	}
	return random.next() * r + lo;
}
