
function StoredDraw (image, offset, size, placement, drawSize) {
	this.image = image;
	this.offset = offset;
	this.size = size;
	this.placement = placement;
	this.drawSize = drawSize;
}
StoredDraw.prototype =
	{ draw: function (context, offset) {
			try {
				// this sometimes errors and i don't really know why (but also i haven't tried looking up the error code)
				context.drawImage (this.image, this.offset.x, this.offset.y, this.size.x, this.size.y, this.placement.x + (offset ? offset.x : 0), this.placement.y + (offset ? offset.y : 0), this.drawSize.x, this.drawSize.y);
			} catch (e) {
				//console.log (e);
				//console.log (this.image);
				//console.log (this.offset);
				throw e;
			}
		}
	, replaceSprite: function (offset) {
			this.offset = offset;
		}
	, reposition: function (placement) {
			this.placement.x = placement.x;
			this.placement.y = placement.y;
		}
	};

function Spritesheet (image, size, sprites) {
	var this_ = this;
	this.image = image;
	this.size = size;
	this.sprites = sprites.map (function (s) {
		return { name: s.name
			, dim: new Point2d (s.dim.x * this_.size.x, s.dim.y * this_.size.y)
			} ;
	});
}
Spritesheet.prototype =
	{ get: function (n) {
			var r;
			if (typeof n == "number") {
				return this.sprites[n];
			}

			r = find (this.sprites, function (m) {
				return m.name == n;
			});
			if (r === undefined) {
				console.error ("no such sprite \"" + n + "\" in spritesheet!");
			}
			return r;
		}
	, exists: function (n) {
			var r = find (this.sprites, function (m) {
				return m.name === n;
			});
			return r !== undefined;
		}
	};
